
// ******************************************************************
// Copyright (c) 2003- Satoshi, All Rights Reserved.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// Author : Satoshi ( af230533@yahoo.co.jp )
// ******************************************************************

#include "zeditor.h"
#include "filedialog.h"

#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qaction.h>
#include <qpopupmenu.h>
#include <qpe/qpemenubar.h>
#include <qmessagebox.h>

#include <qdir.h>
#include <qfile.h>
//#include <qfileinfolist.h>
#include <qfileinfo.h>
//#include <qfileinfolistiterator.h>
#include <qpe/resource.h>

#include <qtextcodec.h>	// v1.0.0
#include <qaccel.h>		// 2003.04
#include <qlabel.h>

#include <stdio.h>		// v1.2.9
#include <dirent.h>		// v1.2.9
//#include <sys/types.h>
//#include <qmessagebox.h>



FileDialog::FileDialog( QWidget* parent,  const char* name, bool modal, WFlags fl)
{
	FileDialog( parent, name, modal, fl, TRUE );
}


FileDialog::FileDialog( QWidget* parent,  const char* name, bool modal, WFlags fl , int load, bool is_small )
    : QDialog( parent, name, modal, fl )
{
	QTextCodec	*codec;

	this_parent = parent;
	LOAD = load;
	codec = QTextCodec::codecForName( "eucJP" );

	// ---------------------------------- v1.3.0 menu
	if( load == DIALOG_FILER )
	{
		popFile = new QPopupMenu( this );

		popFile->insertItem( codec->toUnicode( "̎پ(&I)" ), this , SLOT( fileInformation() ), Key_I + CTRL );
//		popFile->insertItem( codec->toUnicode( "̎°(&A)" ), this , SLOT( fileAttribute() ),  );
		popFile->insertItem( codec->toUnicode( "̎̾ѹ(&N)" ), this , SLOT( fileRename() ), Key_N + CTRL );
		popFile->insertItem( codec->toUnicode( "̎٥ԡ(&C)" ), this , SLOT( fileCopy() ), Key_C + CTRL );
		popFile->insertItem( codec->toUnicode( "ٰ̎ư(&M)" ), this , SLOT( fileMove() ), Key_M + CTRL );

		popFile->insertSeparator();

		popFile->insertItem( codec->toUnicode( "̎ٺ(&D)" ), this , SLOT( fileDelete() ), Key_D + CTRL );

		popFile->insertSeparator();

		popFile->insertItem( codec->toUnicode( "ÎގڎĎغ(&K)" ), this , SLOT( makeDirectory() ), Key_K + CTRL );

		popFile->insertSeparator();

		popFile->insertItem( codec->toUnicode( "إ(&H)" ), this , SLOT( help_menu() ), 0 );

		menu_bar = new QPEMenuBar( this );
		menu_bar->insertItem( codec->toUnicode( "ե" ), popFile );
	}

	// ---------------------------------- frame size
	p_xx = parent->width();
	p_yy = parent->height();
	if( load >= DIALOG_TOCP )
	{
		xx = p_xx - 30;
		yy = p_yy - 40;
	}
	else	// Dilog open, save, filer
	{
		if ( p_xx < 408 )			// 240 x 320
		{
			c700 = false;
			xx = 214;
		}
		else
		{
			c700 = true;
			if ( p_xx < 500 )		// 480 x 640	--> 400
				xx = ( p_xx * 5 ) / 6;
			else				// 640 x 480		--> 400
				xx = ( p_xx * 5 ) / 8;
		}
//		if ( p_yy < 250 )
//			yy = 195;
//		else
//			yy = ( p_yy * 7 )/ 8 + 20;
		// -------------------------------- v2.0.3
		if ( p_xx > p_yy )
			yy = ( p_yy * 7 )/ 8;
		else
			if (( load == DIALOG_SAVE ) && ( is_small ))
				yy = p_yy / 2 - 25;
			else
				yy = ( p_yy * 4 )/ 5;
	}

	// ----------------------------------- v1.0.0 change Y size when save
//	if( load == DIALOG_SAVE )
//		yy -= 20;

	int		pb_size;
	ListBox1 = new QListBox( this );
	PushButton1 = new QPushButton( this, "PushButton1" );
	PushButton1->setGeometry( QRect( 5, yy - 26, 64, 26 ) );

	QPalette	p;
	switch( load )
	{
		case DIALOG_OPEN :
					ListBox1->setGeometry( QRect( 5, 22, xx - 11, yy - 75 ) );
					LineEdit1 = new QLineEdit( this );
					LineEdit1->setGeometry( QRect( 5, yy - 54, xx - 11, 24 ) );

					setCaption( codec->toUnicode( "[  ] ե..." ) );
					PushButton1->setText( codec->toUnicode( "" ) );
					break;
		case DIALOG_SAVE :
					ListBox1->setGeometry( QRect( 5, 22, xx - 11, yy - 75 ) );
					LineEdit1 = new QLineEdit( this );
					LineEdit1->setGeometry( QRect( 5, yy - 55, xx - 107, 24 ) );

					PushButton2_4 = new QPushButton( this, "PushButton2_4" );
					PushButton2_4->setGeometry( QRect( xx - 105, yy - 54, 50, 26 ) );
					PushButton2_4->setText( codec->toUnicode( "Top" ) );

					PushButton2_5 = new QPushButton( this, "PushButton2_4" );
					PushButton2_5->setGeometry( QRect( xx - 51, yy - 54, 40, 26 ) );
					PushButton2_5->setText( codec->toUnicode( "" ) );

					setCaption( codec->toUnicode( ">> ե¸ <<" ) );
					PushButton1->setText( codec->toUnicode( "¸" ) );
					break;
		case DIALOG_FILER :
					ListBox1->setGeometry( QRect( 5, 58, xx - 11, yy - 86 ) );

					p = ListBox1->palette();
					p.setColor( QColorGroup::Base, QColor( 180, 255, 180 ));
					ListBox1->setPalette( p );

					setCaption( codec->toUnicode( " ʰץե顼 " ) );
					PushButton1->setText( codec->toUnicode( "ϣ" ) );
					break;
		case DIALOG_TOCP :
					ListBox1->setGeometry( QRect( 5, 42, xx - 11, yy - 72 ) );
					p = ListBox1->palette();
					p.setColor( QColorGroup::Base, QColor( 180, 180, 255 ));
					ListBox1->setPalette( p );

					setCaption( codec->toUnicode( "ԡϡ" ) );
					PushButton1->setText( codec->toUnicode( "copy" ) );
					break;
		case DIALOG_TOMV :
					ListBox1->setGeometry( QRect( 5, 42, xx - 11, yy - 72 ) );
					p = ListBox1->palette();
					p.setColor( QColorGroup::Base, QColor( 255, 180, 255 ));
					ListBox1->setPalette( p );

					setCaption( codec->toUnicode( "ưϡ" ) );
					PushButton1->setText( codec->toUnicode( "ư" ) );
					break;
	}


	PushButton1_2 = new QPushButton( this, "PushButton1_2" );
	if( load < DIALOG_TOCP )
	{
		if ( c700 )
			pb_size = 64;
		else
			pb_size = 44;
	}
	else	// DIALOG_TOCP or DIALOG_TOMV
	{
		if ( ((FileDialog*)this_parent)->c700 )		// copy & move : parent is this!!!
		{
			pb_size = 64;
			c700 = true;
		}
		else
		{
			pb_size = 42;
			c700 = false;
		}
	}
	PushButton1_2->setGeometry( QRect( xx - pb_size - 4, yy - 26, pb_size, 26 ) );
	PushButton1_2->setText( codec->toUnicode( "ݎ" ) );



	// ------------------------------------------- 2003.01.19 append pushbutton
	PushButton2_1 = new QPushButton( this, "PushButton2_1" );
	PushButton2_2 = new QPushButton( this, "PushButton2_2" );
	PushButton2_3 = new QPushButton( this, "PushButton2_3" );
	PushButton2_6 = new QPushButton( this, "PushButton2_6" );		// v3.3.0
	if ( c700 )
	{
		PushButton2_1->setGeometry( QRect( 78, yy - 26, 48, 26 ) );
		PushButton2_1->setText( tr( "mnt" ) );
		PushButton2_2->setGeometry( QRect( 130, yy - 26, 58, 26 ) );
		PushButton2_2->setText( tr( "home" ) );
		PushButton2_3->setGeometry( QRect( 192, yy - 26, 58, 26 ) );
		PushButton2_3->setText( tr( "text" ) );
		PushButton2_6->setGeometry( QRect( 254, yy - 26, 58, 26 ) );
		PushButton2_6->setText( tr( "user" ) );
	}
	else
	{
		PushButton2_1->setGeometry( QRect( 58, yy - 26, 18, 26 ) );
		PushButton2_1->setText( tr( "m" ) );
		PushButton2_2->setGeometry( QRect( 78, yy - 26, 18, 26 ) );
		PushButton2_2->setText( tr( "h" ) );
		PushButton2_3->setGeometry( QRect( 98, yy - 26, 18, 26 ) );
		PushButton2_3->setText( tr( "t" ) );
		PushButton2_6->setGeometry( QRect( 118, yy - 26, 18, 26 ) );
		PushButton2_6->setText( tr( "u" ) );
	}


	// ------------------------------------------- 2003.01.19 append status bar
	if( load == DIALOG_FILER )
	{
		LineInfo = new QLineEdit( this );
		LineInfo->setGeometry( QRect( 5, 32, xx - 11, 24 ) );
		LineInfo->setReadOnly( true );
	}
	else
	{
		StBar = new QStatusBar( this );
		StBar->setGeometry( QRect( 0, 2, xx, 20 ) );

		if( load >= DIALOG_TOCP )
		{
			StBar2 = new QStatusBar( this );
			StBar2->setGeometry( QRect( 0, 22, xx, 20 ) );
		}
	}

	fdir.setFilter(  QDir::All );	//QDir::Files |
	fdir.setSorting( QDir::DirsFirst);

	connect( ListBox1 ,SIGNAL( clicked( QListBoxItem * )), this, SLOT( changeList()) );
	connect( ListBox1 ,SIGNAL( selected( int )), this, SLOT( changeList()) );
	connect( PushButton1 ,SIGNAL( clicked()), this, SLOT( fileSelected()) );
	connect( PushButton1_2 ,SIGNAL( clicked()), this, SLOT( hide()) );
	if( load < DIALOG_FILER )
		connect( LineEdit1 ,SIGNAL( returnPressed()), this, SLOT( fileSelected()));

	// --------------------------------------------- 2003.01.19 append pushbutton
	connect( PushButton2_1 ,SIGNAL(clicked()), this, SLOT( cd_mnt()) );
	connect( PushButton2_2 ,SIGNAL(clicked()), this, SLOT( cd_home()) );
	connect( PushButton2_3 ,SIGNAL(clicked()), this, SLOT( cd_text()) );
	connect( PushButton2_6 ,SIGNAL(clicked()), this, SLOT( cd_user()) );

	if( load == DIALOG_SAVE )
	{
		connect( PushButton2_4 ,SIGNAL(clicked()), this, SLOT( inputFileName()) );
		connect( PushButton2_5 ,SIGNAL(clicked()), this, SLOT( inputDateTime()) );
	}

	// ------------------------------------------ Accel delete line!!!  BS  qnamespace.h
	QAccel *cdup = new QAccel( this );
	cdup->connectItem( cdup->insertItem( Key_Backspace + CTRL ), this, SLOT( cd_up()) );
	cdup->connectItem( cdup->insertItem( Key_Backspace + SHIFT ), this, SLOT( cd_up()) );

	// ------------------------------------------ Accel Ctrl + R
	QAccel *cdroot = new QAccel( this );
	cdroot->connectItem( cdroot->insertItem( Key_R + CTRL ), this, SLOT( cd_root()) );
	// ------------------------------------------ Accel Ctrl + H
	QAccel *cdhome = new QAccel( this );
	cdhome->connectItem( cdhome->insertItem( Key_H + CTRL ), this, SLOT( cd_home()) );
	// ------------------------------------------ Accel Ctrl + M
//	QAccel *cdmnt = new QAccel( this );
//	cdmnt->connectItem( cdmnt->insertItem( Key_M + CTRL ), this, SLOT( cd_mnt()) );

	// ------------------------------------------ Accel Ctrl + Z
	QAccel *cdz = new QAccel( this );
	cdz->connectItem( cdz->insertItem( Key_Z + CTRL ), this, SLOT( cd_zaurus()) );

	// ------------------------------------------ Accel Ctrl + Q
	QAccel *cdqt = new QAccel( this );
	cdqt->connectItem( cdqt->insertItem( Key_Q + CTRL ), this, SLOT( cd_qt()) );

	// ------------------------------------------ Accel Ctrl + S
	QAccel *cdcard = new QAccel( this );
	cdcard->connectItem( cdcard->insertItem( Key_S + CTRL ), this, SLOT( cd_card()) );

	// ------------------------------------------ Accel Ctrl + F
	QAccel *cdcf = new QAccel( this );
	cdcf->connectItem( cdcf->insertItem( Key_F + CTRL ), this, SLOT( cd_cf()) );

	// ------------------------------------------ Accel Ctrl + T
	QAccel *cdtext = new QAccel( this );
	cdtext->connectItem( cdtext->insertItem( Key_T + CTRL ), this, SLOT( cd_text()) );

	// ------------------------------------------ Accel Ctrl + U
	QAccel *cd_user1 = new QAccel( this );
	cd_user1->connectItem( cd_user1->insertItem( Key_U + CTRL ), this, SLOT( cd_user_U()) );
	// ------------------------------------------ Accel Ctrl + J
	QAccel *cd_user2 = new QAccel( this );
	cd_user2->connectItem( cd_user2->insertItem( Key_J + CTRL ), this, SLOT( cd_user_J()) );

	if( load >= DIALOG_FILER )
		cdup->connectItem( cdup->insertItem( Key_Backspace ), this, SLOT( cd_up()) );


	if( load == DIALOG_SAVE )
	{
		// ------------------------------------------ Accel Ctrl + D, O
		QAccel *dt = new QAccel( this );
		dt->connectItem( dt->insertItem( Key_O + CTRL ), this, SLOT( inputFileName()) );
		dt->connectItem( dt->insertItem( Key_D + CTRL ), this, SLOT( inputDateTime()) );
	}
	else	// else for inputfield
	{
		cdroot->connectItem( cdroot->insertItem( Key_R + SHIFT ), this, SLOT( cd_root()) );
		cdhome->connectItem( cdhome->insertItem( Key_H + SHIFT ), this, SLOT( cd_home()) );
		cdz->connectItem( cdz->insertItem( Key_Z + SHIFT ), this, SLOT( cd_zaurus()) );
		cdqt->connectItem( cdqt->insertItem( Key_Q + SHIFT ), this, SLOT( cd_qt()) );
		cdcard->connectItem( cdcard->insertItem( Key_S + SHIFT ), this, SLOT( cd_card()) );
		cdcf->connectItem( cdcf->insertItem( Key_F + SHIFT ), this, SLOT( cd_cf()) );
		cdtext->connectItem( cdtext->insertItem( Key_T + SHIFT ), this, SLOT( cd_text()) );
		cd_user1->connectItem( cd_user1->insertItem( Key_U + SHIFT ), this, SLOT( cd_user_U()) );
		cd_user2->connectItem( cd_user2->insertItem( Key_J + SHIFT ), this, SLOT( cd_user_J()) );
	}


	setList( QString( "~/" ) );
	if( load == DIALOG_TOCP )
		StBar->message( *( ((FileDialog*)this_parent)->getSelectedFileName()) + "--> copy" );
	if( load == DIALOG_TOMV )
		StBar->message( *( ((FileDialog*)this_parent)->getSelectedFileName()) + "--> move" );
}


void FileDialog::accept()
{
	if( LOAD >= DIALOG_FILER )
		QDialog::accept();
	else
		if ( LineEdit1->text().length() > 0 )
			QDialog::accept();
}

void FileDialog::fileSelected()
{
	accept();
}



void FileDialog::cd_up()
{
	fdir.cdUp();
	QString myPath = fdir.absPath();
	setList( myPath );
}

void FileDialog::cd_root()
{
	setList( QString( "/" ) );
	ListBox1->setFocus();
}

void FileDialog::cd_mnt()
{
	if ( usr_mnt.length() == 0 )
		setList( QString( "/var/mnt" ) );
	else
		setList( usr_mnt );
}

void FileDialog::cd_card()
{
	setList( QString( "/var/mnt/card" ) );
}

void FileDialog::cd_cf()
{
	setList( QString( "/var/mnt/cf" ) );
}

void FileDialog::cd_home()
{
	if ( usr_home.length() == 0 )
		setList( QString( "/home" ) );
	else
		setList( usr_home );
}

void FileDialog::cd_zaurus()
{
	setList( QString( "/home/zaurus" ) );
}

void FileDialog::cd_text()
{
	if ( usr_text.length() == 0 )
		setList( QString( "/home/zaurus/Documents/Text_Files" ) );
	else
		setList( usr_text );
}

void FileDialog::cd_user()
{
	if ( usr_user.length() == 0 )
		setList( QString( "/home/zaurus/Documents" ) );
	else
		setList( usr_user );
}

void FileDialog::setUserDir( const QString udir_u, const QString udir_j )
{
	usr_u = udir_u;
	usr_j = udir_j;
}

void FileDialog::setUserDir2( const QString udir_mnt, const QString udir_home, const QString udir_text, const QString udir_user )
{
	usr_mnt  = udir_mnt;
	usr_home = udir_home;
	usr_text = udir_text;
	usr_user = udir_user;
}

void FileDialog::cd_user_U()
{
	setList( usr_u );
}

void FileDialog::cd_user_J()
{
	setList( usr_j );
}

void FileDialog::cd_qt()
{
	setList( QString( "/home/QtPalmtop" ) );
}

// ----------------------------- v1.3.4
void FileDialog::inputFileName()
{
	QString	line1s = ((TextEdit*)this_parent)->getLine1Text();
	QString	line1_str = line1s.simplifyWhiteSpace();
	int i = line1_str.find( ' ' );
	QString f_name = line1_str;
	if ( i > 0 )
		f_name = line1_str.left( i );
	while( f_name.startsWith( "." ) )
		f_name = f_name.mid( 1 );
	f_name.replace( QRegExp("/"), "_" );
	if ( f_name.length() > 64 )
		f_name = f_name.left( 64 );

	// ------------------------ v1.3.5b
	if (((TextEdit*)this_parent)->appendFileExtension )
		f_name.append( ".txt" );

	QString buf = LineEdit1->text();
	int col = LineEdit1->cursorPosition();

	buf.insert( col, f_name );
	LineEdit1->setText( buf );
	LineEdit1->setFocus();
}

void FileDialog::inputDateTime()
{
	QString	dt;
	QDate	dd = QDate::currentDate();
	dt.sprintf( "%04d%02d%02d", dd.year(), dd.month(), dd.day() );

	QString buf = LineEdit1->text();
	int col = LineEdit1->cursorPosition();

//	QString dt = ((TextEdit*)this_parent)->getDateTime();
//	QString dt = dt.stripWhiteSpace();
//	dt.replace( QRegExp("/"), "_" );

	buf.insert( col, dt );
	LineEdit1->setText( buf );
	LineEdit1->setFocus();
}


void FileDialog::help_menu()
{
	QTextCodec	*codec;
	codec = QTextCodec::codecForName( "eucJP" );

	QMessageBox::information( this, "Filer Help", codec->toUnicode( "Ctrl(Shift)\nCtrl+R : root\nCtrl+H : /home\nCtrl+Q : /home/QtPalmtop\nCtrl+Z : /home/zaurus\nCtrl+T : /home/zaurus/Documents/Text_Files\nCtrl+S : /var/mnt/card (SD Card)\nCtrl+U : /var/mnt/card/Documents (SD Card)\nCtrl+F : /var/mnt/cf (CF Card)\nCtrl+J : /var/mnt/cf/Documents (CF Card)\n\nץåܥ\n[m]    : /var/mnt\n[h]    : /home\n[t]    : /home/zaurus/Documents/Text_Files" ), QMessageBox::Ok, QMessageBox::Default );
}

// ******************************************************************
// 2003.01 latin1() --> utf8  for japanese file name
// ******************************************************************
void FileDialog::changeList( void )
{
	QString file_name = ListBox1->currentText();
	if( file_name == ".." )
	{
		fdir.cdUp();
		QString myPath = fdir.absPath();
		setList( myPath );
	}
	else
	{
		QString myPath = fdir.absPath();
		if ( myPath.right( 1 ) != "/" )
			myPath.append( "/" );
		myPath.append( file_name );

		QFileInfo	f_info( myPath );

		if ( file_name == "." )
		{
		}
		else
		{
			if ( f_info.isFile() )
			{
				currentFileName = file_name;
				if( LOAD < DIALOG_FILER )
				{
					if ( LineEdit1->text() == file_name )	// when enter twice
						fileSelected();
					else
						LineEdit1->setText( file_name );	// for japanese file name 2003.01.19
				}
			}
			else
			{
				if ( f_info.isDir() )
				{
					setList( myPath );
				}
			}
		}
	}
}


// ******************************************************************
// 2003.01 japanese file name
// v2.2.6 append return( true false );
// ******************************************************************

bool FileDialog::setList(const QString myDir)
{
/*--------------------
	QString		wkDir;
	// -------------------------- can't get dot-file & dot diretory!!!
	if ( fdir.cd( myDir ))
		wkDir = myDir;
	else
		wkDir = QDir::homeDirPath();
	fdir.cd( wkDir );
---------------------*/

	// ---------------------------- v2.2.5
	QDir wkDir( myDir );
	wkDir.setFilter( QDir::Dirs | QDir::Files | QDir::Hidden );
	wkDir.setMatchAllDirs( true );
	wkDir.setSorting( QDir::DirsFirst );

 	const QFileInfoList *list = wkDir.entryInfoList();

	// ---------------------------- v2.2.4 check permission
	if ( list == NULL )
		return( false );		// v2.2.6

	fdir = wkDir;
	ListBox1->clear();

	QFileInfoListIterator it( *list );      // create list iterator
	QFileInfo *fi;                          // pointer for traversing

	while ( (fi=it.current()) )
	{           // for each file...
		if ( fi->isFile() )
//			ListBox1->insertItem( Resource::loadPixmap( "fileopen" ), fi->fileName() );
			ListBox1->insertItem( fi->fileName() );
		else
			ListBox1->insertItem( Resource::loadPixmap( "folder" ), fi->fileName() );

		++it;                               // goto next list element
	}


/*----------------

	// --------------------------- v1.2.9 dot file & derectory
	DIR				*dirp;	// pointer for diretory
	struct	dirent	*entp;
	char			my_dir[255];
	QString			utf8_str;

	strcpy( my_dir, (const char*)wkDir.utf8() );

	// This check is necessary!!!  why???
	if ( my_dir[0] == '/' )		// check Japanese word!!!
	{
		dirp = opendir( my_dir );

		while (( entp = readdir( dirp )) != NULL )
		{
			if ( entp->d_name[0] != '.' )
				continue;
			if (( entp->d_name[1] == '\0' ) || ( entp->d_name[1] == '.' ))
				continue;

			utf8_str = QString::fromUtf8( entp->d_name );

			if ( entp->d_type == DT_DIR )
				ListBox1->insertItem( Resource::loadPixmap( "folder" ), utf8_str );
			else
				ListBox1->insertItem( utf8_str );
		}
		closedir( dirp );
	}

	if( LOAD == DIALOG_FILER )
		LineInfo->setText( wkDir );
	else
		if( LOAD >= DIALOG_TOCP )
			StBar2->message( wkDir );
		else
			StBar->message( wkDir );

-----------------------*/

	if( LOAD == DIALOG_FILER )
		LineInfo->setText( myDir );
	else
		if( LOAD >= DIALOG_TOCP )
			StBar2->message( myDir );
		else
			StBar->message( myDir );

	return( true );
}


void FileDialog::setName(const QString fileName)
{
	LineEdit1->setText( fileName );
}


QString * FileDialog::getSelectedFileName()
{
	return new QString( ListBox1->currentText() );
}

QString * FileDialog::getAbsSelectedFileName()
{
	QString *file_name = new QString( LineEdit1->text() );
	QString *myPath = new QString( fdir.absPath() );
	myPath->append( "/" );
	myPath->append( *file_name );
	
	delete file_name;
		//printf("Retuning %s\n",myPath.latin1());
	return myPath;
}

QString FileDialog::getSelectFilePath( void )
{
	QString myPath = fdir.absPath();
	myPath.append( "/" );
	QString file_name = ListBox1->currentText();
	myPath.append( file_name );
	return( myPath );
}


QString * FileDialog::getAbsSelectedPath()
{
	QString *myPath = new QString( fdir.absPath() );
	return myPath;
}





// ******************************************************************
// v1.3.0
// append simple filer
// ******************************************************************
//#define   BUFF_SIZE        4096
#define   BUFF_SIZE        8192
char	  copyBuf[BUFF_SIZE];

bool FileDialog::copyFile( QString r_path, QString w_path )
{
//	FileManager	fm;		fm.copyFile( src, dest )	Can I use FileManager???

	QFile	readFile( r_path );
	QFile	writeFile( w_path );
	int		len;
	int		w_len;

	if ( ! readFile.open( IO_ReadOnly ))
	{
		QMessageBox::critical( this, "Error : open", readFile.name(), QMessageBox::Ok, QMessageBox::Default );
		return( false );
	}
	if ( ! writeFile.open( IO_WriteOnly ))
	{
		readFile.close();
		QMessageBox::critical( this, "Error : open", writeFile.name(), QMessageBox::Ok, QMessageBox::Default );
		return( false );
	}
	while(( len = readFile.readBlock ( copyBuf, BUFF_SIZE )) > 0 )
	{
		w_len = writeFile.writeBlock( copyBuf, len );
		if ( len != w_len )
		{
			QMessageBox::critical( this, "Error : write", writeFile.name(), QMessageBox::Ok, QMessageBox::Default );
			writeFile.close();
			readFile.close();
			return( false );
		}
	}
	writeFile.close();
	readFile.close();
	return( true );
}

void FileDialog::messageFileSelect( void )
{
	QTextCodec	*codec;
	codec = QTextCodec::codecForName( "eucJP" );

	QMessageBox::warning( this, "ZEditor", codec->toUnicode( "ե򤷤Ʋ" ), QMessageBox::Ok, QMessageBox::Default );
}

void FileDialog::fileInformation( void )
{
	QString 	file_name = ListBox1->currentText();
	if ( file_name.length() == 0 )
	{
		messageFileSelect();
		return;
	}

	QString		myPath;
	if ( file_name == "." )
	{
		myPath = fdir.absPath();
	}
	else
	{
		if ( file_name == ".." )
		{
			QDir	wk_fdir = fdir;
			wk_fdir.cdUp();
			myPath = fdir.absPath();
		}
		else
		{
			myPath = getSelectFilePath();
		}
	}
	QFileInfo	f_info( myPath );
	QTime		t1 = f_info.lastModified().time();
	QDate		d1 = f_info.lastModified().date();

	int				f_type;
	static char*	type_str[] = { "ե", "ǥ쥯ȥ", "ܥå", "¾" };
	if ( f_info.isDir() )
		f_type = 1;
	else
		if ( f_info.isSymLink() )
			f_type = 2;
		else
			if ( f_info.isFile() )
				f_type = 0;
			else
				f_type = 3;

	int				ac1;
	int				ac2;
	int				ac3;
	static char*	ac_str[] = { "", "" };
	if ( f_info.isReadable() )
		ac1 = 0;
	else
		ac1 = 1;
	if ( f_info.isWritable() )
		ac2 = 0;
	else
		ac2 = 1;
	if ( f_info.isExecutable() )
		ac3 = 0;
	else
		ac3 = 1;

	QString		buf;
	buf.sprintf( "\nǽ %04d.%02d.%02d\n             %02d:%02d:%02d\nFile   %8d\n", 
				d1.year(), d1.month(), d1.day(), t1.hour(), t1.minute(), t1.second(), f_info.size() );

	buf.append( "File   " );
	buf.append( type_str[f_type] );
	buf.append( "\n   ɹ " );
	buf.append( ac_str[ac1] );
	buf.append( "\n              " );
	buf.append( ac_str[ac2] );
	buf.append( "\n             ¹ " );
	buf.append( ac_str[ac3] );

	QTextCodec	*codec;
	codec = QTextCodec::codecForName( "eucJP" );
	QMessageBox::information( this, "ZEditor", file_name + codec->toUnicode( buf ), QMessageBox::Ok, QMessageBox::Default );
}

/*---
void FileDialog::fileAttribute( void )
{
}
---*/

void FileDialog::fileRename( void )
{
	QString select_file = ListBox1->currentText();
	QFileInfo	f_info( getSelectFilePath() );
	if (( select_file.length() == 0 ) || ( select_file == "." ) || ( select_file == ".." ) || ( f_info.isDir()) )
	{
		messageFileSelect();
		return;
	}

	NameInputDialog		name_dialog( this, "nameinput", true, 0, false );
	name_dialog.setOldStr( select_file );
	if ( name_dialog.exec() == QDialog::Accepted )
	{
		// ------------------------------------- same name
		if ( select_file == name_dialog.name )
			return;

		QFile	tofile( fdir.absPath() + "/" + name_dialog.name );
		// ------------------------------------- check directory
		if ( tofile.exists() )
		{
			QTextCodec	*codec;
			codec = QTextCodec::codecForName( "eucJP" );
			QMessageBox::warning( this, "ZEditor", name_dialog.name + codec->toUnicode( "\nΥե̾ϴ¸ߤޤ\nѹǤޤ" ), QMessageBox::Ok, QMessageBox::Default );
			return;
		}
		else
		{
			QDir	todir;
			if ( ! todir.rename( fdir.absPath() + "/" + select_file, tofile.name() ) )
			{
				QMessageBox::critical( this, " Error : rename file", tofile.name(), QMessageBox::Ok, QMessageBox::Default );
				return;
			}
		}
		setList( fdir.absPath() );
		ListBox1->setFocus();
	}
}

bool FileDialog::fileCopyOrMove( int which )
{
	QString select_file = ListBox1->currentText();
	QFileInfo	f_info( getSelectFilePath() );
	if (( select_file.length() == 0 ) || ( select_file == "." ) || ( select_file == ".." ) || ( f_info.isDir()) )
	{
		messageFileSelect();
		return( false );
	}

	// -------------------------------- dialog
	FileDialog to_dialog( this, "toselector", true, 0, which );
	to_dialog.setUserDir( usr_u, usr_j );
	to_dialog.setList( fdir.absPath() );

	// -------------------------------- dialog
//	ToDialog 	to_dialog( this, "toselector", true, 0, which );
//	to_dialog.setList( fdir.absPath() );

	if ( to_dialog.exec() == QDialog::Accepted )
	{
		QString 	fromPath = fdir.absPath();		// from
		QFile		fromfile( fromPath + "/" + select_file );

		QString		toPath = *( to_dialog.getAbsSelectedPath() );
		QFile		tofile( toPath + "/" + select_file );
		// ------------------------------------- check same directory and file
		if ( fromPath == toPath )
			return( true );
		// ------------------------------------- check to_directory
		if ( tofile.exists() )
		{
			static char*	which_str[] = { "ư", "ԡ" };

			QTextCodec	*codec;
			codec = QTextCodec::codecForName( "eucJP" );

			QFileInfo	fromfinfo( fromfile );
			QFileInfo	tofinfo( tofile );
			QTime		t1 = fromfinfo.lastModified().time();
			QDate		d1 = fromfinfo.lastModified().date();
			QTime		t2 = tofinfo.lastModified().time();
			QDate		d2 = tofinfo.lastModified().date();

			QString		buf;
			buf.sprintf( "ƱΥե뤬¸ߤޤ\nե %04d.%02d.%02d %02d:%02d\nե %04d.%02d.%02d %02d:%02d\n񤭤ƤǤ", 
						d1.year(), d1.month(), d1.day(), t1.hour(), t1.minute(), d2.year(), d2.month(), d2.day(), t2.hour(), t2.minute() );

			int ret = QMessageBox::warning( this, "ZEditor", select_file + "\n" + codec->toUnicode( which_str[which%2] ) + codec->toUnicode( buf ), "OK", "Cancel", 0, 1, 1 );
			if ( ret )
				return( false );
		}
		// -------------------------------- copy or move
		copyFile( fromPath + "/" + select_file, toPath + "/" + select_file );
		// -------------------------------- move
		if ( which == DIALOG_TOMV )
		{
			if ( ! fromfile.remove())
			{
				QMessageBox::critical( this, "Error : remove file", fromfile.name(), QMessageBox::Ok, QMessageBox::Default );
				return( false );
			}
		}
		return( true );
	}
	return( false );
}

void FileDialog::fileCopy( void )
{
	fileCopyOrMove( DIALOG_TOCP );
}

void FileDialog::fileMove( void )
{
	int	del_index = ListBox1->currentItem();
	if ( fileCopyOrMove( DIALOG_TOMV ))
	{
		ListBox1->removeItem ( del_index );
		ListBox1->setFocus();
	}
}

void FileDialog::makeDirectory( void )
{
	NameInputDialog		name_dialog( this, "nameinput", true, 0, true );
	if ( name_dialog.exec() == QDialog::Accepted )
	{
		QDir	todir( fdir.absPath() + "/" + name_dialog.name );
		// ------------------------------------- check directory
		if ( todir.exists() )
		{
			QTextCodec	*codec;
			codec = QTextCodec::codecForName( "eucJP" );
			QMessageBox::warning( this, "ZEditor", name_dialog.name + codec->toUnicode( "\nΥǥ쥯ȥ̾ϴ¸ߤޤ\nǤޤ" ), QMessageBox::Ok, QMessageBox::Default );
			return;
		}
		else
		{
			if ( ! todir.mkdir( fdir.absPath() + "/" + name_dialog.name ) )
			{
				QMessageBox::critical( this, " Error : make dir", todir.dirName(), QMessageBox::Ok, QMessageBox::Default );
				return;
			}
		}
		setList( fdir.absPath() );
		ListBox1->setFocus();
	}
}

void FileDialog::fileDelete( void )
{
	QString select_file = ListBox1->currentText();
	int	del_index = ListBox1->currentItem();
	QFileInfo	f_info( getSelectFilePath() );
	if (( select_file.length() == 0 ) || ( select_file == "." ) || ( select_file == ".." ) )
	{
		messageFileSelect();
		return;
	}

	QString 	delPath = fdir.absPath();		// from
	QFile		delfile( delPath + "/" + select_file );

	QTextCodec	*codec;
	codec = QTextCodec::codecForName( "eucJP" );
	int ret = QMessageBox::warning( this, "ZEditor", delfile.name() + codec->toUnicode( "\nƤǤ" ), "OK", "Cancel", 0, 1, 1 );
	if ( ret )
		return;

	// ---------------------------- delete file
	if ( f_info.isDir() )
	{
		QDir	delDir;
		if ( ! delDir.rmdir( delfile.name() ))
		{
			QMessageBox::critical( this, "Error : remove dir", delfile.name(), QMessageBox::Ok, QMessageBox::Default );
			return;
		}
	}
	else
	{
		if ( ! delfile.remove())
		{
			QMessageBox::critical( this, "Error : remove file", delfile.name(), QMessageBox::Ok, QMessageBox::Default );
			return;
		}
	}
	ListBox1->removeItem ( del_index );
	ListBox1->setFocus();
}



/*
 *  Destroys the object and frees any allocated resources
 */
FileDialog::~FileDialog()
{
    // no need to delete child widgets, Qt does it all for us
}








// **************************************************************
// input file and directory name
// **************************************************************

NameInputDialog::NameInputDialog( QWidget* parent,  const char* name, bool modal, WFlags fl, bool which )
    : QDialog( parent, name, modal, fl )
{
	int       xx;
	bool	c700 = false;
	QTextCodec	*codec;

	// ---------------------------------- frame size
	xx = ((FileDialog*)parent )->p_xx;
	if ( xx > 400 )			// check A300, B500 : 240 x 320 size is 2/3
		c700 = true;

	// ----------------------------------- v1.0.0 Japanese name
	codec = QTextCodec::codecForName( "eucJP" );

	if ( which )
		setCaption( codec->toUnicode( "ǥ쥯ȥ" ) );
	else
		setCaption( codec->toUnicode( "ե̾ѹ" ) );

	QLabel* label1 = new QLabel( codec->toUnicode( "̾" ), this );
	if ( c700 )
		label1->setGeometry( QRect( 5, 10, 50, 30 ) );
	else
		label1->setGeometry( QRect( 5, 10, 35, 20 ) );

	LineEdit1 = new QLineEdit( this );
	if ( c700 )
		LineEdit1->setGeometry( QRect( 60, 10, 190, 30 ) );
	else
		LineEdit1->setGeometry( QRect( 45, 10, 126, 20 ) );
	LineEdit1->setMaxLength ( 80 );

	PushButton1 = new QPushButton( this, "PushButton1" );
	if ( c700 )
		PushButton1->setGeometry( QRect( 5, 50, 54, 34 ) );
	else
		PushButton1->setGeometry( QRect( 5, 40, 36, 22 ) );
	PushButton1->setText( codec->toUnicode( "ϣ" ) );

	PushButton2 = new QPushButton( this, "PushButton2" );
	if ( c700 )
		PushButton2->setGeometry( QRect( 180, 50, 60, 34 ) );
	else
		PushButton2->setGeometry( QRect( 110, 40, 60, 22 ) );
	PushButton2->setText( codec->toUnicode( "ݎ" ) );

	connect( PushButton1 ,SIGNAL( clicked()), this, SLOT( okSelected()) );
	connect( PushButton2 ,SIGNAL( clicked()), this, SLOT( hide()) );
	connect( LineEdit1 ,SIGNAL( returnPressed()), this, SLOT( inputName()));
}


void NameInputDialog::accept()
{
	name = LineEdit1->text();
	if ( name.length() > 0 )
		QDialog::accept();
	else
		LineEdit1->setFocus();
}
void NameInputDialog::okSelected()
{
	accept();
}

void NameInputDialog::inputName()
{
	PushButton1->setFocus();
}


void NameInputDialog::setOldStr( QString str )
{
	if ( str.length() > 0 )
		LineEdit1->setText( str );
}



/*
 *  Destroys the object and frees any allocated resources
 */
NameInputDialog::~NameInputDialog()
{
    // no need to delete child widgets, Qt does it all for us
}
