
// ******************************************************************
// Copyright (c) 2003 Satoshi, All Rights Reserved.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// Author : Satoshi ( af230533@yahoo.co.jp )
// ******************************************************************

#ifndef FILEDIALOGS_H
#define FILEDIALOGS_H

#include <qvariant.h>
#include <qdialog.h>
#include <qdir.h>
#include <qstatusbar.h>
class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLineEdit;
class QListBox;
class QListBoxItem;
class QPushButton;
class QStatusBar;
class QPEMenuBar;


#define		DIALOG_OPEN			0
#define		DIALOG_SAVE			1
#define		DIALOG_FILER		2
#define		DIALOG_TOCP			3
#define		DIALOG_TOMV			4


class FileDialog : public QDialog
{
    Q_OBJECT

	public:
		FileDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		FileDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 , int load = 0, bool is_small = 0  );
		~FileDialog();

		void	setUserDir( const QString udir_u, const QString udir_j );
		void 	setUserDir2( const QString udir_mnt, const QString udir_home, const QString udir_text, const QString udir_user );
		bool	setList( const QString dir );
		void	setName( const QString fileName );
		QString * getSelectedFileName();
		QString * getAbsSelectedFileName();
		QString getSelectFilePath( void );
		bool 	copyFile( QString r_path, QString w_path );
		bool	c700;
		int		p_xx, p_yy;
		QString * getAbsSelectedPath();

	private:

		void			*this_parent;
		QListBox		*ListBox1;
		QLineEdit		*LineEdit1;
		QPushButton		*PushButton1;
		QPushButton		*PushButton1_2;

		// ------------------------------- 2003.01.19
		QPushButton		*PushButton2_1;
		QPushButton		*PushButton2_2;
		QPushButton		*PushButton2_3;
		QPushButton		*PushButton2_4;
		QPushButton		*PushButton2_5;
		QPushButton		*PushButton2_6;
		// ------------------------------- v1.1.0
		QStatusBar		*StBar;
		QStatusBar		*StBar2;
		QLineEdit		*LineInfo;

		QDir			fdir;
		const	char	*currentFileName;
		int				LOAD;

		QString			usr_u;
		QString			usr_j;

		QString			usr_mnt;
		QString			usr_home;
		QString			usr_text;
		QString			usr_user;

	protected slots:
		void accept();

	public slots:
		void changeList();
		void fileSelected();
		// --------------------------------- 2003.01.19
		void cd_up();
		void cd_root();
		void cd_mnt();
		void cd_card();
		void cd_cf();
		void cd_home();
		void cd_zaurus();
		void cd_qt();
		void cd_text();
		void cd_user();
		void cd_user_U();
		void cd_user_J();
		void inputFileName();
		void inputDateTime();
		void help_menu();

	private slots:
		void fileInformation( void );
		void fileRename( void );
		void fileCopy( void );
		void fileMove( void );
		bool fileCopyOrMove( int which );
		void makeDirectory( void );
		void fileDelete( void );


	signals:
		void doneLoad();
		void done();

	private:
		// ------------------------------- v1.3.0
		void messageFileSelect( void );
//		void fileAttribute( void );

		QPEMenuBar		*menu_bar;
		QPopupMenu		*popFile;
		int				xx, yy;
};



class NameInputDialog : public QDialog
{
    Q_OBJECT

	public:
		NameInputDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0, bool which = 0 );
		~NameInputDialog();

		QString		name;
		void		setOldStr( QString str );

	private:

		QLineEdit *	LineEdit1;
		QPushButton *	PushButton1;
		QPushButton *	PushButton2;
		QTextCodec	*	codec;

	protected slots:
		void accept();

	public slots:
		void okSelected();
		void inputName();

	signals:
		void doneLoad();
		void done();
};


#endif // FILEDIALOGS_H

