
// ******************************************************************
// Copyright (c) 2003 Satoshi, All Rights Reserved.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// Author : Satoshi ( af230533@yahoo.co.jp )
// ******************************************************************

#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qwhatsthis.h>
#include <qtextcodec.h>
#include <qlabel.h>

#include "idiom.h"


IdiomSelectDialog::IdiomSelectDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	bool	c700 = false;
	QTextCodec	*codec;

	// ---------------------------------- frame size
	int xx = parent->width();
	if ( xx > 400 )			// check A300, B500 : 240 x 320 size is 2/3
		c700 = true;

	// ----------------------------------- v1.0.0 Japanese name
	codec = QTextCodec::codecForName( "eucJP" );
	setCaption( codec->toUnicode( "Ѷ򤷤Ʋ" ) );

	ListBox = new QListBox( this );
	if ( c700 )
		ListBox->setGeometry( QRect( 1, 1, 339, 225 ) );
	else
		ListBox->setGeometry( QRect( 1, 1, 226, 153 ) );


	PushButton1 = new QPushButton( this, "PushButton1" );
	if ( c700 )
		PushButton1->setGeometry( QRect( 5, 228, 54, 26 ) );
	else
		PushButton1->setGeometry( QRect( 5, 156, 36, 18 ) );
	PushButton1->setText( codec->toUnicode( "ϣ" ) );

	PushButton2 = new QPushButton( this, "PushButton2" );
	if ( c700 )
		PushButton2->setGeometry( QRect( 220, 228, 110, 26 ) );
	else
		PushButton2->setGeometry( QRect( 142, 156,  74, 18 ) );
	PushButton2->setText( codec->toUnicode( "󥻥" ) );

	connect( ListBox, SIGNAL( clicked( QListBoxItem * )), this, SLOT( okSelected()) );
	connect( ListBox, SIGNAL( selected( int )), this, SLOT( okSelected()) );
	connect( PushButton1 ,SIGNAL( clicked()), this, SLOT( okSelected()) );
	connect( PushButton2 ,SIGNAL( clicked()), this, SLOT( hide()) );
}


void IdiomSelectDialog::accept()
{
	QDialog::accept();
}
void IdiomSelectDialog::okSelected()
{
	accept();
}


// -----------------------------------------------------

void IdiomSelectDialog::setThisIdiom( int index, QString str )
{
	ListBox->insertItem( str, index );
}

int  IdiomSelectDialog::getSelectIdiomNum( void )
{
	return( ListBox->currentItem() );
}


/*
 *  Destroys the object and frees any allocated resources
 */
IdiomSelectDialog::~IdiomSelectDialog()
{
    // no need to delete child widgets, Qt does it all for us
}
