// ******************************************************************
// Copyright (c) 2003 Satoshi, All Rights Reserved.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// Author : Satoshi ( af230533@yahoo.co.jp )
// ******************************************************************

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLineEdit;
class QPushButton;


class JumpDialog : public QDialog
{
    Q_OBJECT

	public:
		JumpDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~JumpDialog();

		QString		num;
		void		setOldStr( QString str );

	private:

		QLineEdit *	LineEdit1;
		QPushButton *	PushButton1;
		QPushButton *	PushButton2;
		QTextCodec	*	codec;

	protected slots:
		void accept();

	public slots:
		void jumpSelected();
		void inputNumber();

	signals:
		void doneLoad();
		void done();
};




class ConfirmDialog : public QDialog
{
    Q_OBJECT

	public:
		ConfirmDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~ConfirmDialog();

		int		selected;

	private:

		QPushButton *	PushButton1;
		QPushButton *	PushButton2;
		QPushButton *	PushButton3;
		QTextCodec	*	codec;

	protected slots:
		void accept();

	public slots:
		void okSelected();
		void noSelected();
		void cancelSelected();

	signals:
		void doneLoad();
		void done();
};
