
// ******************************************************************
// Copyright (c) 2003 Satoshi, All Rights Reserved.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// Author : Satoshi ( af230533@yahoo.co.jp )
// ******************************************************************

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLineEdit;
class QPushButton;
class QCheckBox;
class QComboBox;

#include "zeditor.h"

// --------------------------------------------------- 2003.05.22 ɽץ
class OptionDialog : public QDialog
{
    Q_OBJECT

	public:
		OptionDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~OptionDialog();

		void		setShortCutKey( bool flg );		// ҎƎΎĎĎɽ
		void		setBackgroundColor( int num );	// طʿλ
		void		setTextColor( int num );		// ʸο            
		void		setCursorLine( int num );		// 饤ɽ
		void		setCursorLineColor( int num );	// 饤ο    
		void		setCursorStyle( int width );	// ȷ    
		void		setCursorColor( int num );		// ο    
		void		setCRMarkDisp( int num );		// ԥޡ      
		void		setLineNumber( int num, bool cr_num );	// ֹɽ      
		void		setSelectedColor( int num );	// ϰο      
		void		setVerticalLine( int num );		// Сƥ饤      
		void		setScrollBarDisp( int num );	// Сɽ 
		void		setFontName( QString family_name );		// Font v3.1.0


		bool		getShortCutKey();	// ҎƎΎĎĎɽ
		int		getBackgroundColor();	// طʿλ
		int		getTextColor();		// ʸο            
		int		getCursorLine();	// 饤ɽ
		int		getCursorLineColor();	// 饤ο    
		int		getCursorWidth();	//     
		int		getCursorColor();	// ο    
		int		getCRMarkDisp();	// ԥޡ      
		int		getLineNumber();	// ֹɽ      
		bool	getLineNumberCr();	// ֹɽ ñ̡֤ñ 
		int		getSelectedColor();	// ϰο      
		int		getVerticalLine();	// Сƥ饤      
		int		getScrollBarDisp();	// Сɽ 
		QString	getFontName();		// Font v3.1.0

	private:

		QComboBox *	ComboBox1;
		QComboBox *	ComboBox2;
		QComboBox *	ComboBox3;
		QComboBox *	ComboBox4;
		QComboBox *	ComboBox5;
		QComboBox *	ComboBox6;
		QComboBox *	ComboBox7;
  		QComboBox *	ComboBox8;
		QComboBox *	ComboBox9;
		QComboBox *	ComboBox10;
		QComboBox *	ComboBox11;
		QComboBox *	ComboBox12;
		QComboBox *	ComboBox13;
		QComboBox *	ComboBox14;
		QPushButton *	PushButton1;
		QPushButton *	PushButton2;

	protected slots:
		void accept();

	public slots:
		void optionSelected();

	signals:
		void doneLoad();
		void done();
};

// --------------------------------------------------- 2003.05.22 ưץ
class OptionDialog2 : public QDialog
{
    Q_OBJECT

	public:
		OptionDialog2( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~OptionDialog2();

		void		setMoveCursor( bool flg );	// ֳפǥ뼫ưư
//		void		setSelectedCursor( bool flg );	// ֣Хʬ
		void		setAppendCRCode( int flg );	// ShiftJISǲԥɤղ
		void		setCaseSensitive( int flg );	// ʸʸζ(ִ)
		void		setIncrementalSearch( bool flg );// 󥯥󥿥븡
		void		setWordWrap( int flg_count );	// ֤λ
		void		setTabLength( int num );	// ԣΥ      
		void		setInputCodec( int num );	// ϥեʸĎ      
		void		setOutputCodec( int num );	// ϥեʸĎ      
		void		setCursorWord( int num );	// ʸư(ִ)
		void		setDateForm( int num );		// դȻ֤Υե

		bool		getMoveCursor();	// ֳפǥ뼫ưư
//		bool		getSelectedCursor();	// ֣Хʬ
		int			getAppendCRCode();	// ShiftJISǲԥɤղ v2.2.2 bool --> int
		bool		getCaseSensitive();	// ʸʸζ(ִ)

		bool		getIncrementalSearch();	// 󥯥󥿥븡
		int		getWordWrap();		// ֤λ
		int		getTabLength();		// ԣΥ      
		int		getInputCodec();	// ϥեʸĎ      
		int		getOutputCodec();	// ϥեʸĎ      
		int		getCursorWord();	// ʸư(ִ)
		int		getDateForm();		// դȻ֤Υե

	private:

		QComboBox *	ComboBox1;
		QComboBox *	ComboBox2;
		QComboBox *	ComboBox3;
		QComboBox *	ComboBox4;
		QComboBox *	ComboBox5;
		QComboBox *	ComboBox6;
		QComboBox *	ComboBox7;
		QComboBox *	ComboBox8;
		QComboBox *	ComboBox9;
		QComboBox *	ComboBox10;
		QComboBox *	ComboBox11;
		QPushButton *	PushButton1;
		QPushButton *	PushButton2;

	protected slots:
		void accept();

	public slots:
		void optionSelected();

	signals:
		void doneLoad();
		void done();
};


class OptionDialog3 : public QDialog
{
    Q_OBJECT

	public:
		OptionDialog3( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~OptionDialog3();

		QString		changeSpace( QString str );

		void		setWhichRegExpress( bool which );		// ɽλ

		void		setTextCharDispColor( int num );	// ƥȤȾʸοʬ
		void		setTextReservedWord( QString str );	// ƥȤͽ
		void		setTextReservedWord2( QString str );	// ƥȤͽ
		void		setTextReservedWord3( QString str );	// ƥȤͽ
		void		setTextReservedColor( int num );	// ƥȤͽʸοʬ
		void		setTextReservedColor2( int num );	// ƥȤͽʸοʬ
		void		setTextReservedColor3( int num );	// ƥȤͽʸοʬ
		void		setTextCommentWord( QString str );	// ƥȤΥʸ
		void		setTextCommentColor( int num );	// ƥȤΥʸοʬ

		UserFileInfo	getTextInfo();

		void		setUserReserved( int index, UserFileInfo one_user );	// 桼ե
		void		setUserReservedShow( int file_type );				// 桼եɽ

		UserFileInfo	getUserInfo( int which );

	private:

		QCheckBox *	RegexCheckBox;
		QComboBox *	ComboBox1;
		QComboBox *	ComboBox1_1;
		QComboBox *	ComboBox1_2;
		QComboBox *	ComboBox1_3;
		QLineEdit *	LineEdit1rsv1;
		QLineEdit *	LineEdit2rsv1;
		QLineEdit *	LineEdit3rsv1;
		QLineEdit *	LineEdit1comm;
		QComboBox *	ComboBox1comm;

		QLineEdit *	LineEdit1rsv2;
		QLineEdit *	LineEdit2rsv2;
		QLineEdit *	LineEdit3rsv2;
		QLineEdit *	LineEdit4rsv2;
		QComboBox *	ComboBox2_0;
		QComboBox *	ComboBox2;
		QComboBox *	ComboBox3;
		QComboBox *	ComboBox4;
		QLineEdit *	LineEdit2comm;
		QComboBox *	ComboBox2comm;

		QPushButton *	PushButton1;
		QPushButton *	PushButton2;

		int				now_user;
		UserFileInfo	user[MAX_FILE_COLOR];		// user file info .... 0:text. 1:user1, 2:user2

	protected slots:
		void accept();

	public slots:
		void optionSelected();
		void changeUserUp();
		void changeUserDown();
		void changedUserNum(int);
		void changedUserNum2(int);

	signals:
		void doneLoad();
		void done();
};

// --------------------------------------------------- 2004.04.03 Ѷ祪ץ
class OptionDialog4 : public QDialog
{
    Q_OBJECT

	public:
		OptionDialog4( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~OptionDialog4();

		void		setThisIdiom( int index, QString str );	// δѶ򥻥å
		QString		getThisIdiom( int index );				// δѶ

	private:

		QLineEdit *	LineEdit1;
		QLineEdit *	LineEdit2;
		QLineEdit *	LineEdit3;
		QLineEdit *	LineEdit4;
		QLineEdit *	LineEdit5;
		QLineEdit *	LineEdit6;
		QLineEdit *	LineEdit7;
		QLineEdit *	LineEdit8;
		QLineEdit *	LineEdit9;

		QPushButton *	PushButton1;
		QPushButton *	PushButton2;

	protected slots:
		void accept();

	public slots:
		void optionSelected();
};



// --------------------------------------------------- v2.2.0 special key option
class OptionDialog5 : public QDialog
{
    Q_OBJECT

	public:
		OptionDialog5( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~OptionDialog5();

		void		setSpecialKey( SpecialKey sp );
		SpecialKey	getSpecialKey( void );

	private:

		QComboBox *	ComboBox1;
		QComboBox *	ComboBox2;
		QComboBox *	ComboBox3;
		QComboBox *	ComboBox4;
		QComboBox *	ComboBox5;
		QComboBox *	ComboBox6;
		QComboBox *	ComboBox7;
		QComboBox *	ComboBox8;
		QComboBox *	ComboBox9;
		QComboBox *	ComboBox10;

		QPushButton *	PushButton1;
		QPushButton *	PushButton2;

		SpecialKey		d_sp;

	protected slots:
		void accept();

	public slots:
		void optionSelected();
};
