
// ******************************************************************
// Copyright (c) 2003 Satoshi, All Rights Reserved.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//
// Author : Satoshi ( af230533@yahoo.co.jp )
// ******************************************************************

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLineEdit;
class QPushButton;
class QCheckBox;

class ReplaceDialog : public QDialog
{
    Q_OBJECT

	public:
		ReplaceDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~ReplaceDialog();

		QString		old_str;
		QString		new_str;
		bool		which_from;
		bool		which_each;
		void		setOldStr( QString str );
		void		setNewStr( QString str );

	private:

		QLineEdit *	LineEdit1;
		QLineEdit *	LineEdit2;
		QCheckBox *	FromCheckBox;
		QCheckBox *	EachCheckBox;
		QPushButton *	PushButton1;
		QPushButton *	PushButton2;

	protected slots:
		void accept();

	public slots:
		void replaceSelected();
		void inputOldStr();
		void inputNewStr();

	signals:
		void doneLoad();
		void done();
};
