/**********************************************************************
** Copyright (C) 2000-2002 Trolltech AS.  All rights reserved.
**
** This file is part of the Qtopia Environment.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

// ******************************************************************
// Copyright (c) 2003-2004 Satoshi, All Rights Reserved.
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author : Satoshi ( af230533@yahoo.co.jp )
// ******************************************************************
// ******************************************************************** 
// 2003.01.18 - 2003.01.22  v0.9.0
//		append Menu( Save )
//		modified Open & Save codec 
//		modified Dialog size
//		append Dialog pushbutton
//		automatic codec for unicode, UTF-8, ShiftJIS, EUC
// v0.9.1
//		bug fix : check codec
//		delete latin1()
//		modified file select action
//		append WordWrapPolicy
//		append Jump
//		append SelectAll
// v0.9.1b
//		bug fix
//		append open last file
// v0.9.2
//		append last CursorPosition
//		append save
//		Japanese menu
//		modifued default codec
// v1.0.0
//		warning Message box
//		Japanese dialog
//		append short cut key
//		append replace
//		append Date & Time
//		append QList for last file....insert( index...) not correct!
// v1.0.1
//		"short cut key" not save!....bug fix
//		append Path to dialog
//		append returnpress to "find"
//		update OK button close
//		append background color
// v1.0.2
//		ShiftJIS CR+LF : not save!....bug fix
//		default Tab Length
//		change save icon 
//		test !!! cursol line
// v1.0.3
//		draw cursor line
//		append 2last filename
// v1.0.4
//		*.conf, *.rc files open as UTF-8
//		append color of cursor line
// v1.0.5
//		append "undo", "duplicate" to "edit"
//		default "AppendCRCode"
//		modified number of cursor color
// v1.1.0
//		"AppendCRCode" with wordwrap bug fix
//		append Marked text to input line
// v1.1.1
//		"AppendCRCode" update output
// v1.1.2
//		append accelkey
//              delete cursor line
// v1.1.3
//		"AppendCRCode" bug fix
//              Ctrl+?
// v1.1.4
//		Open, Save dialog bug fix
//		check parameter-file and last-file
// v1.1.5
//		setDocument ---> public slots
//		show line number to caption
// v1.1.6
//		setDocument bug fix
//		show line number to caption ---> paintEvent
//		jump Dialog
//		Fn + 1, Fn + 2 accelkey
// v1.1.7
//		count Character
// v1.1.8
//		mark jump
//		append option
// v1.1.9
//		append incremental search mode
//		append case sensitive mode
// v1.2.0
//		override paintCell
//		update cursor style
//		update cursor color ...etc.
// v1.2.1
//		font size 8 isn't exist
//		update cursor line number
//		draw CR pixmap
// v1.2.2
//		bug fix of [word wrap]&[find, replace]
//		update cursor line number
//		draw CR pixmap & EOF
// v1.2.2a
//		bug fix of [word wrap]&[replace]
// v1.2.3
//		bug fix of cursor line color
//		bug fix of find
//		append choice of codec
// v1.2.4
//		append overwrite mode
//		append marked char count
// v1.2.5
//		redraw 1byte character
// v1.2.5a
//		bug fix
// v1.2.6
//		reserved word of text file
// v1.2.7
//		bug fix of [1byte char]
//		append cursor color( white )
// 		append user file
// v1.2.7a
//		check already exist
// v1.2.8
//		update confirm dialog
//		append Tab & space mark
//		append AutoIndent
// v1.2.9
//		check already exist
//		show dot file and dot directory
//		append gray color
// v1.2.9a
//		bug fix
// v1.3.0
//		append filer
// v1.3.0a
//		bug fix
// v1.3.0b
//		bug fix, append JIS7( iso-2022-jp ) codec
// v1.3.0c
//		bug fix
// v1.3.0d
//		bug fix, restruct dialog
// v1.3.0e
//		bug fix( A300 )
// v1.3.1
//		append vertical line, word wrap with col width, qcop 'JumpTo(int)'
// v1.3.1a
//		bug fix : word wrap with col width, qcop 'JumpTo(int)'
// v1.3.1b
//		bug fix : word wrap with col width, qcop 'JumpTo(int)'
// v1.3.1c
//		bug fix : qcop 'JumpTo(int)'
// v1.3.2
//		comment of selected color, append few color
// v1.3.2a
//		bug fix
// v1.3.3
//		append reserved word color, save icon
// v1.3.4
//		append icon_name, set file name, directory jump
// v1.3.5
//		append regular expression
// v1.3.5a
//		bug fix : regular expression
// v1.3.5b
//		bug fix : regular expression
// v1.3.6
//		append redo, change find view, change save of UTF-8
// v2.0.0
//		cursor style, line number, scrollbar disp, replace and undo,
//		selected words, word wrap AtWhiteSpace 
// v2.0.1
//		get baseName from argv[0]
// v2.0.2
//		bug fix : supported "autoindent" in "Undo"
// v2.0.3
//		change file dialog size when view style, append autosave
// v2.0.4
//		bug fix : set file name in autosave, exeception : OK ---> Enter
// v2.0.5
//		bug fix : save as... in autosave, append AutoSaveDir
// v2.0.6
//		bug fix : cursor position when create process ZEditor
// v2.0.7
//		bug fix : update caption when line number show
//		append mark selection
// v2.0.8
//		update cell width, append jump mark
// v2.0.9
//		bug fix : jump of Ctrl + J, U
// v2.0.9a
//		bug fix : setDocument()
// v2.1.0
//		append idiom option, line jump parameter
// v2.1.0a	bug fix	: h_scrollbar
// v2.1.0b	bug fix	: move file
// v2.1.1
//		append reserved word3, regular expression
// v2.1.2	bug fix : save file of size zero
//			append edited check in setDocument
// v2.1.3
//		append user file of option color
// v2.1.4
//		append user file of option color, default show
//		bug fix : A300 cancel button
// v2.1.5
//		delete half byte char check, line number Jump
//		bug fix : reserved word of regular expression
// v2.1.6
//		bug fix : new file cursor show
// v2.1.7
//		append "SaveFastUTF8" to [conf file]
// v2.2.0
//		append option of special key
// v2.2.1
//		append default cut & copy mark
// v2.2.2
//		append Macintosh CR code
//		append insert fullPath
// v2.2.3
//		bug fix : set last file when fileNew()
// v2.2.4
//		bug fix : check permission( FileDialog.cpp )
//		bug fix : update Macintosh CR code
// v2.2.5
//		bug fix : set fdir from wkDir( FileDialog.cpp )
//		update setList(const QString myDir)
// v2.2.6
//		bug fix : updated return value of FileDialog.setList
//		append text color
// v2.3.0
//		append option for the line number display
// v2.3.1
//		append option for the title number display
// v2.3.2
//		append toggle switch for mark cursor position 
// v3.0.0
//		append special keys
//		append find backwords, update search when wordwrap
//		append Tab, Shift Tab indent
// v3.1.0
//		append history of search words
//		append font option
//		check focus for search
// v3.1.1
//		bug fix : set search history when accespt
//		bug fix : setFont() position
// v3.1.2
//		bug fix : position erroe of option label( A300, B500 )
// v3.2.0
//		append character codec of eucKR and GBK( Chinese : GB 2312-80 )
//		append menu of clear all history
//		bug fix : check write error when save file
// v3.2.1
//		bug fix : recpmpile !!!
// v3.2.2
//		bug fix : UTF-8 JP-character count when save file
// v3.2.3
//		append setSelectAll() to JumpDialog
//		bug fix : when unifont was selected, a part of line number is removed
// v3.2.4
//		bug fix : when the file fistory was removed, the history exists.
// v3.3.0
//		append directory button to Filedialog and Filer.
// v3.4.0
//		append conversion of ASCII and Japanese.
// v3.4.1
//		bug fix : can't recognize Tab code when comment draw
// v3.5.0
//		append read only open.
//		append set string from clip board, when find and replace string.
// v3.5.1
//		bug fix : combobox cursor of option color.
// v3.5.2 - 3.5.4
//		bug fix : font and fon size of search combobox
// by Satoshi
// ********************************************************************

#include "zeditor.h"
#include "repdialog.h"
#include "jump.h"
#include "optdialog.h"
#include "idiom.h"

#include <qpe/global.h>
#include <qpe/fileselector.h>
#include <qpe/applnk.h>
#include <qpe/resource.h>
#include <qpe/config.h>
#include <qpe/qpeapplication.h>
#include <qpe/qpemenubar.h>
#include <qpe/qpetoolbar.h>
//#include <qpe/finddialog.h>

#include <qaction.h>
#include <qcolordialog.h>
#include <qfileinfo.h>
#include <qlineedit.h>
#include <qmessagebox.h>
#include <qobjectlist.h>
#include <qpopupmenu.h>
#include <qspinbox.h>
#include <qtoolbutton.h>
#include <qwidgetstack.h>
#include <qtimer.h>
#include <qlistbox.h>

#include <qtextcodec.h>	// 2003.01.18
#include <qtextstream.h>	// 2003.01.21
#include <qaccel.h>		// 2003.04
#include <qclipboard.h>		// 2003.04
#include <qcolor.h>		// 2003.06
#include <qstringlist.h>  // v1.2.6
#include <qcombobox.h>		// v3.1.0

#include <stdlib.h> //getenv
#include <string.h>
#include <ctype.h>


static const int nfontsizes = 7;
static const int fontsize[nfontsizes] = {10,12,16,18,20,24,36};
static char* menu_name[] = { "̎", "Խ", "ɽ", "", };
static char* menu_sk_name[] = { "̎(&F)", "Խ(&E)", "ɽ(&V)", "", };
static char* menu_num[] = { "1", "2", "3", "4", "5", "6", "7", "8", "9" };
// --------------------------white, red, green, blue, water, yellow
static const int color_r[8] = { 255, 255, 150, 150, 255, 150, 255, 0 };
static const int color_g[8] = { 255, 150, 255, 150, 150, 255, 255, 0 };
static const int color_b[8] = { 255, 150, 150, 255, 255, 255, 150, 0 };

// -------------------------- week name
static char* name_week[] = { "", "", "", "", "", "", "", "", "" };   // 1 :monday

// -------------------------- CR xpm  R,G,B   v1.2.1
static const char * const cr_xpm1[] = 
{
    "6 8 2 1",
    ". c None",
    "# c #FF00FF",
    "......",
    "......",
    ".....#",
    ".....#",
    ".....#",
    "..#..#",
    ".#...#",
    "######"
};

static const char * const cr_xpm2[] = 
{
    "6 8 2 1",
    ". c None",
    "# c #FF00FF",
    "......",
    "......",
    "....##",
    "....##",
    "..#.##",
    ".##.##",
    "######",
    "######"
};

static const char * const cr_xpm3[] = 
{
    "8 8 2 1",
    ". c None",
    "# c #FF00FF",
    ".......#",
    ".......#",
    ".......#",
    ".......#",
    ".......#",
    "..#....#",
    ".#.....#",
    "########"
};
static const char * const cr_xpm4[] = 
{
    "8 8 2 1",
    ". c None",
    "# c #FF00FF",
    "......##",
    "......##",
    "......##",
    "......##",
    "..##..##",
    ".##...##",
    "########",
    "########"
};

static const char * const eof_xpm[] = 
{
    "8 8 2 1",
    ". c None",
    "# c #FF00FF",
    ".......#",
    "......##",
    ".....###",
    "....####",
    "...#####",
    "..######",
    ".#######",
    "########"
};

static const char * const tab_xpm1[] = 
{
    "8 8 2 1",
    ". c None",
    "# c #FF00FF",
    "........",
    "....#...",
    ".....#..",
    "......#.",
    ".....#..",
    "....#...",
    "...#....",
    "........"
};

static const char * const tab_xpm2[] = 
{
    "8 8 2 1",
    ". c None",
    "# c #FF00FF",
    "........",
    "....##..",
    ".....##.",
    "......##",
    ".....##.",
    "....##..",
    "...##...",
    "........"
};


static const char * const zsp_xpm1[] = 
{
    "10 10 2 1",
    ". c None",
    "# c #FF00FF",
    ".#........",
    "..........",
    ".#........",
    "..........",
    ".#........",
    "..........",
    ".#........",
    "..........",
    ".#........",
    ".#.#.#.#.#"
};

static const char * const zsp_xpm2[] = 
{
    "10 10 2 1",
    ". c None",
    "# c #FF00FF",
    "..........",
    ".#........",
    "..#.......",
    ".#........",
    "..#.......",
    ".#........",
    "..#.......",
    ".#........",
    "..#.#.#.#.",
    ".#.#.#.#.#"
};

static const char * const mark_xpm[] = 
{
    "12 14 3 1",
    ". c None",
    "# c #FF00FF",
    "@ c #FFFF00",
    ".###########",
    "############",
    "###@@@@@@@@@",
    "##@@########",
    "##@##.......",
    "##@#........",
    "##@#........",
    "##@#........",
    "##@#........",
    "##@#........",
    "##@#........",
    "##@#........",
    "##@#........",
    "##@#........",
};




// -------------------------- v1.1.5 instead of signal. can't get signals!!!
extern	TextEdit *G_edit;

extern "C" { void   InsteadOfSignal( void ); }
void  InsteadOfSignal( void )
{
	G_edit->updateCaption();
}

// --------------------------- v1.2.1 instead of wrap signal
int		FrameWidth;
int		UpdateCellWidth;
extern "C" { void   InsteadOfWrapSignal( void ); }
void  InsteadOfWrapSignal( void )
{
	G_edit->wrap_this();
}

// --------------------------- v1.2.5 file type
int		FileType;


#if QT_VERSION < 300

class QpeEditor : public QMultiLineEdit
{
//		Q_OBJECT

public:
	QpeEditor( QWidget *parent, const char * name = 0 ) : QMultiLineEdit( parent, name )
        {
            clearTableFlags();
            setTableFlags( Tbl_vScrollBar | Tbl_autoHScrollBar );
        }

	//public slots:
	void moveCursorCenter( int line );		// v3.0.0
	void find( const QString &txt, int caseSensitive, bool backwords );
	int replace ( const QString &old_txt, const QString &new_txt, int caseSensitive, bool which_from, bool which_each );

	int			getCharType( QString c );
	void		autoSelectWords();
	void		lineDuplicate();
	QString		getCursorWord( int cursorword );
	QString		getMarkedWord();
	void		overwrite();
	void		setOverWriteWhich( int which ) { overwrite_which = which; };
	void		setBkColorNum( int num ) { bk_num = num; };
	void		setCursorDraw( int l_num ) { cursor_line = l_num; };
	void		setCursorStyle( int w ) { cursor_style = w; };
	void		setAutoindent( bool a ) { auto_indent = a; };
	void		setJumpMark( int line, int col )
				{
					int old_line = jump_line;
					jump_line = line;
					jump_col  = col;
					if ( old_line >= 0 )
						updateCell( old_line, 0, true );	// Cell col is always zero
				};
	void		defaultLineMark();		// v2.2.1
	bool		insertTabIndent();
	bool		removeTabIndent();

	void	set2byteSpace()
			{
				QTextCodec	*codec;
				// ---------------------------------------- from 2byte space to 1byte space
				codec = QTextCodec::codecForName( "eucJP" );
				z_spc = codec->toUnicode( "" );
			}

	int		getVerticalScrollBarWidth()
			{
				if ( testTableFlags( Tbl_vScrollBar ))
					return( verticalScrollBar()->width() );
				else
					return( 0 );
			}

	void	setLineNumber( int c, bool cr )
			{
				line_disp = c;
				cr_linenumber = cr;
				if ( line_disp >= LINE_NUMBER_FRONT2 )
				{
					// ------------------------------------ v3.2.3
					if ( font().family() == "lcfont" )
						setHMargin( font().pointSize() / 2 * line_disp + LINE_DISP_SPACE );
					else
						setHMargin( font().pointSize() * line_disp );
				}
				else
					setHMargin( DEFAULT_HMARGIN );
			};
	void	setCRMarkDisp( int c )
			{
				mark_disp = c;
				switch( mark_disp )
				{
					case 1 :
						cr_pixmap = QPixmap( (const char **)cr_xpm1 );
						tab_pixmap = QPixmap( (const char **)tab_xpm1 );
						zsp_pixmap = QPixmap( (const char **)zsp_xpm1 );
						break;
					case 2 :
						cr_pixmap = QPixmap( (const char **)cr_xpm2 );
						tab_pixmap = QPixmap( (const char **)tab_xpm2 );
						zsp_pixmap = QPixmap( (const char **)zsp_xpm2 );
						break;
					case 3 :
						cr_pixmap = QPixmap( (const char **)cr_xpm3 );
						tab_pixmap = QPixmap( (const char **)tab_xpm1 );
						zsp_pixmap = QPixmap( (const char **)zsp_xpm1 );
						break;
					case 4 :
						cr_pixmap = QPixmap( (const char **)cr_xpm4 );
						tab_pixmap = QPixmap( (const char **)tab_xpm2 );
						zsp_pixmap = QPixmap( (const char **)zsp_xpm2 );
						break;
					default :
						break;
				}
				eof_pixmap = QPixmap( (const char **)eof_xpm );
				mark_pixmap = QPixmap( (const char **)mark_xpm );
			};
	uint	font_width;
	void	setCursorColor( int num )
	 		{
				switch( num )
				{
					default:
					case 0 : cc = Qt::red;	break;
					case 1 : cc = Qt::green;	break;
					case 2 : cc = Qt::blue;	break;
					case 3 : cc = Qt::magenta;	break;
					case 4 : cc = Qt::cyan;	break;
					case 5 : cc = Qt::yellow;	break;
					case 6 : cc = Qt::black;	break;
					case 7 : cc = Qt::white;	break;
				}
			};
	void	setCursorLineColor( int num )
	 		{
				switch( num )
				{
					default:
					case 1 : clc = Qt::red;	break;
					case 2 : clc = Qt::darkGreen;	break;
					case 3 : clc = Qt::blue;	break;
					case 4 : clc = Qt::magenta;	break;
					case 5 : clc = Qt::cyan;	break;
					case 6 : clc = Qt::darkYellow;	break;
					case 7 : clc = Qt::black;	break;
					case 8 : clc = Qt::white;	break;
				}
			};
	void	setSelectedColor( int num )
	 		{
				switch( num )
				{
					default:
					case 0 : slc = Qt::blue;	break;
					case 1 : slc = Qt::darkBlue;	break;
					case 2 : slc = Qt::darkRed;	break;
					case 3 : slc = Qt::darkGreen;	break;
					case 4 : slc = Qt::darkMagenta;	break;
					case 5 : slc = Qt::darkYellow;	break;
					case 6 : slc = QColor( 80, 80, 80 );	break;
//					case 6 : slc = Qt::darkGray;	break;
				}
			};
	QColor	getReservedColor( int num )
	 		{
				switch( num )
				{
					default:
					case 1 : return( Qt::blue );
					case 2 : return( Qt::red );
					case 3 : return( Qt::green );
					case 4 : return( Qt::magenta );
					case 5 : return( Qt::cyan );
					case 6 : return( Qt::yellow );
					case 7 : return( Qt::darkGray );
/*-----
					case 8 : return( Qt::darkBlue );
					case 9 : return( Qt::darkRed );
					case 10: return( Qt::darkGreen );
					case 11: return( Qt::darkMagenta );
					case 12: return( Qt::darkYellow );
----*/
					case 8 : return( QColor( 80, 0, 0 ) );
					case 9 : return( QColor( 0, 80, 0 ) );
					case 10: return( QColor( 0, 0, 80 ) );
					case 11: return( QColor( 80, 0, 80 ) );
					case 12: return( QColor( 80, 80, 0 ) );
				}
			};


	void	setUserFileInfo( int num, UserFileInfo user )
			{
				if ( num == FILE_TEXT )
				{
					reg_express = user.RegExpress;	// set bool	v2.1.1
					textword_disp = user.half_color;	// set bool
					txtc = getReservedColor( user.half_color );
				}

				if ( num == FILE_ETC )
				{
					reserved_disp[num] = false;	// set bool
					reserved_disp2[num] = false;	// set bool
					reserved_disp3[num] = false;	// set bool
					comment_disp[num] = false;	// set bool
				}
				else
				{
					reserved_disp[num] = user.Color1;	// set bool
					r_user_c[num] = getReservedColor( user.Color1 );
					reserved_disp2[num] = user.Color2;	// set bool
					r_user_c2[num] = getReservedColor( user.Color2 );
					reserved_disp3[num] = user.Color3;	// set bool
					r_user_c3[num] = getReservedColor( user.Color3 );
					comment_disp[num] = user.CommentColor;	// set bool
					r_user_cc[num] = getReservedColor( user.CommentColor );
				}

				if ( FileType == num )
				{
					list.clear();
					list = QStringList::split( " ", user.Word1 );
					list2.clear();
					list2 = QStringList::split( " ", user.Word2 );
					list3.clear();
					list3 = QStringList::split( " ", user.Word3 );
					comment_str = user.Comment;
				}
			};


	void	setVerticalLine( int num )	{ v_line = num; }

	// ------------------------------------------- v2.0.0
	void	setSeparateKanaKanji( int which )
	 		{
				separateKanaKanji = which;	// set bool
			};

	// ------------------------------------------- v2.0.0
	void	setScrollBarDisp( int num )
			{
				uint	t_flg = 0;
				clearTableFlags( Tbl_vScrollBar | Tbl_autoHScrollBar );
				switch( num )
				{
					case 0 :
							t_flg = Tbl_vScrollBar | Tbl_autoHScrollBar;
							break;
					case 1 :
							t_flg = Tbl_autoHScrollBar;
							break;
					case 2 :
							t_flg = Tbl_vScrollBar;
							break;
				}
				setTableFlags( t_flg );
				updateScrollBars();
			}

	// -------------------------------------------- v1.3.1 
	int		Line2WrapLineNumber( int line )
			{
				int		num = -1;		// start is 0
				bool	old_cr = true;
				int		row;
				for( row= 0 ; row < numLines() ; row++ )
				{
					if ( old_cr )
						num++;
					if ( num == line )
						return( row );
					if ( isEndOfParagraph( row ))
						old_cr = true;
					else
						old_cr = false;
				}
				return( -1 );
			}

	// -------------------------------------------- v2.3.0
	int		Row2CRLineNumber( int row )
			{
				int		num = -1;		// start is 0
				bool	old_cr = true;
				for( int i= 0 ; i <= row ; i++ )
				{
					if ( old_cr )
						num++;
					if ( isEndOfParagraph( i ))
						old_cr = true;
					else
						old_cr = false;
				}
				return( num );
			}

	// -------------------------------------------- v3.5.0
	void		setReadOnlyFlg( bool y ) { read_only_flg = y; };

	// -------------------------------------------- v3.4.0	convert ASCII <--> Japanse Zen
	// which 	true  : ASCII --> Japanse Zen
	//			false :  Japanse Zen --> ASCII
	void	convertAsciiZen( bool which )
			{
				if ( ! hasMarkedText() )
					return;

				int		line1, col1, line2, col2;
				if ( getMarkedRegion( &line1, &col1, &line2, &col2 ) )
				{
					int		line_num;
					int		st, end;
					QString	*str;
					ushort		wk;

					for( line_num= line1 ; line_num <= line2 ; line_num++ )
					{
						str = getString( line_num );
						if ( line_num == line1 )
						{
							st = col1;
							if ( line_num == line2 )
								end = col2;
							else
								end = str->length();
						}
						else
						{
							if ( line_num == line2 )
							{
								st = 0;
								end = col2;
							}
							else
							{
								st = 0;
								end = str->length();
							}
						}

						// --------------------------------- convert
						for( int i= st ; i < end ; i++ )
						{
							wk = ((*str)[i]).unicode();
							// ----------------------------- ASCII --> Zen
							if ( which )
							{
								if (( wk >= 0x21 ) && ( wk <= 0x7e ))
								{
									(*str)[i] = wk + 0xfee0;
								}
							}
							else	// Zen --> ASCII
							{
								if (( wk >= 0xff01 ) && ( wk <= 0xff5e ))
								{
									(*str)[i] = wk - 0xfee0;
								}
							}
						}
					}
				}
			}



protected:

/*-------- v1.1.5 can't get touchpen!!!
	void keyPressEvent( QKeyEvent *e )
	{
		int	col;
		int	old_line;
		int	new_line;

		getCursorPosition( &old_line, &col );
		QMultiLineEdit::keyPressEvent( e );

		if ( ! line_disp )
			return;
		getCursorPosition( &new_line, &col );

		if ( old_line != new_line )
		{
//			emit lineChanged();
//			emit textChanged();
			InsteadOfSignal();
		}
	}
---------*/
	void setNewCellWidth( int new_cellwidth )
	{
		setCellWidth( new_cellwidth );	// not changed when word wrap!!!
		updateTableSize();
		updateScrollBars();				// erase h_scrollbar
	}

	// ----------------------------------- v1.2.1 change scroll size when line number disp
	//										v3.5.0 append read only
	void keyPressEvent( QKeyEvent *e )
	{
		int	col;
		int	line;

		// ------------------------------- v3.5.0 read only
		if ( read_only_flg )
		{
			switch( e->key() )
			{
				case Qt::Key_Up :
				case Qt::Key_Down :
				case Qt::Key_Left :
				case Qt::Key_Right :

				case Qt::Key_Up + CTRL :
				case Qt::Key_Down + CTRL  :
				case Qt::Key_Left + CTRL  :
				case Qt::Key_Right + CTRL  :

				case Qt::Key_Up + SHIFT:
				case Qt::Key_Down + SHIFT :
				case Qt::Key_Left + SHIFT :
				case Qt::Key_Right + SHIFT :

				case Qt::Key_PageUp :
				case Qt::Key_PageDown :
				case Qt::Key_Home :
				case Qt::Key_End :
	
				case Qt::Key_C + CTRL :
				case Qt::Key_F + CTRL :
				case Qt::Key_J + CTRL :
				case Qt::Key_M + CTRL :
				case Qt::Key_G + CTRL :
				case Qt::Key_T + CTRL :
				case Qt::Key_B + CTRL :
				case Qt::Key_N + CTRL :
				case Qt::Key_E + CTRL :
				case Qt::Key_O + CTRL :
				case Qt::Key_P + CTRL :
						break;

				default :
						return;
			}
		}


		QMultiLineEdit::keyPressEvent( e );

		if ( line_disp >= LINE_NUMBER_FRONT2  )
		{
			getCursorPosition( &line, &col );
			if ( col == 0 )
				setXOffset( 0 );
		}
		// ------------------------------ v1.2.8
		if ( auto_indent )
		{
			// -------------- Enter key
			if (( e->key() == Qt::Key_Enter ) || ( e->key() == Qt::Key_Return ))
			{
				unsigned int	i;
				int	col;
				int	now_line;

				getCursorPosition( &now_line, &col );
				QString	*old_str = getString( now_line - 1 );
				for( i= 0 ; i < old_str->length() ; i++ )
				{
					if (( (*old_str)[i] != ' ' ) && ( (*old_str)[i] != '\t' ) && ( (*old_str)[i] != z_spc[0] ))
						break;
				}
				if ( i > 0 )		// append from 0 to i
				{
//					QString	*now_str = getString( now_line );
//					now_str->insert( 0, old_str->left( i ));	bug fix
					insert( old_str->left( i ));
					setCursorPosition( now_line, i );
				}
			}
		}
	}

	// ----------------------------------------------------------- cursor line
	void paintEvent( QPaintEvent * pe )
	{
		QTableView::paintEvent( pe );

		// ------------------------------ v1.1.6 append line_number, v1.2.1
		if ( line_disp == LINE_NUMBER_TITLE  )
		{
			InsteadOfSignal();
		}
		// ------------------------------ v1.2.1 check frame width & rewrap
		if ( FrameWidth != AUTO_OR_NOWRAP )
		{
			if (( FrameWidth < MIN_FRAME_WIDTH ) || ( FrameWidth != width() ))
			{
				InsteadOfWrapSignal();
			}
		}
		// ------------------------------ v1.2.1 update CellWidth to erase h_scrollbar
		//								  v2.0.8 update
		if ( UpdateCellWidth )
		{
			setNewCellWidth( UpdateCellWidth );
			UpdateCellWidth = 0;
		}


		// ------------------------------ draw cursor line
		// draw rect is clipped !!!  erase timing isn't here!
		if ( cursor_line )
		{
			int		xx, yy, hh;
			int		now_col, now_line;
			QPainter paint( this );

			getCursorPosition( &now_line, &now_col );

			PenStyle style;
			if ( cursor_line == 1 )
				style = Qt::SolidLine;
			else
				if ( cursor_line == 2 )
					style = Qt::DashLine;
				else
					if ( cursor_line == 3 )
						style = Qt::DotLine;
					else
						style = Qt::DashDotLine;
			QPen	pen( clc, 1, style );
			paint.setPen( pen );
			rowYPos( now_line, &yy );
			colXPos( 0, &xx );
			hh = cellHeight( now_line );
			paint.drawLine( xx + 1, yy + hh -1, xx + cellWidth( 0 ) - 1, yy + hh -1 );
			QFrame::drawFrame( &paint );
		}
	}


static int textWidthWithTabs2( const QFontMetrics &fm, const QString &s, uint start, uint nChars, uint tab_dist )
{
	if ( s.isEmpty() )
		return 0;

	int dist = -fm.leftBearing( s[(int)start] );
	int i = start;
	while ( (uint)i < s.length()  &&  (uint)i < start + nChars )
	{
		if ( s[i] == '\t' )
		{
			dist = ( ( dist + tab_dist + 1 ) / tab_dist ) * tab_dist;
			i++;
		}
		else
		{
			int st_i = i;
			while ( (uint)i < s.length()  &&  (uint)i < start + nChars  &&  s[i] != '\t' )
				i++;
			dist += fm.width( s.mid( st_i, i - st_i ) );
		}
	}
	return dist;
}

/*------------------------------------ check half byte char
static bool is_alpha( QCharRef c )
{
	if ( (( c >= 'A' ) && ( c <= 'Z' ))
	 ||  (( c >= 'a' ) && ( c <= 'z' )) )
		return( true );
	return( false );
}
------------------------------------*/

void paintCell( QPainter * painter, int row, int )        // don't use "col" : always zero!!!
{
	const QColorGroup & cg = colorGroup();
	QFontMetrics fm( painter->font() );
	QString str = stringShown( row );
	if ( str.isNull() )
	{
		qWarning( "QMultiLineEdit::paintCell: (%s) no text at line %d", name( "unnamed" ), row );
		return;
	}

	QRect updateR = cellUpdateRect();
	static QPixmap *buffer2;
	if ( ! buffer2 )
		buffer2 = new QPixmap;
	if ( buffer2->width() < updateR.size().width() || buffer2->height() < updateR.size().height() )
		buffer2->resize( updateR.size() );

	ASSERT( buffer2 );
	buffer2->fill( cg.base() );

	QPainter p( buffer2 );
	p.setFont( painter->font() );
	p.translate( -updateR.left(), -updateR.top() );

	font_width = fm.width( QChar('x'));
	uint tab_dist = defaultTabStop() * font_width;
	p.setTabStops( tab_dist );

	int yPos = 0;
	int markX1, markX2;				// in x-coordinate pixels
	markX1 = markX2 = 0;			// avoid gcc warning
	int margin = hMargin();

	if ( hasMarkedText())
	{
		int markBeginX, markBeginY;
		int markEndX, markEndY;
		getMarkedRegion( &markBeginY, &markBeginX, &markEndY, &markEndX );
		if ( row >= markBeginY && row <= markEndY )
		{
			if ( row == markBeginY )
			{
				markX1 = markBeginX;
				if ( row == markEndY ) 		// both marks on same row
					markX2 = markEndX;
				else
					markX2 = str.length();	// mark till end of line
			}
			else
			{
				if ( row == markEndY )
				{
					markX1 = 0;
					markX2 = markEndX;
				}
				else
				{
					markX1 = 0;			// whole line is marked
					markX2 = str.length();	// whole line is marked
				}
			}
		}
	}
	p.setPen( cg.text() );
	int x = margin - p.fontMetrics().leftBearing( str[0] );
//	p.drawText( x, yPos, cellWidth() - margin - x, cellHeight(), ExpandTabs, str );
	p.drawText( x, yPos, cellWidth(), cellHeight(), ExpandTabs, str );

	// ------------------------------ v1.2.1 CR mark image
	if ( mark_disp )
	{
		// word wrap & last line aren't CR
		if ( isEndOfParagraph( row ))
		{
			int w = textWidthWithTabs2( fm, str, 0, str.length(), tab_dist );
			// word wrap & last line aren't CR
			if ( row == numLines() - 1 )
				p.drawPixmap( w + margin, yPos + cellHeight() - 12, eof_pixmap );
			else
				p.drawPixmap( w + margin, yPos + cellHeight() - 12, cr_pixmap );
		}

		// ---------------------- v1.2.8 Tab & Space
		uint	i;
		int	word_which;

		for( i= 0 ; i < str.length() ; i++ )
		{
			if ( str[i] == '\t' )
				word_which = 1;
			else
				if ( str[i] == z_spc[0] )
					word_which = 2;
				else
					word_which = 0;
			if ( word_which > 0 )
			{
				int w = textWidthWithTabs2( fm, str, 0, i, tab_dist );
				if ( word_which == 1 )
					p.drawPixmap( w + margin, yPos + cellHeight() - 12, tab_pixmap );
				else
					p.drawPixmap( w + margin, yPos + cellHeight() - 12, zsp_pixmap );
			}
		}
	}

	// ------------------------------ v1.2.1 line number	v2.3.0
	if ( line_disp >= LINE_NUMBER_FRONT2 )
	{
		bool	draw_sw;
		int		d_line = 0;

		if ( cr_linenumber )
		{
			if ( ( row == 0 ) || ( isEndOfParagraph( row - 1 )) )
			{
				d_line = Row2CRLineNumber( row );
				draw_sw = true;
			}
			else
			{
				draw_sw = false;
			}
		}
		else
		{
			d_line = row;
			draw_sw = true;
		}
		if ( draw_sw )
		{
			QString num = "";
			num.sprintf( "%06d", d_line + 1 );
			QString num_str = num.right( line_disp );
			p.setPen( Qt::darkCyan );
			p.drawText( 0, yPos, margin - LINE_DISP_SPACE, cellHeight(), ExpandTabs, num_str );
		}
		p.setPen( darkGray );
		p.drawLine( margin - LINE_DISP_SPACE, yPos, margin - LINE_DISP_SPACE, yPos + fm.height() );
	}

	// ------------------------------ v1.2.5 1 byte char check & redraw
	if (( textword_disp ) && ( FileType == FILE_TEXT ))
	{
		uint	i;
		bool	word_obj;
		int	word_st;
		int	word_end;
		int	st_pos = 0;

		for( ;; )
		{
			word_obj = false;
			word_st = -1;
			word_end = -1;

			for( i= st_pos ; i < str.length() ; i++ )
			{
				if ( word_obj )
				{
					if (( str[i] < ' ' ) || ( str[i] > '~' ))
					{
						word_end = i - 1;
						break;
					}
				}
				else
				{
					if (( str[i] >= ' ' ) && ( str[i] <= '~' ))
					{
						word_st = i;
						word_obj = true;
					}
				}
			}
			st_pos = i;
			if ( word_end < word_st )
				word_end = str.length() - 1;
			if (( word_st >= 0 ) && ( word_end >= 0 ))
			{
				//---------------------------- draw characters
				int w = textWidthWithTabs2( fm, str, 0, word_st, tab_dist );
				int xpos1 = margin + w;
				p.setPen( txtc );
				QString disp_str = str.mid( word_st, word_end - word_st + 1 );
				p.drawText( xpos1,  yPos, cellWidth(), cellHeight(), ExpandTabs, disp_str );
			}
			if ( i >= str.length() )
				break;
		}
	}


	int	xx, yy;
	getCursorPosition( &yy, &xx );


	// ------------------------------ v1.2.6 reserved word check & redraw
	// ------------------------------ v1.3.2 comment check & redraw
	// ------------------------------ v1.3.3 append researved word color2
	if ( 
		(( reserved_disp[FileType]  ) && ( list.count()  > 0 ))
		 || (( reserved_disp2[FileType] ) && ( list2.count() > 0 ))
		 ||	(( reserved_disp3[FileType] ) && ( list3.count() > 0 ))
		 ||	( comment_disp[FileType] )
		)
	{
		QString	prev_str;
		QString	next_str;
		int	st_pos;
		int	end_pos;
		QColor	r_commtc;
		QColor	r_commtc2;
		QColor	r_commtc3;
		QColor	r_commcc;

		// ----------------------------------- set color
		r_commtc  = r_user_c[FileType];
		r_commtc2 = r_user_c2[FileType];
		r_commtc3 = r_user_c3[FileType];
		r_commcc  = r_user_cc[FileType];

		// ----------------------------------- check prev word wrap
		if ( row > 0 )
		{
			if ( ! isEndOfParagraph( row - 1 ))
			{
				// --------------------------- next line
				QString	*wrap_str = getString( row - 1 );
				prev_str = wrap_str->right( MAX_RESERVED_LENGTH );
			}
		}
		else
		{
			prev_str = "";
		}
		// ----------------------------------- check next word wrap
		if ( ! isEndOfParagraph( row ))
		{
			// --------------------------- next line
			QString	*wrap_str = getString( row + 1 );
			next_str = wrap_str->left( MAX_RESERVED_LENGTH );
		}
		int	org_length = str.length();

		st_pos = prev_str.length();
		end_pos = org_length + st_pos;

		QString	wk_str = prev_str + str + next_str;

		// ------------------------------------------- v1.3.2 comment draw
		if ( comment_disp[FileType] )
	 	{
			if ( comment_str.length() > 0 )
			{
				int		comment_st = -1;
				int		comment_end = -1;
				int 	commentCol;

				// -------------------------------- check prev str
				int		prev_row;
				for( prev_row= row - 1 ; prev_row >= 0 ; prev_row-- )
				{
					if ( isEndOfParagraph( prev_row ))
						break;
                }
               	prev_str = "";
               	for( int i= prev_row + 1 ; i < row ; i++ )
                   	prev_str.append( *getString( i ));

				// --------------------------------- v2.1.1 Regular Exression
				QRegExp rg( comment_str );
				if ( reg_express )
					commentCol = rg.match( prev_str, 0 );
				else
					commentCol = prev_str.find( comment_str, 0 );
				if ( commentCol >= 0 )
				{
					comment_st  = st_pos;
					comment_end = end_pos;
				}
				else
				{
					// -------------------------------- check comment str
					if ( reg_express )
						commentCol = rg.match( wk_str, 0 );
					else
						commentCol = wk_str.find( comment_str, 0 );
					if (( commentCol >= 0 ) && ( commentCol <= end_pos ))
					{
						comment_st  = QMAX( st_pos, commentCol );
						comment_end = end_pos;
					}
				}

				if ( comment_st >= 0 )
				{
					// ----------------------------- delete comment
					wk_str.remove( comment_st, comment_end - comment_st + 1 );	// not necessary to reserved word !

					comment_st  -= st_pos;
					comment_end -= st_pos;
/*------
					int w = textWidthWithTabs2( fm, str, 0, comment_st, tab_dist );
					int xpos1 = margin + w;
					p.setPen( r_commcc );
					QString disp_str = str.mid( comment_st, comment_end - comment_st + 1 );
					p.drawText( xpos1, yPos, cellWidth(), cellHeight(), ExpandTabs, disp_str );
-------*/

					// ---------------------------------- v3.4.1	start
					//	comment + '\t' : QPainter.drawText() start position is draw position
					//					can't recognize Tab code!
					int		i;
					bool	word_obj;
					int		word_st;
					int		word_end;
					int		st_pos = comment_st;

					p.setPen( r_commcc );
					for( ;; )
					{
						word_obj = false;
						word_st = -1;
						word_end = -1;

						for( i= st_pos ; i < comment_end ; i++ )
						{
							if ( word_obj )
							{
								if ( str[i] == '\t' )
								{
									word_end = i - 1;
									break;
								}
							}
							else
							{
								if ( str[i] > ' ' )
								{
									word_st = i;
									word_obj = true;
								}
							}
						}
						st_pos = i;
						if ( word_end < word_st )
							word_end = comment_end;
						if (( word_st >= 0 ) && ( word_end >= 0 ))
						{
							//---------------------------- draw characters
							int w = textWidthWithTabs2( fm, str, 0, word_st, tab_dist );
							int xpos1 = margin + w;
							QString disp_str = str.mid( word_st, word_end - word_st + 1 );
							p.drawText( xpos1,  yPos, cellWidth(), cellHeight(), ExpandTabs, disp_str );
						}
						if ( i >= comment_end )
							break;
					}
					// ---------------------------------- v3.4.1	end
				}
			}
		}

		// ------------------------------------------- get reserved word
		QStringList::Iterator	it;
		QStringList::Iterator	it_end;
		// ------------------------------------------- v1.3.3 draw twice --> 3times v2.1.1
		for( int i= 0 ; i < 3 ; i++ )
		{
			if ( i == 0 )
			{
				if (( reserved_disp[FileType] ) && ( list.count() > 0 ))
				{
					it = list.begin();
					it_end = list.end();
				}
				else
					continue;
			}
			else
			{
				if ( i == 1 )
				{
					if (( reserved_disp2[FileType] ) && ( list2.count() > 0 ))
					{
						it = list2.begin();
						it_end = list2.end();
					}
					else
						continue;
				}
				else
				{
					if (( reserved_disp3[FileType] ) && ( list3.count() > 0 ))
					{
						it = list3.begin();
						it_end = list3.end();
					}
					else
						continue;
				}
			}

			for (  ; it != it_end ; ++it )
//			for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it )
			{
				// ----------------------------------- check reserved word
				int	word_len;
				int	col = 0;
				int findCol;

				for( ;; )
				{
					// ------------------------------- v2.1.1 Regular Exression
					if ( reg_express )
					{
						// ------------------------- exception of RegExp ^
						if (( col > 0 ) && ( (*it).left( 1 ) == "^" ))
								break;

						QRegExp rg( *it );
						findCol = rg.match( wk_str, col, &word_len );
					}
					else
					{
						word_len = (*it).length();
						findCol = wk_str.find( *it, col );
					}

					if ( findCol >= 0 )
					{
						if ( findCol + word_len - 1 < st_pos )
						{
//							col += word_len;		bug fix !!! 	v2.1.5
							col = findCol + word_len;
							continue;
						}
						if ( findCol > end_pos )
							break;

						// ------ check neighbourhood ---	check half byte char
/*------ delete v2.1.5 --------------------------------------------------
						if ( is_alpha( wk_str[findCol] ))
						{
							if ( (( findCol > 0 ) && ( is_alpha( wk_str[findCol-1] )))
							 ||  (( findCol < end_pos ) && ( is_alpha( wk_str[findCol+word_len] ))) )
							{
								col += word_len;
								continue;
							}
						}
-----------------------------------------------------------------------*/
						int	st = QMAX( st_pos, findCol );
						int	end = QMIN( end_pos, findCol + word_len - 1 );
						st -= st_pos;
						end -= st_pos;

						// ----- find !!!  drraw reservrd_word from [st] to [end]
						int w = textWidthWithTabs2( fm, str, 0, st, tab_dist );
						int xpos1 = margin + w;
						if ( i == 0 )
							p.setPen( r_commtc );
						else
							if ( i == 1 )
								p.setPen( r_commtc2 );
							else
								p.setPen( r_commtc3 );
						QString disp_str = str.mid( st, end - st + 1 );
						p.drawText( xpos1, yPos, cellWidth(), cellHeight(), ExpandTabs, disp_str );

						// ----- next find
//						col += word_len;		bug fix !!!		v2.1.5
						col = findCol + word_len;
					}
					else
						break;
				}
			}
		}
	}


	if ( markX1 != markX2 )
	{
		int sLength = str.length();

		int min = QMIN( (int)str.length(), markX1 );
		int w = textWidthWithTabs2( fm, str, 0, min, tab_dist ) - 1;
		int xpos1 = margin + w;
		min = QMIN( (int)str.length(), markX2 );
		w = textWidthWithTabs2( fm, str, 0, min, tab_dist ) - 1;
		int xpos2 = margin + w;

		int fillxpos1 = xpos1;
		int fillxpos2 = xpos2;
		if ( markX1 == 0 )
			fillxpos1 -= 2;
		if ( markX2 == sLength )
			fillxpos2 += 3;
		p.setClipping( true );
		p.setClipRect( fillxpos1 - updateR.left(), 0, fillxpos2 - fillxpos1, cellHeight(row) );
		p.fillRect( fillxpos1, 0, fillxpos2 - fillxpos1, cellHeight( row ), QBrush( slc ) );
		p.setPen( Qt::white );
//		p.drawText( x,  yPos, cellWidth() - margin - x, cellHeight(), ExpandTabs, str );
		p.drawText( x,  yPos, cellWidth(), cellHeight(), ExpandTabs, str );
		p.setClipping( false );
	}

	// -------------------------------------------- vertical line v1.3.1
	if ( v_line > 0 )
	{
		int		vline_col = v_line * 5 + 5;		// 10, 15, 20, 25 ...40
		int		vline_x;
		p.setPen( QPen( Qt::darkYellow, 1, Qt::DotLine ));
		for( int i= 1 ; i < 10 ; i++ )
		{
			vline_x = margin + font_width * vline_col * i;
			if ( vline_x > MAX_VLINE_PIX )
				break;
			p.drawLine( vline_x, yPos, vline_x, yPos + fm.height() );
		}
	}


	// ------------------------------------------- v2.0.8 jump mark
	if (( jump_col >= 0 ) && ( row == jump_line ))
	{
		int w = textWidthWithTabs2( fm, str, 0, jump_col, tab_dist ) - 2;
		p.drawPixmap( w + margin, yPos, mark_pixmap );
	}


	// -------------------------------------------- cursor
	if ( row == yy && cursorOn && ! isReadOnly() )
	{
		int cursorPos = QMIN( (int)str.length(), xx );
		int w2 = textWidthWithTabs2( fm, str, 0, cursorPos, tab_dist );
		int w1 = w2 - 1;
		int w4 = textWidthWithTabs2( fm, str, 0, cursorPos+1, tab_dist );
//		int w3 = w4 - 1;

		// -----------------------------------------
		//  w1w2      w3w4
		//   ||        ||
		//   VV        VV
		//    +--------+ <-- cYPos
		//    |        |
		//    |        |
		//    +--------+ <-- cYPos + fm.height()
		// -----------------------------------------
		QColor	cc_sub;
		if ( overwrite_which )
			cc_sub = Qt::darkGray;
		else
			cc_sub = cc;

		int cXPos;
		int cXPos2;
		int cYPos   = 0;
		if ( hasFocus() )
		{
			// --------------------------------- "|"
			if ( cursor_style <= 5 )
			{
				cXPos = margin + w1;
				p.setPen( QPen( cc_sub, cursor_style ) );
				p.drawLine( cXPos, cYPos, cXPos, cYPos + fm.height() - 2 );
			}
			else
			{
				switch( cursor_style )
				{
					// -------------------------- ""
					case 6 :
							cXPos = margin + w1;
							if (( str.length() > 0 ) && ( (unsigned int)xx < str.length() ))
								cXPos2 = margin + w4;
							else
								cXPos2 = cXPos + 5;
							p.setPen( QPen( cc_sub, 1 ) );
//							p.drawLine( cXPos, cYPos, cXPos, cYPos + fm.height() - 2 );
//							p.drawLine( cXPos2, cYPos, cXPos2, cYPos + fm.height() - 2 );
//							p.drawLine( cXPos, cYPos, cXPos2, cYPos );
//							p.drawLine( cXPos, cYPos + fm.height() - 1, cXPos2, cYPos + fm.height() - 1 );
							p.drawRect( cXPos, cYPos, cXPos2 - cXPos, fm.height() - 2 );
							break;
					// -------------------------- ""
					case 7 :
							cXPos = margin + w2;
							if (( str.length() > 0 ) && ( (unsigned int)xx < str.length() ))
								cXPos2 = margin + w4;
							else
								cXPos2 = cXPos + 5;
							p.fillRect( cXPos, cYPos, cXPos2 - cXPos, cYPos + fm.height() - 1, cc_sub );

							if (( str.length() > 0 ) && ( (unsigned int)xx < str.length() ))	// avoid new file and CR code
							{
								if (( cc == Qt::green ) || ( cc == Qt::cyan ) || ( cc == Qt::yellow ) || ( cc == Qt::white ))
									p.setPen( Qt::red );
								else
									p.setPen( Qt::white );
								p.drawText( cXPos,  yPos, cXPos2 - cXPos, cellHeight(), ExpandTabs, str.mid( xx, 1 ), 1 );
							}
							break;
					// -------------------------- "" : width= 3
					case 8 :
							cXPos = margin + w1;
							p.setPen( QPen( cc_sub, 3 ) );
							p.drawLine( cXPos, cYPos, cXPos, cYPos + fm.height() - 2 );
							p.setPen( QPen( cc_sub, 2 ) );
							p.drawLine( cXPos - 5, cYPos + 1, cXPos + 4, cYPos + 1 );
							p.drawLine( cXPos - 5, cYPos + fm.height() - 3, cXPos + 4, cYPos + fm.height() - 3 );
							break;
					// -------------------------- "" : width= 3
					case 9 :
							cXPos = margin + w1;
							p.setPen( QPen( cc_sub, 4 ) );
							p.drawLine( cXPos + 3, cYPos, cXPos - 2, cYPos + fm.height() - 2 );
							break;
				}
			}
		}
	}
	p.end();
	painter->drawPixmap( updateR.left(), updateR.top(), *buffer2, 0, 0, updateR.width(), updateR.height() );
}






private:
	QString		word_buf;
	QString		marked_buf;
	bool		textword_disp;

	bool		reserved_disp[MAX_FILE_COLOR];
	bool		reserved_disp2[MAX_FILE_COLOR];
	bool		reserved_disp3[MAX_FILE_COLOR];
	bool		comment_disp[MAX_FILE_COLOR];

	bool		overwrite_which;
	bool		auto_indent;
	bool		separateKanaKanji;
	bool		reg_express;
	bool		read_only_flg;		// v3.5.0
	QString		comment_txt;
	QString		comment_user1;
	QString		comment_str;
	int			bk_num;
	int			cursor_line;
	int			cursor_style;
	int			line_disp;
	bool		cr_linenumber;
	int			mark_disp;
	int			v_line;
	int			jump_col;
	int			jump_line;
	QString		z_spc;
	QColor		cc;
	QColor		clc;
	QColor		slc;
	QColor		txtc;
	QColor		r_user_c[MAX_FILE_COLOR];
	QColor		r_user_c2[MAX_FILE_COLOR];
	QColor		r_user_c3[MAX_FILE_COLOR];
	QColor		r_user_cc[MAX_FILE_COLOR];
	QPixmap		cr_pixmap;
	QPixmap		eof_pixmap;
	QPixmap		mark_pixmap;
	QPixmap		tab_pixmap;
	QPixmap		zsp_pixmap;
	QStringList	list;
	QStringList	list2;
	QStringList	list3;
};


// --------------------------------------------- v2.0.0 auto select words
int	QpeEditor::getCharType( QString c )
{
	QTextCodec *codec = QTextCodec::codecForName( "eucJP" );

	if ( c == "\t" )
		return( CHAR_1B_TAB );
	if ( c == " " )
		return( CHAR_1B_SPACE );
	if ( c < " " )
		return( CHAR_1B_OTHER );
	if (( c >= "0" ) && ( c <= "9" ))
		return( CHAR_1B_NUM );
	if (( c >= "A" ) && ( c <= "Z" ))
		return( CHAR_1B_ALPHA_UPP );
	if (( c >= "a" ) && ( c <= "z" ))
		return( CHAR_1B_ALPHA_LOW );

	if ( c <= "~" )
		return( CHAR_1B_SYMBOL );
	else
		if (( c >= codec->toUnicode( "" )) && ( c <= codec->toUnicode( "" )))
			return( CHAR_1B_KANA );
		else
			if ( c <= codec->toUnicode( " " ) )
				return( CHAR_1B_OTHER );

	if ( c == codec->toUnicode( "" ) )
		return( CHAR_2B_JP_SPACE );

	if (( c >= codec->toUnicode( "" ) ) && ( c <= codec->toUnicode( "" )))
		return( CHAR_2B_NUM );
	if (( c >= codec->toUnicode( "" )) && ( c <= codec->toUnicode( "" )))
		return( CHAR_2B_ALPHA_UPP );
	if (( c >= codec->toUnicode( "" )) && ( c <= codec->toUnicode( "" )))
		return( CHAR_2B_ALPHA_LOW );

	if (( c >= codec->toUnicode( "" )) && ( c <= codec->toUnicode( "" )))
		return( CHAR_2B_JP_KANA );
	if (( c >= codec->toUnicode( "" )) && ( c <= codec->toUnicode( "" )))
		return( CHAR_2B_JP_KATAKANA );

	if (( c >= codec->toUnicode( "" )) && ( c <= codec->toUnicode( "" )))
		return( CHAR_2B_JP_SYMBOL );
	if (( c >= codec->toUnicode( "" )) && ( c <= codec->toUnicode( "" )))
		return( CHAR_2B_SYMBOL );

	return( CHAR_2B_JP_KANJI );
}

void QpeEditor::autoSelectWords()
{
	int		line1;
	int		line2;
	int		col1;
	int		col2;
	QString	*str;


	if ( ! getMarkedRegion( &line1, &col1, &line2, &col2 ))
	{
		getCursorPosition( &line1, &col1 );
		str = getString( line1 );
		int		st_def_type = getCharType( str->mid( col1, 1 ) );

		// --------------------- get start position
		if (( st_def_type <= CHAR_1B_SPACE ) || ( st_def_type == CHAR_2B_JP_SPACE ))
		{
			int		i;
			int		next_type;
			for( i= col1 + 1 ; i < (int)str->length() ; i++ )
        	{
				next_type = getCharType( str->mid( i, 1 ) );
				if ( st_def_type != next_type )
					break;
        	}
 	       if ( i >= (int)str->length() )
				col2 = col1;
			else
				col2 = col1 = i;
		}
		else	// check prev words
		{
			int		i;
			int		prev_type;
			for( i= col1 - 1 ; i >= 0 ; i-- )
        	{
				prev_type = getCharType( str->mid( i, 1 ) );
				if (( st_def_type / 10 == 1 ) && ( prev_type  / 10 == 1 ))
					continue;
				if (( st_def_type / 100 == 1 ) && ( prev_type  / 100 == 1 ))
					continue;
				if ( ! separateKanaKanji )
					if (( st_def_type / 100 == 6 ) && ( prev_type  / 100 == 6 ))
						continue;
				if ( st_def_type != prev_type )
					break;
        	}
 	       if ( i < 0 )
				col2 = col1 = 0;
			else
				col2 = col1 = i + 1;
        }
		line2 = line1;
	}

	str = getString( line2 );
	int		st_char_type = getCharType( str->mid( col2, 1 ) );
	int		len = str->length();
	bool	end_sw = false;
	col2++;
	for( ;; )
    {
    	if ( col2 >= len )
    	{
    		if ( ! isEndOfParagraph( line2 ))
    		{
    			col2 = 0;
    			line2++;
				str = getString( line2 );
    		}
    		else
    			break;
    	}
		int	char_type = getCharType( str->mid( col2, 1 ) );
		switch( st_char_type )
		{
			case CHAR_1B_TAB		 :
			case CHAR_1B_SPACE		 :
			case CHAR_2B_JP_SPACE	 :
//						if (( char_type == CHAR_1B_TAB ) || ( char_type == CHAR_1B_SPACE ) || ( char_type == CHAR_2B_JP_SPACE ))
						if (( char_type < 10 ) || ( char_type == CHAR_2B_JP_SPACE ))
							break;
						end_sw = true;
						break;

			case CHAR_1B_NUM		 :
			case CHAR_1B_ALPHA_UPP	 :
			case CHAR_1B_ALPHA_LOW	 :
//						if (( char_type == CHAR_1B_NUM ) || ( char_type == CHAR_1B_ALPHA_UPP ) || ( char_type == CHAR_1B_ALPHA_LOW ))
						if ( char_type  / 10 == 1 )
							break;
						end_sw = true;
						break;

			case CHAR_1B_SYMBOL		 :
						if ( char_type == CHAR_1B_SYMBOL )
							break;
						end_sw = true;
						break;

			case CHAR_1B_KANA		 :
						if ( char_type == CHAR_1B_KANA )
							break;
						end_sw = true;
						break;

			case CHAR_1B_OTHER		 :
						if ( char_type == CHAR_1B_OTHER )
							break;
						end_sw = true;
						break;

			case CHAR_2B_NUM		 :
			case CHAR_2B_ALPHA_UPP	 :
			case CHAR_2B_ALPHA_LOW	 :
//						if (( char_type == CHAR_2B_NUM ) || ( char_type == CHAR_2B_ALPHA_UPP ) || ( char_type == CHAR_2B_ALPHA_LOW ))
						if ( char_type / 100 == 1 )
							break;
						end_sw = true;
						break;

			case CHAR_2B_SYMBOL		 :
						if ( char_type == CHAR_2B_SYMBOL )
							break;
						end_sw = true;
						break;

			case CHAR_2B_JP_KANA	 :
			case CHAR_2B_JP_KANJI	 :
						if ( separateKanaKanji )
						{
							if ( st_char_type == char_type )
								break;
						}
						else
						{
//							if (( char_type == CHAR_2B_JP_KANA ) || ( char_type == CHAR_2B_JP_KANJI ))
							if ( char_type / 100 == 6 )
								break;
						}
						end_sw = true;
						break;

			case CHAR_2B_JP_KATAKANA :
						if ( char_type == CHAR_2B_JP_KATAKANA )
							break;
						end_sw = true;
						break;

			case CHAR_2B_JP_SYMBOL	 :
						if ( char_type == CHAR_2B_JP_SYMBOL )
							break;
						end_sw = true;
						break;
		}
		if ( end_sw )
			break;
    	col2++;
    }
    if ( col2 < 0 )
    {
    	line2--;
    	col2 = getString( line2 )->length();
	}
	setSelection( line1, col1, line2, col2 );
}


// ----------------------------------------------------------- Duplicate
void QpeEditor::lineDuplicate()
{
	int  line, col;

	getCursorPosition ( &line, &col );
	QString *txt = getString( line );
	insertLine( *txt, line );
}





// ------------------------------- v3.0.0
void QpeEditor::moveCursorCenter( int line )
{
	int		max_line = 0;
	if ( height() > 400 )
		max_line = ( height() - 36 ) / ( font().pointSize() + 2 );
	else
		if ( height() > 100 )
			max_line = ( height() - 24 ) / ( font().pointSize() + 2 );
	setCursorPosition( line + max_line / 2, 0, false );
}


// -------------------------------- v3.0.0 support backwords
void QpeEditor::find ( const QString &f_str, int caseSensitive,	bool backwords )
{
	static bool st_sw = true;
	int line, col, f_line;
	bool	reg_express;
	bool	regexp_top = false;
	bool	regexp_end = false;

	if ( st_sw )
	{
		if ( backwords )
			getCursorPosition( &line, &col );
		else
			line = col = 0;

		st_sw = false;
		//	emit search start;
	}
	else
	{
		getCursorPosition( &line, &col );
	}
	if ( backwords )
	{
		col--;
		if ( col < 0 )
			line--;
	}

	if ( caseSensitive % 2 == 1 )
		reg_express = true;
	else
		reg_express = false;

	// ------------------------- exception of RegExp ^
	if (( reg_express ) && ( f_str.left( 1 ) == "^" ))
	{
		if (( col > 0 ) && ( ! backwords ))
		{
			line++;		// next line!!! important!!!
			col = 0;
		}
	}
	// ------------------------- exception of RegExp $
	if (( reg_express ) && ( f_str.right( 1 ) == "$" ))
		regexp_end = true;

	// ------------------------------------- v1.3.5 append regular expression
	bool	case_sensitive;
	if ( caseSensitive < 2 )
		case_sensitive = false;
	else
		case_sensitive = true;

	// v3.0.0 support backwords
	if ( backwords )
	{
		for ( ; ; )
		{
			if ( line < 0 )
			{
				st_sw = true;
				//emit notFound();
				break;
			}

			// ------------------------- exception of RegExp ^, $
			if ( line > 0 )
			{
				if (( ! isEndOfParagraph( line - 1 )) && ( regexp_top ))
				{
					line--;
					col = -1;
					continue;
				}
			}
			if (( ! isEndOfParagraph( line )) && ( regexp_end ))
			{
					line--;
					col = -1;
					continue;
			}

			QString	line_txt = *getString( line );
			int	org_length = line_txt.length();

			// ----------------------------------- check word wrap v1.2.2
			if ( line > 0 )
				if ( ! isEndOfParagraph( line - 1 ))
					line_txt.insert( 0, *getString( line - 1 ));

			int	org_col = line_txt.length() - org_length;	// start pos of original
			if ( col < 0 )
				col = line_txt.length();					// set end of position

			// ----------------------------------- check regular expreesion v1.3.5
			int fstr_len;
			int findCol;
			if ( reg_express )
			{
				QRegExp rg( f_str );
				findCol = line_txt.findRev( rg, col );
				rg.match( line_txt, findCol, &fstr_len );
			}
			else
			{
				findCol = line_txt.findRev( f_str, col, case_sensitive );
				fstr_len = f_str.length();
			}
			if ( findCol >= 0 )
			{
				// ------------------------------- v1.3.6 move cursor to center
				moveCursorCenter( line );

				// ------------------- select from last char to start char
				if ( findCol + fstr_len < org_col )
				{
					col = findCol + fstr_len;
					f_line = line - 1;
				}
				else
				{
					col = findCol + fstr_len - org_col;
					f_line = line;
				}
				setCursorPosition( f_line, col, false );

				int		st_line;
				if ( findCol < org_col )
				{
					col = findCol;
					st_line = line - 1;
				}
				else
				{
					col = findCol - org_col;
					st_line = line;
				}
				setCursorPosition( st_line, col, true );

				//found = true;
				break;
			}
			line--;
			col = -1;
		}
	}
	else	// --------------------------------- next search
	{
		for ( ; ; )
		{
			if ( line >= numLines() )
			{
				st_sw = true;
				//emit notFound();
				break;
			}

			// ------------------------- exception of RegExp ^, $
			if ( line > 0 )
			{
				if (( ! isEndOfParagraph( line - 1 )) && ( regexp_top ))
				{
					line++;
					col = 0;
					continue;
				}
			}
			if (( ! isEndOfParagraph( line )) && ( regexp_end ))
			{
					line++;
					col = 0;
					continue;
			}

			QString	line_txt = *getString( line );
			int	org_length = line_txt.length();
			// ----------------------------------- check word wrap v1.2.2
			if ( ! isEndOfParagraph( line ))
				line_txt.append( *getString( line + 1 ));

			// ----------------------------------- check regular expreesion v1.3.5
			int fstr_len;
			int findCol;
			if ( reg_express )
			{
				QRegExp rg( f_str );
				findCol = rg.match( line_txt, col, &fstr_len );
			}
			else
			{
				findCol = line_txt.find( f_str, col, case_sensitive );
				fstr_len = f_str.length();
			}
			if ( findCol >= 0 )
			{
				// ------------------------------- v1.3.6 move cursor to center
				moveCursorCenter( line );

				int		st_line;
				if ( findCol < org_length )
					st_line = line;
				else
					st_line = line + 1;
				setCursorPosition( st_line, findCol, false );

				if ( findCol + fstr_len <= org_length )
				{
					col = findCol + fstr_len;
					f_line = line;
				}
				else
				{
					col = findCol + fstr_len - org_length;
					f_line = line + 1;
				}
				setCursorPosition( f_line, col, true );

				//found = true;
				break;
			}
			line++;
			col = 0;
		}
	}
}



// ----------------------------------------------------------- replace
int QpeEditor::replace ( const QString &old_str, const QString &new_str, int caseSensitive, bool which_from, bool which_each )
{
	int 	line, col, f_line;
	int 	count= 0;
	bool	regexp_top = false;
	bool	regexp_end = false;
//	QTextCodec *codec = QTextCodec::codecForName( "eucJP" );

	// ------------------------------------- v1.3.5 append regular expression
	bool	case_sensitive;
	bool	reg_express;
	if ( caseSensitive < 2 )
		case_sensitive = false;
	else
		case_sensitive = true;

	if ( caseSensitive % 2 == 1 )
		reg_express = true;
	else
		reg_express = false;

	// ------------------------- start position
	if ( which_from )
		getCursorPosition( &line, &col );
	else
		line = col = 0;

	// ------------------------- exception of RegExp ^
	if (( reg_express ) && ( old_str.left( 1 ) == "^" ))
	{
		col = 0;
		regexp_top = true;
	}
	// ------------------------- exception of RegExp $
	if (( reg_express ) && ( old_str.right( 1 ) == "$" ))
		regexp_end = true;

	for ( ; ; )
	{
		if ( line >= numLines() )
			break;

		QString *rec = getString( line );
		for ( ;; )
		{
			if ( line > 0 )
				if (( ! isEndOfParagraph( line - 1 )) && ( regexp_top ))
					break;
			if (( ! isEndOfParagraph( line )) && ( regexp_end ))
					break;
//			int findCol = rec->find( old_str, col, case_sensitive );
			// ----------------------------------- check regular expreesion v1.3.5
			int old_len;
			int findCol;
			if ( reg_express )
			{
				QRegExp rg( old_str );
				findCol = rg.match( *rec, col, &old_len );
			}
			else
			{
				findCol = rec->find( old_str, col, case_sensitive );
				old_len = old_str.length();
			}

			if ( findCol >= 0 )
			{
				// confirm to replace!!!
				if ( which_each )
				{
					setCursorPosition( line, findCol, false );
					col = findCol + old_len;
					setCursorPosition( line, col, true );

/*-------------- ----> ConfirmDialog v1.2.8
// ???? Yes, Cancel : call twice !!!
//					 QMessageBox mb( codec->toUnicode("ZEditor ִ"), codec->toUnicode( "֤ޤ" ), QMessageBox::NoIcon, QMessageBox::Yes | QMessageBox::Default, QMessageBox::No, QMessageBox::Cancel | QMessageBox::Escape );

		int ret = QMessageBox::information( this, codec->toUnicode("ZEditor ִ"), codec->toUnicode( "֤ޤ" ), "OK", "No", "Cancel", 0, 2 );

					if ( ret == 1 )		// No
					{
						col = findCol + old_str.length();
						continue;
					}
					else
					{
						if ( ret == 2 )		// Cancel
							return( count );
					}
---------------*/
					ConfirmDialog confirmDialog( this, "", true, 0 );
					if ( confirmDialog.exec() == QDialog::Accepted )
					{
						if ( confirmDialog.selected == false )		// No
						{
							// ----------------------- replace only onece for RegularExpression ^, $
							if ( regexp_top )
								break;
							col = findCol + old_len;
							if ( old_len == 0 )		// next col
								col++;

							continue;
						}
						else
						{
							if ( confirmDialog.selected == -1 )	// Cancel
								return( count );
						}
					}
					else
					{
						return( count );		// Cancel
					}
				}
				// replace from old_str to new_str
				rec->replace( findCol, old_len, new_str );
				count++;
				col = findCol + new_str.length();
				// ------------------------------ replace only onece for RegularExpression ^, $
				if ( regexp_top )
					break;
				if ( old_len == 0 )
					col++;
			}
			else
			{
				break;
			}
		}
		// ----------------------------------- check word wrap v1.2.2
		if (( ! isEndOfParagraph( line )) && ( ! regexp_top ))
		{
			QString	line_txt = *getString( line );
			int	org_length = line_txt.length();
			// --------------------------- next line
			QString	*wrap_str = getString( line + 1 );
//			QString	left_str = wrap_str->left( old_str.length() - 1 );
			line_txt.append( *wrap_str );

//			int findCol = line_txt.find( old_str, col, case_sensitive );
			// ----------------------------------- check regular expreesion v1.3.5
			int old_len;
			int findCol;
			if ( reg_express )
			{
				QRegExp rg( old_str );
				findCol = rg.match( line_txt, col, &old_len );
			}
			else
			{
				findCol = line_txt.find( old_str, col, case_sensitive );
				old_len = old_str.length();
			}

			if (( findCol >= 0 ) && ( findCol < org_length ) && ( old_len > 0 ))
			{
				col = findCol + old_len - org_length;
				f_line = line + 1;

				if ( which_each )
				{
					setCursorPosition( line, findCol, false );
					setCursorPosition( f_line, col, true );
/*-------------- ----> ConfirmDialog v1.2.8
					int ret = QMessageBox::information( this, codec->toUnicode("ZEditor ִ"), codec->toUnicode( "֤ޤ" ), "OK", "No", "Cancel", 0, 2 );
					if ( ret == 1 )		// No
					{
						break;
					}
					else
					{
						if ( ret == 2 )		// Cancel
							return( count );
					}
---------------------*/
					ConfirmDialog confirmDialog( this, "", true, 0 );
					if ( confirmDialog.exec() == QDialog::Accepted )
					{
						if ( confirmDialog.selected == false )		// No
						{
							break;
						}
						else
						{
							if ( confirmDialog.selected == -1 )	// Cancel
								return( count );
						}
					}
				}
				// replace from old_str to new_str
				rec->replace( findCol, org_length - findCol, new_str );
				QString	*next_rec = getString( line + 1 );
				next_rec->remove( 0, col );
				count++;
			}
		}
		line++;
		col = 0;
	}
	return( count );
}

// ---------------------------------- get the word for [find] and [replace] 
QString QpeEditor::getCursorWord( int cursorword )
{

	// -------------------------- get the word from cursor position
	// 2005.08.20 Don't move !!!
	if ( cursorword == 2 )
	{
		word_buf = markedText();
	}
	else
	{
		QString		c_str = QApplication::clipboard()->text();

		if ( ( cursorword == 1 )
		 ||  (( cursorword == 3 )  && ( c_str.length() == 0 )) )
		{
			int line, col;

			getCursorPosition( &line, &col );
			QString buf = getString( line )->copy();
			word_buf = buf.right( buf.length() - col );
			word_buf.simplifyWhiteSpace();
			int pos = word_buf.find( " " );
			if ( pos >= 0 )
				word_buf.truncate( pos );
			else
				word_buf.truncate( 10 );       // max length
		}
		// -------------------------- get the word from marked text
		else	// cursorword is 3
		{
			// v3.5.0 from clipboard
			word_buf = c_str.left( 30 );	// max 50
		}
	}
	return( word_buf );
}

// ---------------------------------- get the word for char count
QString QpeEditor::getMarkedWord()
{
	// -------------------------- get the word from marked text
	marked_buf = markedText();
	return( marked_buf );
}

void QpeEditor::overwrite()
{
	if ( overwrite_which )
		overwrite_which = false;
	else
		overwrite_which = true;
	setOverwriteMode( overwrite_which );
}
// ----------------------------------- default cut & copy mark	v2.2.1
void QpeEditor::defaultLineMark()
{
	// ----------------- already marked
	if ( hasMarkedText())
		return;

	int line1, col1;
	int line2, col2;

	getCursorPosition( &line1, &col1 );
	if ( line1 == numLines() - 1 )		// last line
	{
		line2 = line1;
    	col2 = getString( line1 )->length();
	}
	else
	{
		line2 = line1 + 1;
		col2 = 0;
	}

	col1 = 0;
	setSelection( line1, col1, line2, col2 );
}

// -------------------------------------------- v3.0.0 Tab, ShiftTab indent
bool	QpeEditor::insertTabIndent()
{
	int		line1, col1, line2, col2;

	if ( getMarkedRegion ( &line1, &col1, &line2, &col2 ) )
	{
		int		line_num;
		for( line_num= line1 ; line_num <= line2 ; line_num++ )
		{
			if (( line_num == 0 ) || ( isEndOfParagraph( line_num - 1 )))
			{
				insertAt( "\t", line_num, 0, false );
			}
		}
		return( true );
	}
	return( false );
}

bool	QpeEditor::removeTabIndent()
{
	int		line1, col1, line2, col2;
	QKeyEvent	ke_b( QEvent::KeyPress, Qt::Key_BackSpace, 0, 0 );

	if ( getMarkedRegion( &line1, &col1, &line2, &col2 ) )
	{
		int		line_num;
		QString	*str;
		for( line_num= line1 ; line_num <= line2 ; line_num++ )
		{
			if (( line_num == 0 ) || ( isEndOfParagraph( line_num - 1 )))
			{
				str = getString( line_num );
				if ( str->left( 1 ) == "\t" )
				{
//					str->remove( 0, 1 );		out of the object of "undo"
					setCursorPosition( line_num, 1, false );
					QApplication::sendEvent( this, &ke_b );
				}
			}
		}
		setCursorPosition( line1, col1, false );
		setCursorPosition( line2, col2, true );
		return( true );
	}
	return( false );
}


#else

#error "Must make a QpeEditor that inherits QTextEdit"

#endif




static int u_id = 1;
static int get_unique_id()
{
    return u_id++;
}



TextEdit::TextEdit( QString baseName, QWidget *parent, const char *name, WFlags f )
    : QMainWindow( parent, name, f ), bFromDocView( false )
{
    doc = 0;
//    listF.setAutoDelete( true );      // v1.0.0  insert( index,.. ), take( index ) not correct!!!

	// ------------------------------- v1.3.1a  Don't move!!! ( 2003.10.11 Mr.inue )
	connect( qApp, SIGNAL(appMessage( const QCString&, const QByteArray&)), this, SLOT( qcop_receive( const QCString&, const QByteArray& )));


    setToolBarsMovable( false );

    QPEToolBar *bar = new QPEToolBar( this );
    bar->setHorizontalStretchable( true );
    menu = bar;

    menuBar = new QPEMenuBar( bar );
    popFile = new QPopupMenu( this );
    popEdit = new QPopupMenu( this );
    popView = new QPopupMenu( this );

    bar = new QPEToolBar( this );
    editBar = bar;


	arg0_baseName = baseName;
	int defsize;
	{
		int		i;
		Config cfg( arg0_baseName );		// v2.0.1
//		Config cfg( "ZEditor" );

		// -----------------------
		// [Key]	v2.2.0
		// -----------------------
		cfg.setGroup( "Key" );
		sp_key.ctrl_enter  = cfg.readNumEntry( "KeyCtrlEnter", 0 );
		sp_key.ctrl_space  = cfg.readNumEntry( "KeyCtrlSpace", 0 );
		sp_key.shift_enter = cfg.readNumEntry( "KeyShiftEnter", 0 );
		sp_key.shift_space = cfg.readNumEntry( "KeyShiftSpace", 0 );
		sp_key.fn_N        = cfg.readNumEntry( "KeyFn_N", 0 );
		sp_key.fn_M        = cfg.readNumEntry( "KeyFn_M", 0 );
		sp_key.fn_O        = cfg.readNumEntry( "KeyFn_O", 0 );
		sp_key.fn_P        = cfg.readNumEntry( "KeyFn_P", 0 );
		sp_key.fn_A        = cfg.readNumEntry( "KeyFn_A", 0 );
		sp_key.fn_S        = cfg.readNumEntry( "KeyFn_S", 0 );

		// -----------------------
		// [View]
		// -----------------------
		cfg.setGroup( "View" );
		defsize       = cfg.readNumEntry( "FontSize", 10 );
		word_wrap     = cfg.readBoolEntry( "Wrap", false );
		wrap_method   = cfg.readNumEntry( "WrapMethod", false );
		auto_indent   = cfg.readBoolEntry( "AutoIndent", false );
		cursorword    = cfg.readNumEntry( "CursorWord", 1 );
		movecursor    = cfg.readBoolEntry( "MoveCursor", true );
//		selectedcursor= cfg.readBoolEntry( "SelectedCursor", true );
		windateform   = cfg.readNumEntry( "WinDateForm", 0 );
		shortcutkey   = cfg.readBoolEntry( "ShortCutKey", true );
		backcolor     = cfg.readNumEntry( "BackColor", 0 );
		textcolor     = cfg.readNumEntry( "TextColor", 0 );
		if ( backcolor > 7 )
			backcolor = 0;
		else
			if (( backcolor == 7 ) && ( textcolor == 0 ))	// black
				textcolor = 4;
		if (( backcolor == 0 ) && ( textcolor == 4 ))	// white!!
			textcolor = 0;
		cursor_draw       = cfg.readNumEntry( "CursorDraw", 0 );
		cursor_color      = cfg.readNumEntry( "CursorColor2", 0 );
		cursor_line_color = cfg.readNumEntry( "CursorColor", 0 );
		if ( cursor_line_color > 8 )
			cursor_line_color = 1;
		cursor_style = cfg.readNumEntry( "CursorWidth", 2 );
		if (( cursor_style < 1 ) || ( cursor_style > 9 ))
			cursor_style = 2;
		selected_color   = cfg.readNumEntry( "SelectedColor", 0 );
		vertical_line    = cfg.readNumEntry( "VerticalLine", 0 );
		scrollbar_disp   = cfg.readNumEntry( "ScrollBarDisp", 0 );
		cr_code          = cfg.readNumEntry( "AppendCRCode", 0 );
		c_sensitive      = cfg.readNumEntry( "CaseSensitive", 0 );
		incremental_s    = cfg.readBoolEntry( "IncrementalSearch", true );
		tablength        = cfg.readNumEntry( "TabLength", 0 );
		if (( tablength < 2 ) || ( tablength > 8 ))
			tablength = 8;

		input_codec      = cfg.readNumEntry( "InputCodec", 0 );
		if (( input_codec < 0 ) || ( input_codec > 6 ))
			input_codec = 0;
		output_codec      = cfg.readNumEntry( "OutputCodec", 0 );
		if (( output_codec < 0 ) || ( output_codec > 6 ))
			output_codec = 0;

		line_number      = cfg.readNumEntry( "LineNumber", 0 );
		line_number_cr   = cfg.readBoolEntry( "LineNumberCr", 0 );
		cr_markdisp      = cfg.readNumEntry( "CRMarkDisp", 0 );

		icon_new    = cfg.readBoolEntry( "IconNew",  false );
		icon_open   = cfg.readBoolEntry( "IconOpen", true );
		icon_save   = cfg.readBoolEntry( "IconSave", true );
		icon_cut    = cfg.readBoolEntry( "IconCut",  true );
		icon_copy   = cfg.readBoolEntry( "IconCopy", true );
		icon_paste  = cfg.readBoolEntry( "IconPaste",true );
		icon_find   = cfg.readBoolEntry( "IconFind", true );
		icon_nfind  = cfg.readBoolEntry( "IconNFind",false );

		// ----------------------------- v2.0.3 timer interval
		time_interval = cfg.readNumEntry( "AutoSave", 0 );	// 1 - 60
		if (( time_interval < 0 ) || ( time_interval > 60 ))
			time_interval = 0;
		autosave_dir = cfg.readEntry( "AutoSaveDir",   "/home/zaurus/Documents/Text_Files/" );

		// ----------------------------- v2.0.3 small dialog
		is_small = cfg.readBoolEntry( "SmallSaveDialog",  false );
		// ----------------------------- v2.0.4 viewstyle : OK ---> Enter
		ok_is_enter = cfg.readBoolEntry( "OKisEnter",  false );

		// ----------------------------- v2.0.8 Ctrl + up, down
		ctrl_up     = cfg.readNumEntry( "CtrlUpSelect", 0 );
		ctrl_down   = cfg.readNumEntry( "CtrlDownSelect", 0 );

		// ----------------------------- v1.3.5b [Top] button
		appendFileExtension = cfg.readBoolEntry( "AppendFileExtension", false );

		// ----------------------------- v2.0.0 auto select of Kana Kanji
		separateKanaKanji = cfg.readBoolEntry( "SeparateKanaKanji", false );

		icon_nw_name = cfg.readEntry( "IconNewName",   "new" );
		icon_op_name = cfg.readEntry( "IconOpenName",  "slfolder" );
		icon_sv_name = cfg.readEntry( "IconSaveName",  "rec" );
		icon_ct_name = cfg.readEntry( "IconCutName",   "cut" );
		icon_cp_name = cfg.readEntry( "IconCopyName",  "copy" );
		icon_ps_name = cfg.readEntry( "IconPasteName", "paste" );
		icon_fd_name = cfg.readEntry( "IconFindName",  "find" );
		icon_nf_name = cfg.readEntry( "IconNFindName", "down" );

		userJumpU = cfg.readEntry( "UserJumpU", "/var/mnt/card/Documents" );
		userJumpJ = cfg.readEntry( "UserJumpJ", "/var/mnt/cf/Documents" );
		// ----------------------------- v3.3.0
		userJumpMnt  = cfg.readEntry( "UserJumpMnt" );
		userJumpHome = cfg.readEntry( "UserJumpHome" );
		userJumpText = cfg.readEntry( "UserJumpText" );
		userJumpUser = cfg.readEntry( "UserJumpUser" );

		// ----------------------------- v2.1.7 save fast UTF-8
		save_fast = cfg.readBoolEntry( "SaveFastUTF8",  false );

		default_cutcopy = cfg.readBoolEntry( "DefCutAndCopy", false );

		// ----------------------------- v2.3.2 toggle switch for mark cursor position
		markpos_toggle = cfg.readBoolEntry( "MarkPosToggle", false );

		// ----------------------------- append v3.1.0	font
		family_name = cfg.readEntry( "FontFamilyName", font().family() );
//		family_name = cfg.readEntry( "FontFamilyName", "lcfont" );

		// ----------------------------- append v3.5.0	font
		history_clear	= cfg.readBoolEntry( "HistoryClear", false );
		read_only		= cfg.readBoolEntry( "ReadOnly", false );

		// ----------------------------- append v3.1.0	search words
		for( i= 1 ; i <= MAX_SEARCH_COUNT ; i++ )
		{
			char  buf[21];
			sprintf( buf, "SearchWords%d", i );
			search_words[i] = cfg.readEntry( buf, "" );
		}

		// -----------------------
		// [LastFile]
		// -----------------------
		cfg.setGroup( "LastFile" );
		last_file = cfg.readEntry( "LastFile1" );     // only 1 fiel. set last file dir

		listF.itemSet( 0, cfg.readEntry( "LastFile1", "dummy" ), cfg.readNumEntry( "LastFile1_col", -1 ), cfg.readNumEntry( "LastFile1_line", -1 ), cfg.readNumEntry( "LastFile1_color", 0 ) );
		listF.itemSet( 1, cfg.readEntry( "LastFile2", "dummy" ), cfg.readNumEntry( "LastFile2_col", -1 ), cfg.readNumEntry( "LastFile2_line", -1 ), cfg.readNumEntry( "LastFile2_color", 0 ) );
		listF.itemSet( 2, cfg.readEntry( "LastFile3", "dummy" ), cfg.readNumEntry( "LastFile3_col", -1 ), cfg.readNumEntry( "LastFile3_line", -1 ), cfg.readNumEntry( "LastFile3_color", 0 ) );
		listF.itemSet( 3, cfg.readEntry( "LastFile4", "dummy" ), cfg.readNumEntry( "LastFile4_col", -1 ), cfg.readNumEntry( "LastFile4_line", -1 ), cfg.readNumEntry( "LastFile4_color", 0 ) );
		listF.itemSet( 4, cfg.readEntry( "LastFile5", "dummy" ), cfg.readNumEntry( "LastFile5_col", -1 ), cfg.readNumEntry( "LastFile5_line", -1 ), cfg.readNumEntry( "LastFile5_color", 0 ) );
		listF.itemSet( 5, cfg.readEntry( "LastFile6", "dummy" ), cfg.readNumEntry( "LastFile6_col", -1 ), cfg.readNumEntry( "LastFile6_line", -1 ), cfg.readNumEntry( "LastFile6_color", 0 ) );
		listF.itemSet( 6, cfg.readEntry( "LastFile7", "dummy" ), cfg.readNumEntry( "LastFile7_col", -1 ), cfg.readNumEntry( "LastFile7_line", -1 ), cfg.readNumEntry( "LastFile7_color", 0 ) );
	}
	// -------------------------------------------------- v1.2.6 reserved word
	{
		Config r_cfg( arg0_baseName + "_r" );		// v2.0.1
//		Config r_cfg( "ZEditor_r" );

		r_cfg.setGroup( "Common" );
		user[0].RegExpress = r_cfg.readNumEntry( "CommonRegExpress", 0 );

		r_cfg.setGroup( "Text" );
		user[0].half_color = r_cfg.readNumEntry( "TextCharColor", 0 );
		if (( user[0].half_color < 0 ) || ( user[0].half_color > 12 ))
			user[0].half_color = 1;

		user[0].Color1  = r_cfg.readNumEntry( "rTextColor", 0 );
		user[0].Color2  = r_cfg.readNumEntry( "rTextColor2", 0 );
		user[0].Color3  = r_cfg.readNumEntry( "rTextColor3", 0 );
		user[0].Word1   = r_cfg.readEntry( "rTextWord" );
		user[0].Word2   = r_cfg.readEntry( "rTextWord2" );
		user[0].Word3   = r_cfg.readEntry( "rTextWord3" );
		user[0].CommentColor 	= r_cfg.readNumEntry( "rTextCommentColor", 0 );
		user[0].Comment 		= r_cfg.readEntry( "rTextComment" );

		r_cfg.setGroup( "User" );
		QString	ii;
		for( int i= 1 ; i < FILE_ETC ; i++ )
        {
			ii.sprintf( "User%d", i );
			user[i].Ext    = r_cfg.readEntry( ii + "Ext" );
			user[i].Color1  = r_cfg.readNumEntry( ii + "Color1", false );
			user[i].Color2  = r_cfg.readNumEntry( ii + "Color2", false );
			user[i].Color3  = r_cfg.readNumEntry( ii + "Color3", false );
			user[i].Word1   = r_cfg.readEntry( ii + "Word1" );
			user[i].Word2   = r_cfg.readEntry( ii + "Word2" );
			user[i].Word3   = r_cfg.readEntry( ii + "Word3" );
			user[i].CommentColor 	= r_cfg.readNumEntry( ii + "CommentColor" );
			user[i].Comment 		= r_cfg.readEntry( ii + "Comment" );

			extUserlist[i].clear();
			extUserlist[i] = QStringList::split( " ", user[i].Ext );
        }
/*--
		extUser1list.clear();
		extUser1list = QStringList::split( " ", user[FILE_USER1].Ext );
		extUser2list.clear();
		extUser2list = QStringList::split( " ", user[FILE_USER2].Ext );
---*/


		// ------------------------------------ v2.1.0
		char  buf[11];
		r_cfg.setGroup( "Idiom" );
		for( int i= 0 ; i < 9 ; i++ )
		{
			sprintf( buf, "rIdiom%d", i+1 );
			idiom[i]	= r_cfg.readEntry( buf );
		}
	}

	// ***************************
	//		File
	// ***************************
	codec = QTextCodec::codecForName( "eucJP" );

	QAction *a = new QAction( codec->toUnicode( "(&N)" ), Resource::loadPixmap( icon_nw_name ), QString::null, 0, this, 0 );

	connect( a, SIGNAL( activated() ), this, SLOT( fileNew() ) );
	if ( icon_new )
		a->addTo( bar );
	a->addTo( popFile );

	// -------------------- Resource::loadPixmap( "fileopen" ) libpng warning!!!
	a = new QAction( codec->toUnicode( "(&O)..." ), Resource::loadPixmap( icon_op_name ), QString::null, Key_O + CTRL, this, 0 );

	connect( a, SIGNAL( activated() ), this, SLOT( fileOpen() ) );
	if ( icon_open )
		a->addTo( bar );
	a->addTo( popFile );

	popFile->insertSeparator();

	// ------------------------------ v0.9.2  Resource::loadPixmap( "Save" ) is too small
	//                                v1.0.2  "pen" is not exist in SL-A300
	a = new QAction( codec->toUnicode( "¸(&S)" ), Resource::loadPixmap( icon_sv_name ), QString::null, Key_S + CTRL, this, 0 );

	connect( a, SIGNAL( activated() ), this, SLOT( fileMenuSave() ) );
	if ( icon_save )
		a->addTo( bar );
	a->addTo( popFile );

	// ------------------------------ 2003.01.19
	popFile->insertItem( codec->toUnicode( "̾դ¸(&A)..." ), this , SLOT( fileMenuSaveAs() ) , Key_A + CTRL );

	popFile->insertSeparator();

	// ------------------------------ v1.3.0
	popFile->insertItem( codec->toUnicode( "ʰץե顼(&P)" ), this , SLOT( fileMenuFiler() ) , Key_P + CTRL );


	popFile->insertSeparator();

	if ( history_clear )
	{
		popFile->insertItem( codec->toUnicode( "եõ(&C)" ), this , SLOT( fileClearHistory() ) );
	}
	else
	{
		QAction *wa = new QAction( codec->toUnicode( "ɤ߼Ѥꤹ(&R)"), QString::null, 0, this, 0 );
		wa->setToggleAction( true );
		wa->addTo( popFile );
		wa->setOn( read_only );
		connect( wa, SIGNAL( toggled(bool) ), this, SLOT( fileReadOnly(bool) ) );
	}
	popFile->insertSeparator();

	QString	m_file;
	for ( int i= 0, k= 0 ; i < MAX_LIST_COUNT ; i++ )
	{
		if ( listF.col( i ) < 0 )
			continue;
		m_file = QFileInfo( listF.path( i ) ).fileName();
		m_file.append( tr( "(&" ) );
		m_file.append( tr( menu_num[k++] ) );
		m_file.append( tr( ")" ));
		popFile->insertItem( m_file, this , SLOT( openLastFile( int ) ) , 0, i );	// v2.0.1
	}

	// ***************************
	//		Edit
	// *************************** 
	a = new QAction( codec->toUnicode( "ڼcut(&T)" ), Resource::loadPixmap( icon_ct_name ), QString::null, Key_X + CTRL, this, 0 );
	connect( a, SIGNAL( activated() ), this, SLOT( editCut() ) );
	if ( icon_cut )
		a->addTo( editBar );
	a->addTo( popEdit );

	a = new QAction( codec->toUnicode( "ʣcopy(&C)" ), Resource::loadPixmap( icon_cp_name ), QString::null, Key_C + CTRL, this, 0 );
	connect( a, SIGNAL( activated() ), this, SLOT( editCopy() ) );
	if ( icon_copy )
		a->addTo( editBar );
	a->addTo( popEdit );

	a = new QAction( codec->toUnicode( "Žpaste(&P)" ), Resource::loadPixmap( icon_ps_name ), QString::null, Key_V + CTRL, this, 0 );
	connect( a, SIGNAL( activated() ), this, SLOT( editPaste() ) );
	if ( icon_paste )
		a->addTo( editBar );
	a->addTo( popEdit );


	popEdit->insertItem( codec->toUnicode( "ʣ(&L)" ), this , SLOT( editDuplicate() ) , Key_L + CTRL );
	popEdit->insertItem( codec->toUnicode( "ٹԺ(&Y)" ), this , SLOT( editRemove() ) , Key_Y + CTRL );


	popEdit->insertSeparator();

//	popEdit->insertItem( codec->toUnicode( "٤(&A)" ), this , SLOT( editSelectAll() ) , 0 );
    popSelect = new QPopupMenu( this );
    connect( popSelect, SIGNAL( activated(int) ), this, SLOT( optionProcNum(int) ) );
    popSelect->insertItem( codec->toUnicode( "٤(&A)"), this , SLOT( editSelectAll()) );
    popSelect->insertItem( codec->toUnicode( "ʸƬ(&T)"), this , SLOT( editSelectTop()) );
    popSelect->insertItem( codec->toUnicode( "ʸ(&B)"), this , SLOT( editSelectBottom()) );
    popSelect->insertItem( codec->toUnicode( "ޡ(&M)"), this , SLOT( editSelectMark()) );
    popEdit->insertItem( codec->toUnicode( "ϰ(&S)"), popSelect );

	// ------------------------------- v2.0.8 Ctrl + up, down
	if ( ctrl_up )
	{
		QAccel *acc_up = new QAccel( this );
		if ( ctrl_up == 1 )
			acc_up->connectItem( acc_up->insertItem( Key_Up + CTRL ), this, SLOT( editSelectTop() ) );
		else
			acc_up->connectItem( acc_up->insertItem( Key_Up + CTRL ), this, SLOT( editSelectMark() ) );
	}
	if ( ctrl_down )
	{
		QAccel *acc_down = new QAccel( this );
		if ( ctrl_down == 1 )
			acc_down->connectItem( acc_down->insertItem( Key_Down + CTRL ), this, SLOT( editSelectBottom() ) );
		else
			acc_down->connectItem( acc_down->insertItem( Key_Down + CTRL ), this, SLOT( editSelectMark() ) );
	}

	popEdit->insertSeparator();

	a = new QAction( codec->toUnicode( "(&F)" ), Resource::loadPixmap( icon_fd_name ), QString::null, Key_F + CTRL, this, 0 );
	connect( a, SIGNAL( activated() ), this, SLOT( editFind() ) );
	if ( icon_find )
		a->addTo( bar );
	a->addTo( popEdit );

	// ***************************
	//		View
	// ***************************
	popView->insertItem( codec->toUnicode( "ʸƬ(&T)" ), this , SLOT( jump_top() ), Key_T + CTRL );
	popView->insertItem( codec->toUnicode( "ʸ(&B)" ), this , SLOT( jump_bottom() ), Key_B + CTRL );
	popView->insertItem( codec->toUnicode( "֤(&G)" ), this , SLOT( jump_number() ), Key_G + CTRL );

    jump_mark = new QAction( codec->toUnicode( "ٰ֎ώ(&M)"), QString::null, Key_M + CTRL, this, 0 );
    jump_mark->setToggleAction(true);
    jump_mark->addTo( popView );
    connect( jump_mark, SIGNAL( toggled(bool) ), this, SLOT( MarkCursorPos( bool ) ) );

	popView->insertItem( codec->toUnicode( "ώ؎ގݎ̎(&J)" ), this , SLOT( jump_markpos() ), Key_J + CTRL );

    popView->insertSeparator();

    zin = new QAction( codec->toUnicode( "ʸ礭(&L)"), QString::null, 0, this, 0 );
    connect( zin, SIGNAL( activated() ), this, SLOT( zoomIn() ) );
    zin->addTo( popView );

    zout = new QAction( codec->toUnicode( "ʸ򾮤(&S)"), QString::null, 0, this, 0 );
    connect( zout, SIGNAL( activated() ), this, SLOT( zoomOut() ) );
    zout->addTo( popView );

	// ---------------------- v1.1.6  Fn + 1, Fn + 2 change character size
	QAccel *acc1 = new QAccel( this );
	acc1->connectItem( acc1->insertItem( 0x200f ), this, SLOT( zoomOut() ) );
	QAccel *acc2 = new QAccel( this );
	acc2->connectItem( acc2->insertItem( 0x2010 ), this, SLOT( zoomIn() ) );


    popView->insertSeparator();


    QAction *wa = new QAction( codec->toUnicode( "ޤ֤(&W)"), QString::null, 0, this, 0 );
    wa->setToggleAction( true );
    wa->addTo( popView );
	wa->setOn( word_wrap );		// don't call setWordWrap(bool)!!!  frame_width is not correct!
    connect( wa, SIGNAL( toggled(bool) ), this, SLOT( setWordWrap(bool) ) );

    // --------------------------- v1.2.8
    QAction *at = new QAction( codec->toUnicode( "ĎݎÎގݎ(&U)"), QString::null, 0, this, 0 );
    at->setToggleAction( true );
    at->addTo( popView );
	at->setOn( auto_indent );
    connect( at, SIGNAL( toggled(bool) ), this, SLOT( setAutoIndent(bool) ) );

    popView->insertSeparator();

	popView->insertItem( codec->toUnicode( "؎̎ߎΎގĎ(&H)" ), this , SLOT( show_clipboard() ), Key_H + CTRL );

	popView->insertItem( codec->toUnicode( "ʸݎ(&I)" ), this , SLOT( countCharacter() ), Key_I + CTRL );

    popView->insertSeparator();

	// ------------------------------------------------------------ v1.2.5
    popOption = new QPopupMenu( this );
    connect( popOption, SIGNAL( activated(int) ), this, SLOT( optionProcNum(int) ) );
    popOption->insertItem( codec->toUnicode( "ɽ(&O)..."), 0 );
    popOption->insertItem( codec->toUnicode( "ư(&P)..."), 1 );
    popOption->insertItem( codec->toUnicode( "ʬ(&C)..."), 2 );
    popOption->insertItem( codec->toUnicode( "Ѷ(&W)..."), 3 );
    popOption->insertItem( codec->toUnicode( "ü쎷(&K)..."), 4 );

    popView->insertItem( codec->toUnicode( "ץ(&O)"), popOption );
    popView->insertSeparator();


	popView->insertItem( codec->toUnicode( "about(&A)..." ), this , SLOT( aboutMessage() ), 0 );




	// *************************** Menu ***********************
	if ( shortcutkey )
	{
		id_file = menuBar->insertItem( codec->toUnicode( menu_sk_name[0] ), popFile );
		id_edit = menuBar->insertItem( codec->toUnicode( menu_sk_name[1] ), popEdit );
		id_view = menuBar->insertItem( codec->toUnicode( menu_sk_name[2] ), popView );
	}
	else
	{
		id_file = menuBar->insertItem( codec->toUnicode( menu_name[0] ), popFile );
		id_edit = menuBar->insertItem( codec->toUnicode( menu_name[1] ), popEdit );
		id_view = menuBar->insertItem( codec->toUnicode( menu_name[2] ), popView );
	}

	// ***************************
	//		Edit
	// *************************** 

	// *************************** Search ***********************
    searchBar = new QPEToolBar(this);
    addToolBar( searchBar,  "Search", QMainWindow::Top, true );

    searchBar->setHorizontalStretchable( true );

    searchComboEdit = new QComboBox( true, searchBar );			// v3.1.0	<--- QLineEdit
    searchBar->setStretchableWidget( searchComboEdit );
    if (( incremental_s ) && ( c_sensitive  % 2 == 0 ))		// not RegularExpression
        connect( searchComboEdit, SIGNAL( textChanged( const QString & ) ), this, SLOT( search() ) );
//    connect( searchEdit, SIGNAL( returnPressed()), this, SLOT( search() ) );
//    connect( searchComboEdit, SIGNAL( activated(int)), this, SLOT( search() ) );


     a = new QAction( codec->toUnicode( "򸡺(&N)" ), Resource::loadPixmap( icon_nf_name ), QString::null, Key_N + CTRL, this, 0 );
     connect( a, SIGNAL( activated() ), this, SLOT( findNext() ) );
     if ( icon_nfind )
         a->addTo( bar );
     a->addTo( popEdit );

	popEdit->insertItem( codec->toUnicode( "λ(&E)" ), this , SLOT( findClose() ) , Key_E + CTRL );
	popEdit->insertItem( codec->toUnicode( "ִ(&R)..." ), this , SLOT( replaceProc() ) , Key_R + CTRL );

    popEdit->insertSeparator();

	popEdit->insertItem( codec->toUnicode( "դȻ(&D)" ), this , SLOT( insertDateTime() ) , Key_D + CTRL );


	// ----------------------------------- v1.3.6
    popOther = new QPopupMenu( this );
    connect( popOther, SIGNAL( activated(int) ), this, SLOT( otherProcNum(int) ) );
    popOther->insertItem( codec->toUnicode( "undo(&U) Ctrl+U"), 0 );
    popOther->insertItem( codec->toUnicode( "redo(&Q) Ctrl+Q"), 1 );
    popOther->insertItem( codec->toUnicode( "Ѷ(&W) Ctrl+W"), 2 );

    popEdit->insertItem( codec->toUnicode( "¾(&O)"), popOther );

	// ----------------------------------- undo
	QAccel *acc_undo = new QAccel( this );
	acc_undo->connectItem( acc_undo->insertItem( Key_U + CTRL ), this, SLOT( undoProc() ) );

	// ----------------------------------- v1.3.6 redo
	QAccel *acc_redo = new QAccel( this );
	acc_redo->connectItem( acc_redo->insertItem( Key_Q + CTRL ), this, SLOT( redoProc() ) );

	// ----------------------------------- v2.0.3 timer
	if ( time_interval )
	{
    	QTimer *timer = new QTimer( this );
    	connect( timer, SIGNAL( timeout() ), this, SLOT( timerOn()) );
		timer->start( time_interval * 60000, false );
	}

	// ------------------------------- v2.1.0 idiom list box
	QAccel *acc_idiom = new QAccel( this );
	acc_idiom->connectItem( acc_idiom->insertItem( Key_W + CTRL ), this, SLOT( idiomListBox() ) );

	QAccel *acc_num = new QAccel( this );
	acc_num->connectItem( acc_num->insertItem( Key_1 + CTRL ), this, SLOT( idiomNumber1() ) );
	acc_num->connectItem( acc_num->insertItem( Key_2 + CTRL ), this, SLOT( idiomNumber2() ) );
	acc_num->connectItem( acc_num->insertItem( Key_3 + CTRL ), this, SLOT( idiomNumber3() ) );
	acc_num->connectItem( acc_num->insertItem( Key_4 + CTRL ), this, SLOT( idiomNumber4() ) );
	acc_num->connectItem( acc_num->insertItem( Key_5 + CTRL ), this, SLOT( idiomNumber5() ) );
	acc_num->connectItem( acc_num->insertItem( Key_6 + CTRL ), this, SLOT( idiomNumber6() ) );
	acc_num->connectItem( acc_num->insertItem( Key_7 + CTRL ), this, SLOT( idiomNumber7() ) );
	acc_num->connectItem( acc_num->insertItem( Key_8 + CTRL ), this, SLOT( idiomNumber8() ) );
	acc_num->connectItem( acc_num->insertItem( Key_9 + CTRL ), this, SLOT( idiomNumber9() ) );

	// ------------------------------- v3.0.0 Tab, ShiftTab indent
	acc_num->connectItem( acc_num->insertItem( Key_Tab ), this, SLOT( tabIndent() ) );
	acc_num->connectItem( acc_num->insertItem( Key_Tab + SHIFT ), this, SLOT( shiftTabIndent() ) );


	// ----------------------------------- Close Find Icon
    a = new QAction( tr( "Close Find" ), Resource::loadPixmap( "close" ), QString::null, 0, this, 0 );
    connect( a, SIGNAL( activated() ), this, SLOT( findClose() ) );
    a->addTo( searchBar );

    searchBar->hide();

    editorStack = new QWidgetStack( this );
    setCentralWidget( editorStack );

    searchVisible = false;

	FrameWidth  = AUTO_OR_NOWRAP;
	UpdateCellWidth = 0;
	find_backword = false;

	// ----------------------------------- v3.4.0
    popConvert = new QPopupMenu( this );
    popConvert->insertItem( codec->toUnicode( "Ⱦѱѿ梪ѱѿ"), this , SLOT( convertAscii2Zen()) );
    popConvert->insertItem( codec->toUnicode( "ѱѿ梪Ⱦѱѿ"), this , SLOT( convertZen2Ascii()) );

	// *************************************************
	//						editor !!!
	// *************************************************
	editor = new QpeEditor( editorStack );
	editor->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	editorStack->addWidget( editor, get_unique_id() );
	// ------------------------------- v1.1.5
//	connect( editor, SIGNAL( returnPressed()), this, SLOT( updateCaption()) );  can't get!!!
	// ------------------------------- Tab
	editor->setDefaultTabStop( tablength );
	editor->setCursorDraw( cursor_draw );
	editor->setCursorLineColor( cursor_line_color );
	editor->setCursorColor( cursor_color );
	editor->setCursorStyle( cursor_style );
	editor->setSelectedColor( selected_color );
	editor->setVerticalLine( vertical_line );
	editor->setScrollBarDisp( scrollbar_disp );
	editor->setLineNumber( line_number, line_number_cr );
	editor->setCRMarkDisp( cr_markdisp );
	editor->setAutoindent( auto_indent );
	editor->setJumpMark( -1, -1 );
	editor->setSeparateKanaKanji( separateKanaKanji );

//	connect( editor, SIGNAL( textChanged() ), this, SLOT( textisChanged() ) );  can not available???

	// ------------------------------- v1.2.4  Ctrl + 0 change ovewrite mode
	QAccel *acc3 = new QAccel( this );
	acc3->connectItem( acc3->insertItem( Key_0 + CTRL ), this, SLOT( changeOverWrite() ) );
	editor->setOverWriteWhich( false );

	// ------------------------------- v2.0.0 select words ---> v2.2.0
//	QAccel *acc_sword = new QAccel( this );
//	acc_sword->connectItem( acc_sword->insertItem( Key_Space + SHIFT ), this, SLOT( selectWords() ) );

	// ---------------------- v2.2.0
	sp_acc = new QAccel( this );
	optionSpecialKey( true );


//	setCaption( tr("ZEditor") );
	setCaption( arg0_baseName );
	// ------------------------------- v3.1.0	bug : v3.1.1 initialized font size !
	QFont	font( family_name );
	editor->setFont( font );
	setFontSize( defsize, true );

	int	p_size = editor->font().pointSize();
	font.setPointSize( p_size );
	searchComboEdit->setFont( font );				//	v3.5.3

	fileNew();

	editor->set2byteSpace();
	// ------------------------------- short cut key
	if ( ! shortcutkey )
		setShortCutKey( false );

	// ------------------------------- background color
	setBackColor( backcolor );
	// ------------------------------- text color
	setTextColor( textcolor );

	// ------------------------------- reserved word v1.2.6 ---> v2.1.3
	for( int i= 0 ; i < MAX_FILE_COLOR ; i++ )
	{
		editor->setUserFileInfo( i, user[i] );
	}

	// ------------------------------- v3.5.0
	fileReadOnly( read_only );
}

TextEdit::~TextEdit()
{
	writeConf();
	writeConf2();
}


void TextEdit::writeConf()
{
	int		i;
	Config cfg( arg0_baseName );		// v2.0.1
//	Config cfg( "ZEditor" );

	cfg.setGroup( "LastFile" );
	// --------------------------------------- set last file v1.0.0
//	setLastFile();	---> move to TextEdit::closeEvent()		v2.0.6 Mr.yakty

	for( i= 0 ; i < MAX_LIST_COUNT ; i++ )
	{
		char  buf[21];

		sprintf( buf, "LastFile%d", i+1 );
		cfg.writeEntry( buf, listF.path( i ) );
		sprintf( buf, "LastFile%d_col", i+1 );
		cfg.writeEntry( buf, listF.col( i ) );
		sprintf( buf, "LastFile%d_line", i+1 );
		cfg.writeEntry( buf, listF.line( i ) );
		sprintf( buf, "LastFile%d_color", i+1 );
		cfg.writeEntry( buf, listF.color( i ) );
	}

	cfg.setGroup( "View" );
	QFont f = editor->font();
	cfg.writeEntry( "FontSize", f.pointSize());
	cfg.writeEntry( "Wrap", word_wrap );
	cfg.writeEntry( "WrapMethod", wrap_method );
	cfg.writeEntry( "AutoIndent", auto_indent );
	// ----------------------------- append v1.0.0
	cfg.writeEntry( "ShortCutKey", shortcutkey );
	cfg.writeEntry( "CursorDraw", cursor_draw );
	cfg.writeEntry( "BackColor", backcolor );
	cfg.writeEntry( "LineNumber", line_number );
	cfg.writeEntry( "LineNumberCr", line_number_cr );
	cfg.writeEntry( "CRMarkDisp", cr_markdisp );

	cfg.writeEntry( "CursorWord",         cursorword       );
	cfg.writeEntry( "MoveCursor",         movecursor       );
	cfg.writeEntry( "SelectedCursor",     selectedcursor   );
	cfg.writeEntry( "WinDateForm",        windateform      );
	cfg.writeEntry( "TextColor",          textcolor        );
	cfg.writeEntry( "CursorColor",        cursor_line_color );
	cfg.writeEntry( "CursorColor2",       cursor_color     );
	cfg.writeEntry( "CursorWidth",        cursor_style     );
	cfg.writeEntry( "AppendCRCode",       cr_code          );
	cfg.writeEntry( "CaseSensitive",      c_sensitive      );
	cfg.writeEntry( "IncrementalSearch",  incremental_s    );
	cfg.writeEntry( "TabLength",          tablength        );
	cfg.writeEntry( "InputCodec",         input_codec      );
	cfg.writeEntry( "OutputCodec",        output_codec     );
	cfg.writeEntry( "SelectedColor",      selected_color   );
	cfg.writeEntry( "VerticalLine",       vertical_line    );
	cfg.writeEntry( "ScrollBarDisp",      scrollbar_disp   );
	// ----------------------------- append v3.1.0
	cfg.writeEntry( "FontFamilyName",     family_name      );

	// ----------------------------- append v3.1.0
	for( i= 1 ; i <= MAX_SEARCH_COUNT ; i++ )
	{
		char  buf[21];
		sprintf( buf, "SearchWords%d", i );
		cfg.writeEntry( buf, search_words[i] );
	}

	// ----------------------------- append v3.5.0
	cfg.writeEntry( "ReadOnly", read_only );

	cfg.setGroup( "Key" );
	cfg.writeEntry( "KeyCtrlEnter",		sp_key.ctrl_enter );
	cfg.writeEntry( "KeyCtrlSpace",		sp_key.ctrl_space );
	cfg.writeEntry( "KeyShiftEnter",	sp_key.shift_enter );
	cfg.writeEntry( "KeyShiftSpace",	sp_key.shift_space );
	cfg.writeEntry( "KeyFn_N",			sp_key.fn_N );
	cfg.writeEntry( "KeyFn_M",			sp_key.fn_M );
	cfg.writeEntry( "KeyFn_O",			sp_key.fn_O );
	cfg.writeEntry( "KeyFn_P",			sp_key.fn_P );
	cfg.writeEntry( "KeyFn_A",			sp_key.fn_A );
	cfg.writeEntry( "KeyFn_S",			sp_key.fn_S );
}

void TextEdit::writeConf2()
{
	// ------------------------------------------ v1.2.6 reserved word
	Config r_cfg( arg0_baseName + "_r" );		// v2.0.1
//	Config r_cfg( "ZEditor_r" );

	r_cfg.setGroup( "Common" );
	r_cfg.writeEntry( "CommonRegExpress", user[0].RegExpress );

	r_cfg.setGroup( "Text" );
	r_cfg.writeEntry( "TextCharColor", user[0].half_color );
	r_cfg.writeEntry( "rTextColor", user[0].Color1 );
	r_cfg.writeEntry( "rTextColor2", user[0].Color2 );
	r_cfg.writeEntry( "rTextColor3", user[0].Color3 );
	r_cfg.writeEntry( "rTextWord", user[0].Word1 );
	r_cfg.writeEntry( "rTextWord2", user[0].Word2 );
	r_cfg.writeEntry( "rTextWord3", user[0].Word3 );
	r_cfg.writeEntry( "rTextCommentColor", user[0].CommentColor );
	r_cfg.writeEntry( "rTextComment", user[0].Comment );

	int		i;
	QString	ii;
	r_cfg.setGroup( "User" );
	for( i= 1 ; i < FILE_ETC ; i++ )
	{
		ii.sprintf( "User%d", i );
		r_cfg.writeEntry( ii + "Ext", user[i].Ext );
		r_cfg.writeEntry( ii + "Color1", user[i].Color1 );
		r_cfg.writeEntry( ii + "Color2", user[i].Color2 );
		r_cfg.writeEntry( ii + "Color3", user[i].Color3 );
		r_cfg.writeEntry( ii + "Word1", user[i].Word1 );
		r_cfg.writeEntry( ii + "Word2", user[i].Word2 );
		r_cfg.writeEntry( ii + "Word3", user[i].Word3 );
		r_cfg.writeEntry( ii + "Comment", user[i].Comment );
		r_cfg.writeEntry( ii + "CommentColor", user[i].CommentColor );
	}

	// ------------------------------------------- v2.1.0
	r_cfg.setGroup( "Idiom" );
	char  buf[11];
	for( int i= 0 ; i < 9 ; i++ )
	{
		sprintf( buf, "rIdiom%d", i+1 );
		r_cfg.writeEntry( buf, idiom[i] );
	}
}

// ********************************************************************
// 		>> View <<
// ********************************************************************
void TextEdit::changeOverWrite()
{
	editor->overwrite();
}

void TextEdit::jump_top()
{
	editor->setCursorPosition( 0, 0, false );
    editor->setFocus();		// v1.0.0
	// -------------------------------- v1.1.5, v1.2.1
	if ( line_number == LINE_NUMBER_TITLE )
		updateCaption();
}

void TextEdit::jump_to( int line )
{
	if ( line < 0 )
		line = editor->numLines();
	if ( word_wrap )
	{
		line = editor->Line2WrapLineNumber( line );
		if ( line < 0 )
			line = editor->numLines();
	}
	editor->setCursorPosition( line, 0, false );
}

/*-------------------------------- v1.1.6 delete!!
void TextEdit::jump_middle()
{
	int		line_num;

	line_num = editor->numLines();
	editor->setCursorPosition( line_num / 2, 0, false );
    editor->setFocus();		// v1.0.0
	// -------------------------------- v1.1.5
	if ( line_number )
		updateCaption();
}
----------------------------------*/

void TextEdit::jump_bottom()
{
	int		line_num;

	line_num = editor->numLines();
	editor->setCursorPosition( line_num, 0, false );
	editor->setFocus();		// v1.0.0
	// -------------------------------- v1.1.5, v1.2.1
	if ( line_number == LINE_NUMBER_TITLE  )
		updateCaption();
}

void TextEdit::jump_number()
{
	// ----------------------------------- replace dialog
	JumpDialog jmpDialog( this, "", true, 0 );
	jmpDialog.setOldStr( old_num );

	// ----------------------------------- get str
	if ( jmpDialog.exec() == QDialog::Accepted )
	{
		bool	ok;
		int		line_num;
		int		now_line, now_col;
		int		show_line;

		line_num = jmpDialog.num.toUInt( &ok );
		if ( ok )
		{
			if ( line_num > 0 )
				line_num--;			// start num is 0 --> 1


			editor->getCursorPosition( &now_line, &now_col );

			// ------------------------------- v2.1.5 move cursor to center
			int		max_line = 0;
			if ( height() > 400 )
				max_line = ( height() - 36 ) / ( font().pointSize() + 2 );
			else
				if ( height() > 100 )
					max_line = ( height() - 24 ) / ( font().pointSize() + 2 );

			if ( line_num > now_line )
				show_line = line_num + max_line / 2;
			else
				show_line = line_num - max_line / 2;
			if ( show_line < 0 )
				show_line = 0;

			editor->setCursorPosition( show_line, 0, false );


			editor->setCursorPosition( line_num, 0, false );
			old_num = jmpDialog.num;
			// -------------------------------- v1.1.5, v1.2.1
			if ( line_number == LINE_NUMBER_TITLE  )
				updateCaption();
		}
	}
}

void TextEdit::MarkCursorPos( bool y )
{
	// -------------------------------- v2.3.2 append toggle switch
	if ( markpos_toggle )
	{
		if ( y )
			editor->getCursorPosition( &mk_yy, &mk_xx );
		else
			mk_yy = mk_xx = -1;
		jump_mark->setOn( y );
	}
	else
	{
		editor->getCursorPosition( &mk_yy, &mk_xx );
		jump_mark->setOn( true );
	}
	editor->setJumpMark( mk_yy, mk_xx );
	editor->setFocus();
}

void TextEdit::jump_markpos()
{
	int		line_num;

	if ( jump_mark->isOn() )
	{
		line_num = editor->numLines();
		if ( mk_yy > line_num )
			mk_yy = line_num;
		editor->setCursorPosition( mk_yy, mk_xx, false );
		editor->setFocus();
		// -------------------------------- v1.1.5, v1.2.1
		if ( line_number == LINE_NUMBER_TITLE  )
			updateCaption();
	}
	else
	{
		editor->setFocus();
	}
}

void TextEdit::zoomIn()
{
    setFontSize( editor->font().pointSize()+1, false );

	if (( word_wrap ) && ( wrap_method > 3 ))
		setWordWrap( word_wrap );
    editor->setFocus();		// v1.0.0
}

void TextEdit::zoomOut()
{
    setFontSize( editor->font().pointSize()-1, true );

	if (( word_wrap ) && ( wrap_method > 3 ))
		setWordWrap( word_wrap );
    editor->setFocus();		// v1.0.0
}


void TextEdit::setFontSize(int sz, bool round_down_not_up)
{
	int		s=10;

	for ( int i=0 ; i < nfontsizes ; i++ )
	{
		if ( fontsize[i] == sz )
		{
			s = sz;
			break;
		}
		else
		{
			if ( round_down_not_up )
			{
				if ( fontsize[i] < sz )
					s = fontsize[i];
			}
			else
			{
				if ( fontsize[i] > sz )
				{
					s = fontsize[i];
					break;
				}
			}
		}
	}
	QFont f = editor->font();
	f.setPointSize( s );
	editor->setFont( f );

	searchComboEdit->setFont( f );				//	v3.5.4

	zin->setEnabled( s != fontsize[nfontsizes-1] );
	zout->setEnabled( s != fontsize[0] );
	editor->setLineNumber( line_number, line_number_cr );
	setUpdateCellWidth();
}

void TextEdit::setBold(bool y)
{
    QFont f = editor->font();
    f.setBold(y);
    editor->setFont(f);
}

void TextEdit::setItalic(bool y)
{
    QFont f = editor->font();
    f.setItalic(y);
    editor->setFont(f);
}

void TextEdit::wrap_this( void )
{
	setWordWrap( word_wrap );
}
void TextEdit::setUpdateCellWidth( void )
{
	if ( word_wrap )
	{
		if ( wrap_method > 3 )
			UpdateCellWidth = FrameWidth - editor->getVerticalScrollBarWidth() - FIX_CELL_WIDTH;
		else
			UpdateCellWidth = FrameWidth;
	}
//	else	v2.1.0a bug fix	: h_scrollbar
//			UpdateCellWidth = FrameWidth;
	if ( UpdateCellWidth < 0 )
		UpdateCellWidth = MIN_FRAME_WIDTH * 3;
}

void TextEdit::setWordWrap( bool y )
{
//	int	yy,xx;
//	editor->getCursorPosition( &yy, &xx );    line number is changed !!

	word_wrap = y;

	bool state = editor->edited();
	if ( wrap_method == 3 )
		editor->setWrapPolicy( QMultiLineEdit::AtWhiteSpace );		// v2.0.0
	else
		editor->setWrapPolicy( QMultiLineEdit::Anywhere );

	if (( wrap_method == 1 ) || ( wrap_method > 3 ))
	{
		if ( y )
		{
			FrameWidth = editor->width();	// width is 100 !!! when TextEdit start
			if ( FrameWidth < MIN_FRAME_WIDTH )
				return;

			setUpdateCellWidth();
			// -------------------------- v1.3.1 input wrap col
			if ( wrap_method > 3 )
			{
				// ---------------------- font().pointSize() : 2byte char
				//							and  check last 2byte char!!!
				int	wrap_width = editor->font().pointSize() * wrap_method / 2 + editor->font().pointSize();
				editor->setWrapColumnOrWidth( wrap_width );
			}
			else
			{
				editor->setWrapColumnOrWidth( FrameWidth - editor->hMargin() - editor->getVerticalScrollBarWidth() );
			}
		}
		else
		{
			FrameWidth = AUTO_OR_NOWRAP;
		}
		editor->setWordWrap( y ? QMultiLineEdit::FixedPixelWidth  :  QMultiLineEdit::NoWrap );
	}
	else  // auto
	{
		FrameWidth = AUTO_OR_NOWRAP;
		editor->setWordWrap( y ? QMultiLineEdit::WidgetWidth  :  QMultiLineEdit::NoWrap );
	}
// ------------------------------------- col Test : can't use multibyte char
//	editor->setWrapColumnOrWidth( col is only half char!!! );
//	editor->setWordWrap( y ? QMultiLineEdit::FixedColumnWidth  :  QMultiLineEdit::NoWrap );


	editor->setEdited( state );
	// why move cursor to top?
	editor->setCursorPosition( 0, 0 );
	editor->setScrollBarDisp( scrollbar_disp );		// v2.0.0 setWordWrap clear TableFlags!
	editor->setFocus();		// v1.0.0
}

// ----------------------------------- v1.2.8
void TextEdit::setAutoIndent( bool y )
{
	auto_indent = y;
	editor->setAutoindent( y );
	editor->setFocus();
}

void TextEdit::setShortCutKey(bool y)
{
	codec = QTextCodec::codecForName( "eucJP" );
    if ( y )
    {
        menuBar->changeItem( id_file, codec->toUnicode( menu_sk_name[0] ));
        menuBar->changeItem( id_edit, codec->toUnicode( menu_sk_name[1] ));
        menuBar->changeItem( id_view, codec->toUnicode( menu_sk_name[2] ));
    }
    else
    {
        menuBar->changeItem( id_file, codec->toUnicode( menu_name[0] ));
        menuBar->changeItem( id_edit, codec->toUnicode( menu_name[1] ));
        menuBar->changeItem( id_view, codec->toUnicode( menu_name[2] ));
    }
	shortcutkey = y;
	editor->setFocus();		// v1.0.0
}

void TextEdit::setCursorLine( int l_num )
{
	cursor_draw = l_num;
	editor->setCursorDraw( cursor_draw );
	editor->update();
	editor->setFocus();		// v1.0.0
}


void TextEdit::setTextColor( int t_num )
{
	QColor	tc;
	switch( t_num )
	{
		default:
		case 0 : tc = Qt::black;	break;
		case 1 : tc = QColor( 80, 0, 0 );	break;
		case 2 : tc = QColor( 0, 80, 0 );	break;
		case 3 : tc = QColor( 0, 0, 80 );	break;
		case 4 : tc = Qt::white;	break;

		case 5 : tc = Qt::gray;	break;
		case 6 : tc = Qt::darkGray;	break;

		case 7 : tc = Qt::red;	break;
		case 8 : tc = Qt::green;	break;
		case 9 : tc = Qt::blue;	break;
		case 10: tc = Qt::magenta;	break;
		case 11: tc = Qt::cyan;	break;
		case 12: tc = Qt::yellow;	break;

		case 13: tc = QColor( 255, 100, 100 );	break;
		case 14: tc = QColor( 100, 255, 100 );	break;
		case 15: tc = QColor( 100, 100, 255 );	break;
		case 16: tc = QColor( 255, 100, 255 );	break;
		case 17: tc = QColor( 100, 255, 255 );	break;
		case 18: tc = QColor( 255, 255, 100 );	break;
	}
	// ------------------------------- text color
	QPalette p = editor->palette();
	p.setColor( QColorGroup::Text, tc );
	editor->setPalette( p );
}

void TextEdit::setBackColor( int c_num )
{
	if (( c_num < 0 ) || ( c_num > 7 ))
		c_num = 0;
	if (( c_num == 7 ) && ( textcolor == 0 ))	// back:black, text:black
	{
		textcolor = 4;
		setTextColor( textcolor );
	}
	if (( c_num < 7 ) && ( textcolor == 4 ))	// back:white, text:white
	{
		textcolor = 0;
		setTextColor( textcolor );
	}
	if (( c_num == 0 ) && ( cursor_color == 7 ))	// back:white, cursor:white
	{
		cursor_color = 0;
		editor->setCursorColor( cursor_color );
	}
	if (( c_num == 7 ) && ( cursor_color == 6 ))	// back:black, cursor:white
	{
		cursor_color = 7;
		editor->setCursorColor( cursor_color );
	}


	// ------------------------------- change pallete
	QPalette p = editor->palette();
	p.setColor( QColorGroup::Base, QColor( color_r[c_num], color_g[c_num], color_b[c_num] ));
	editor->setPalette( p );
	backcolor = c_num;
	editor->setBkColorNum( c_num );

//	editor->update();
	editor->setFocus();
}


void TextEdit::optionProcNum( int opt_num )
{
	switch( opt_num )
	{
		case 0 :
			optionProc();
			break;
		case 1 :
			optionProc2();
			break;
		case 2 :
			optionProc3();
			break;
		case 3 :
			optionProc4();
			break;
		case 4 :
			optionProc5();
			break;
	}
}



// --------------------------------------------------- v2.2.0
void TextEdit::optionSpecialKey( bool which )
{
	setSpecialKey( which, Key_Return + CTRL, sp_key.ctrl_enter );
	setSpecialKey( which, Key_Space + CTRL, sp_key.ctrl_space );

setSpecialKey( which, Key_Return + SHIFT, sp_key.shift_enter );
	setSpecialKey( which, Key_Space + SHIFT, sp_key.shift_space );

	setSpecialKey( which, 0x2019, sp_key.fn_N );			// Fn + N
	setSpecialKey( which, 0x201a, sp_key.fn_M );			// Fn + M
	setSpecialKey( which, 0x2015, sp_key.fn_O );			// Fn + O
	setSpecialKey( which, 0x2016, sp_key.fn_P );			// Fn + P
	setSpecialKey( which, 0x2017, sp_key.fn_A );			// Fn + A
	setSpecialKey( which, 0x2018, sp_key.fn_S );			// Fn + S
//	setSpecialKey( which, Qt::Key_F23, sp_key.fn_space );	// Fn + space ??
}


void TextEdit::setSpecialKey( bool which, int key_code, int slot_num )
{
	const char	*jump_slot;

	switch( slot_num )
	{
		case SP_HALF_SPACE :
				jump_slot = SLOT( inputHalfSpace() );
				break;
		case SP_AUTO_SELECT :
				jump_slot = SLOT( selectWords() );
				break;
		case SP_REDO :
				jump_slot = SLOT( redoProc() );
				break;
		case SP_UNDO :
				jump_slot = SLOT( undoProc() );
				break;
		case SP_DEL_LINE :
				jump_slot = SLOT( editRemove() );
				break;
		case SP_DUP_LINE :
				jump_slot = SLOT( editDuplicate() );
				break;
		case SP_FIND :
				jump_slot = SLOT( editFind() );
				break;
		case SP_FINDNEXT :
				jump_slot = SLOT( findNext() );
				break;
		case SP_REPLACE :
				jump_slot = SLOT( replaceProc() );
				break;
		case SP_DATETIME :
				jump_slot = SLOT( insertDateTime() );
				break;
		case SP_IDIOM :
				jump_slot = SLOT( idiomListBox() );
				break;
		// --------------------------------------- v2.2.2
		case SP_FULLPATH :
				jump_slot = SLOT( insertFullPath() );
				break;

		// --------------------------------------- v3.0.0
		case SP_EDITFINDPREV:
				jump_slot = SLOT( editFindPrev() );
				break;
		case SP_FINDPREV:
				jump_slot = SLOT( findPrev() );
				break;
		case SP_SAVE :
				jump_slot = SLOT( fileMenuSave() );
				break;
		case SP_NAMESAVE :
				jump_slot = SLOT( fileMenuSaveAs() );
				break;

		// --------------------------------------- v3.4.0
		case SP_CONVERT :
				jump_slot = SLOT( convertWordProc() );
				break;
		default :
				return;
	}
	if ( which )
		sp_acc->connectItem( sp_acc->insertItem( key_code ), this, jump_slot );
	else
		sp_acc->disconnectItem( sp_acc->insertItem( key_code ), this, jump_slot );
}

void TextEdit::inputHalfSpace()
{
	editor->insert( " " );
}

// --------------------------------------------------- v3.4.0 convert word
void TextEdit::convertWordProc()
{
	int	xx = width() / 2 - 50;
	int	yy = height() / 2 - 20;
//	popConvert->exec( QCursor::pos() );		// pop up menu
	QPoint	cur( xx, yy );
	popConvert->exec( cur );		// pop up menu
}

void TextEdit::convertAscii2Zen()
{
	editor->convertAsciiZen( true );
	editor->update();
	editor->setFocus();
}

void TextEdit::convertZen2Ascii()
{
	editor->convertAsciiZen( false );
	editor->update();
	editor->setFocus();
}

// **********************************************************
// option
// **********************************************************
void TextEdit::optionProc()
{
	// ----------------------------------- option dialog
	OptionDialog optDialog( this, "", true, 0 );

	optDialog.setShortCutKey( shortcutkey );
	optDialog.setBackgroundColor( backcolor );
	optDialog.setTextColor( textcolor );
	optDialog.setCursorLine( cursor_draw );
	optDialog.setCursorLineColor( cursor_line_color );
	optDialog.setCursorColor( cursor_color );
	optDialog.setCursorStyle( cursor_style );
	optDialog.setLineNumber( line_number, line_number_cr );
	optDialog.setCRMarkDisp( cr_markdisp );
	optDialog.setSelectedColor( selected_color );
	optDialog.setVerticalLine( vertical_line );
	optDialog.setScrollBarDisp( scrollbar_disp );
	optDialog.setFontName( family_name );

	// ----------------------------------- get option data
	if ( optDialog.exec() == QDialog::Accepted )
	{
		int	wk;
		bool	change_flg = false;
		bool	backcolor_change = false;

		wk = optDialog.getShortCutKey();
		if ( shortcutkey != wk )
		{
			shortcutkey = wk;
			setShortCutKey( wk );
		}

		wk = optDialog.getBackgroundColor();
		if ( backcolor != wk )
		{
			backcolor = wk;
			setBackColor( backcolor );
			backcolor_change = true;
		}

		wk = optDialog.getCursorLine();
		if ( cursor_draw != wk )
		{
			cursor_draw = wk;
			setCursorLine( wk );
		}

		wk = optDialog.getLineNumber();
		bool	wk2 = optDialog.getLineNumberCr();
		if ( line_number != wk )
		{
			editor->setLineNumber( wk, wk2 );
			if (( line_number >= LINE_NUMBER_FRONT2 ) || ( wk >= LINE_NUMBER_FRONT2 ))
			{
				if ( word_wrap )
				{
					setWordWrap( word_wrap );
				}
			}
			line_number = wk;
			updateCaption();
			change_flg = true;
		}
		if ( line_number_cr != wk2 )
		{
			editor->setLineNumber( wk, wk2 );
			line_number_cr = wk2;
			updateCaption();
			change_flg = true;
		}

		wk = optDialog.getCRMarkDisp();
		if ( cr_markdisp != wk )
		{
			cr_markdisp = wk;
			change_flg = true;
			editor->setCRMarkDisp( cr_markdisp );
		}

		wk = optDialog.getTextColor();
		if (( textcolor != wk ) || ( backcolor_change ))
		{
			textcolor = wk;
			// ------------------------------- check background color
			if (( backcolor == 0 ) && ( textcolor == 4 ))	// back:white, text:white
				textcolor = 0;
			if (( backcolor == 7 ) && ( textcolor == 0 ))	// back:black
				textcolor = 4;
			// ------------------------------- text color
			setTextColor( textcolor );
			change_flg = true;
		}
		wk = optDialog.getCursorLineColor();
		if ( cursor_line_color != wk )
		{
			cursor_line_color = wk;
			// ------------------------------- check background color
			if (( backcolor == 0 ) && ( cursor_line_color == 8 ))	// back:white, cursor:white
				cursor_line_color = 7;
			if (( backcolor == 7 )  && ( cursor_line_color == 7 ))	// back:black
				cursor_line_color = 8;
			editor->setCursorLineColor( cursor_line_color );
			change_flg = true;
		}
		wk = optDialog.getCursorColor();
		if ( cursor_color != wk )
		{
			cursor_color = wk;
			// ------------------------------- check background color
			if (( backcolor == 0 ) && ( cursor_color == 7 ))	// back:white, cursor:white
				cursor_color = 0;
			if (( backcolor == 7 ) && ( cursor_color == 6 ))	// back:black
				cursor_color = 7;
			editor->setCursorColor( cursor_color );
			change_flg = true;
		}
		wk = optDialog.getCursorWidth();
		if ( cursor_style != wk )
		{
			cursor_style = wk;
			editor->setCursorStyle( cursor_style );
			change_flg = true;
		}
		wk = optDialog.getSelectedColor();
		if ( selected_color != wk )
		{
			selected_color = wk;
			editor->setSelectedColor( selected_color );
			change_flg = true;
		}
		wk = optDialog.getVerticalLine();
		if ( vertical_line != wk )
		{
			vertical_line = wk;
			editor->setVerticalLine( vertical_line );
			change_flg = true;
		}
		wk = optDialog.getScrollBarDisp();
		if ( scrollbar_disp != wk )
		{
			scrollbar_disp = wk;
			editor->setScrollBarDisp( scrollbar_disp );
			change_flg = true;
		}
		QString	wk_str = optDialog.getFontName();
		if ( family_name != wk_str )
		{
			family_name = wk_str;
			QFont	font( family_name );
			editor->setFont( font );

			int	p_size = editor->font().pointSize();
			font.setPointSize( p_size );
			searchComboEdit->setFont( font );				//	v3.5.3

			// ------------------- v3.2.3 bug fix
			if ( line_number >= LINE_NUMBER_FRONT2 )
				editor->setLineNumber( line_number, line_number_cr );

			change_flg = true;
		}

		writeConf();
		if ( change_flg )
			editor->update();
	}
}


// **********************************************************
// option2
// **********************************************************
void TextEdit::optionProc2()
{
	// ----------------------------------- option dialog
	OptionDialog2 optDialog( this, "", true, 0 );

	optDialog.setMoveCursor( movecursor );
//	optDialog.setSelectedCursor( selectedcursor );
	optDialog.setAppendCRCode( cr_code );
	optDialog.setCaseSensitive( c_sensitive );
	optDialog.setIncrementalSearch( incremental_s );
	optDialog.setWordWrap( wrap_method );
	optDialog.setTabLength( tablength );
	optDialog.setInputCodec( input_codec );
	optDialog.setOutputCodec( output_codec );
	optDialog.setCursorWord( cursorword );
	optDialog.setDateForm( windateform );

	// ----------------------------------- get option data
	if ( optDialog.exec() == QDialog::Accepted )
	{
		bool	change_flg = false;

		movecursor       = optDialog.getMoveCursor();
//		selectedcursor   = optDialog.getSelectedCursor();
		cr_code          = optDialog.getAppendCRCode();
		c_sensitive      = optDialog.getCaseSensitive();
		cursorword       = optDialog.getCursorWord();
		windateform      = optDialog.getDateForm();

		incremental_s    = optDialog.getIncrementalSearch();
		int	wk           = optDialog.getWordWrap();
		if ( wrap_method != wk )
		{
			wrap_method = wk;
			if ( word_wrap )
				setWordWrap( word_wrap );
		}
		if ( incremental_s )
			connect( searchComboEdit, SIGNAL( textChanged( const QString & ) ), this, SLOT( search() ) );
		else
			disconnect( searchComboEdit, SIGNAL( textChanged( const QString & ) ), this, SLOT( search() ) );

		int len = optDialog.getTabLength();
		if ( tablength != len )
		{
			tablength = len;
			editor->setDefaultTabStop( tablength );
			change_flg = true;
		}

		int cdc1 = optDialog.getInputCodec();
		if ( input_codec != cdc1 )
		{
			input_codec = cdc1;
			updateCaption();
		}
		int	cdc2 = optDialog.getOutputCodec();
		if (( input_codec > CODEC_AUTO ) && ( cdc2 == CODEC_AUTO ))
			cdc2 = input_codec;
		if ( output_codec != cdc2 )
		{
			output_codec = cdc2;
			updateCaption();
		}

		writeConf();
		if ( change_flg )
			editor->update();
	}
}

// **********************************************************
// option3
// **********************************************************
void TextEdit::optionProc3()
{
	// ----------------------------------- option dialog
	OptionDialog3 optDialog( this, "", true, 0 );

	optDialog.setWhichRegExpress( user[0].RegExpress );

	optDialog.setTextCharDispColor( user[0].half_color );
	optDialog.setTextReservedWord( user[0].Word1 );
	optDialog.setTextReservedWord2( user[0].Word2 );
	optDialog.setTextReservedWord3( user[0].Word3 );
	optDialog.setTextReservedColor( user[0].Color1 );
	optDialog.setTextReservedColor2( user[0].Color2 );
	optDialog.setTextReservedColor3( user[0].Color3 );
	optDialog.setTextCommentWord( user[0].Comment );
	optDialog.setTextCommentColor( user[0].CommentColor );

	for( int i= 1 ; i < FILE_ETC ; i++ )
    {
		optDialog.setUserReserved( i, user[i] );
    }
	optDialog.setUserReservedShow( FileType );


	// ----------------------------------- get option data
	if ( optDialog.exec() == QDialog::Accepted )
	{
		bool	change_flg = false;

		// ----------------------------------------------------------------
		// Text & user
		// ----------------------------------------------------------------
		UserFileInfo	wk_user;
		int				i;

		for( i= 0 ; i < FILE_ETC ; i++ )
        {

			if ( i == FILE_TEXT )
			{
				wk_user = optDialog.getTextInfo();
				if ( user[i].RegExpress != wk_user.RegExpress )
				{
					user[i].RegExpress = wk_user.RegExpress;
					change_flg = true;
				}

				if ( user[i].half_color != wk_user.half_color )
				{
					// ------------------------------- char color
					user[i].half_color = wk_user.half_color;
					change_flg = true;
				}
			}
			else	// FILE_USER9
			{
				wk_user = optDialog.getUserInfo( i );

				if ( user[i].Ext != wk_user.Ext )
				{
					// ------------------------------- reserved word
					user[i].Ext = wk_user.Ext;
					extUserlist[i].clear();
					extUserlist[i] = QStringList::split( " ", user[i].Ext );

					change_flg = true;
				}
			}

			if ( user[i].Color1 != wk_user.Color1 )
			{
				// ------------------------------- user1 word color
				user[i].Color1 = wk_user.Color1;
				change_flg = true;
			}

			if ( user[i].Color2 != wk_user.Color2 )
			{
				// ------------------------------- user1 word color
				user[i].Color2 = wk_user.Color2;
				change_flg = true;
			}

			if ( user[i].Color3 != wk_user.Color3 )
			{
				// ------------------------------- user1 word color
				user[i].Color3 = wk_user.Color3;
				change_flg = true;
			}

			if ( user[i].Word1 != wk_user.Word1 )
			{
				// ------------------------------- reserved word
				user[i].Word1 = wk_user.Word1;
				change_flg = true;
			}

			if ( user[i].Word2 != wk_user.Word2 )
			{
				// ------------------------------- reserved word
				user[i].Word2 = wk_user.Word2;
				change_flg = true;
			}

			if ( user[i].Word3 != wk_user.Word3 )
			{
				// ------------------------------- reserved word
				user[i].Word3 = wk_user.Word3;
				change_flg = true;
			}

			if ( user[i].CommentColor != wk_user.CommentColor )
			{
				// ------------------------------- text word color
				user[i].CommentColor = wk_user.CommentColor;
				change_flg = true;
			}

			if ( user[i].Comment != wk_user.Comment )
			{
				// ------------------------------- reserved word
				user[i].Comment = wk_user.Comment;
				change_flg = true;
			}

			editor->setUserFileInfo( i, user[i] );

			user[i] = wk_user;
        }


		writeConf2();
		if ( change_flg )
		{
			setFileType( file_ext );
			editor->update();
		}
	}
}


// **********************************************************
// option4
// **********************************************************
void TextEdit::optionProc4()
{
	// ----------------------------------- option dialog
	OptionDialog4 optDialog( this, "", true, 0 );

	int		i;
	for( i= 0 ; i < 9 ; i++ )
	{
		optDialog.setThisIdiom( i, idiom[i] );
	}

	// ----------------------------------- get option data
	if ( optDialog.exec() == QDialog::Accepted )
	{
		QString	buf;

		for( i= 0 ; i < 9 ; i++ )
		{
			buf = optDialog.getThisIdiom( i );
			if ( idiom[i] != buf )
			{
				idiom[i] = buf;
			}
		}
		writeConf2();
	}
}


// **********************************************************
// option5		v2.2.0
// special key
// **********************************************************
void TextEdit::optionProc5()
{
	// ----------------------------------- option dialog
	OptionDialog5 optDialog( this, "", true, 0 );

	optDialog.setSpecialKey( sp_key );

	// ----------------------------------- get option data
	if ( optDialog.exec() == QDialog::Accepted )
	{
		bool			change_flg = false;
		SpecialKey		wk_sp;

		wk_sp = optDialog.getSpecialKey();
		if ( sp_key.ctrl_enter != wk_sp.ctrl_enter )
			change_flg = true;
		if ( sp_key.ctrl_space != wk_sp.ctrl_space )
			change_flg = true;
		if ( sp_key.shift_enter != wk_sp.shift_enter )
			change_flg = true;
		if ( sp_key.shift_space != wk_sp.shift_space )
			change_flg = true;
		if ( sp_key.fn_N != wk_sp.fn_N )
			change_flg = true;
		if ( sp_key.fn_M != wk_sp.fn_M )
			change_flg = true;
		if ( sp_key.fn_O != wk_sp.fn_O )
			change_flg = true;
		if ( sp_key.fn_P != wk_sp.fn_P )
			change_flg = true;
		if ( sp_key.fn_A != wk_sp.fn_A )
			change_flg = true;
		if ( sp_key.fn_S != wk_sp.fn_S )
			change_flg = true;

		if ( change_flg )
		{
			optionSpecialKey( false );
			sp_key = wk_sp;
			optionSpecialKey( true );
			writeConf();
		}
	}
}





void TextEdit::show_clipboard()
{
	QClipboard *cb = QApplication::clipboard();
	QString text;
	text = cb->text();
	if ( text.length() > 80 )
	{
		text.truncate( 80 );
		text.append( "..." );
	}
	QMessageBox::information( this, "Clipboard", text, QMessageBox::Ok, QMessageBox::Default );
}


void TextEdit::countCharacter()
{
	codec = QTextCodec::codecForName( "eucJP" );
	QString buf;

	buf = editor->getMarkedWord();		// v1.2.4 marked text
	if ( buf.length() == 0 )
		buf = editor->text();

	uint	len = buf.length();
	uint	i, c_count;
	uint	hsp, zsp, tb, hch, zch, cr, etc;

	QString z_spc = codec->toUnicode("");
	QString h_kata1 = codec->toUnicode("");	// half char katakana
	QString h_kata2 = codec->toUnicode("");	// half char katakana
	hsp = zsp = tb = hch = zch = cr = etc = 0;
	// -------------------------------------- v1.1.7 only check UTF-8
	for( i= 0, c_count= 0 ; i < len ; i++ )
	{
		if ( buf[i] <= 0x7f )
		{
			if (( buf[i] > 0x20 ) && ( buf[i] <= 0x7f ))
				hch++;							// half character
			else
				if ( buf[i] == ' ' )
					hsp++;						// half space
				else
					if ( buf[i] == '\t' )		// Tab
						tb++;
					else
						if ( buf[i] == '\n' )	// CR
							cr++;
						else
							etc++;
		}
		else
		{

			if ( buf[i] == z_spc[0] )
				zsp++;
			else
				if (( buf[i] >= h_kata1[0] ) && ( buf[i] <= h_kata2[0] ))
					hch++;							// half character
				else
					zch++;
		}
	}

	QString buf2;
	buf2.sprintf( "ʸȡ\n\nʸ %6d (  %6d )\n        ( Ⱦ %6d )\nڡ %6d (  %6d )\n        ( Ⱦ %6d )\n֡ %6d\nԎĎ %6d\n¾ %6d\n----------------\n٤ơ %6d", zch+hch, zch, hch, zsp+hsp, zsp, hsp, tb, cr, etc, len );
	QMessageBox::information( this, codec->toUnicode("ZEditor ʸ"), codec->toUnicode( buf2 ), QMessageBox::Ok, QMessageBox::Default );
}


void TextEdit::aboutMessage()
{
	QMessageBox::about( this, "ZEditor about", "ZEditor v3.5.4\nCopyright(C) 2003- Satoshi" );
}

// ********************************************************************
// 		>> File <<
// ********************************************************************
void TextEdit::fileNew()
{
	// ---------------------- v1.0.0 : save file if edited
	if ( doc )
	{
		// ---------------------- v1.0.0 : save file ? if edited
		if ( allRight() )
			return;
	}
	// ---------------------------------------  bug fix : set last file v2.2.3
	setLastFile();

	if ( output_codec  == CODEC_AUTO )
		codec_num = CODEC_SJIS;       // v0.9.2 ... save error!!! length()???
	else
		codec_num = output_codec;	// v1.2.3
	// ---------------------- set correct codec
	setDoingCodec();
	newFile( DocLnk() );

	// ---------------------- v2.1.6 : show cursor
	editor->setCursorPosition( 0, 0, false );
}

void TextEdit::fileOpen()
{
	// ---------------------- v1.0.0 : save file ? if edited
	if ( allRight() )
		return;

	// ---------------------- get old doc
	QString old_path;
	if (( doc ) && ( ! doc->file().isEmpty() ))
		old_path = doc->file();
	else
		if ( ! last_file.isNull() )
			old_path = last_file;

	FileDialog fileDialog( this, "", true, 0, DIALOG_OPEN );
	fileDialog.setUserDir( userJumpU, userJumpJ );
	fileDialog.setUserDir2( userJumpMnt, userJumpHome, userJumpText, userJumpUser );
	if ( ! old_path.isNull() )
		if ( ! fileDialog.setList( QFileInfo( old_path ).dirPath() ) )	// v2.2.6
			fileDialog.cd_text();

	if ( fileDialog.exec() == QDialog::Accepted )
		openThisFile( *( fileDialog.getAbsSelectedFileName() ) );
}

// -------------------------------------------- chaeck last List files  v1.1.4
void TextEdit::openThisFile(  const QString &f )
{
	int	i;

	for( i= 0 ; i < MAX_LIST_COUNT ; i++ )
	{
		if ( f == listF.path( i ) )
		{
			openLastFile( i );
			return;
		}
	}
	openFile( f );
	editor->setCursorPosition( 0, 0, false );
}


void TextEdit::openLastFile( int index )
{	// ---------------------- v1.0.0 : save file ? if edited
	if ( allRight() )
		return;

	int		col   = listF.col( index );
	int		line  = listF.line( index );
	int		color = listF.color( index );
	// -------------------------------- change path, col, line !!!
	openFile( listF.path( index ) );

	// --- move last_col, last_line
	if ( movecursor )
	{
		editor->setCursorPosition( line, col, false );
//		if ( selectedcursor )     v1.1.9 delete!!!
//			editor->setSelection( line, col, line, col + 2 );
	}
	// -------------------------------- v1.0.1
	setBackColor( color );
	// -------------------------------- v1.1.5, v1.2.1
	if ( line_number == LINE_NUMBER_TITLE  )
		updateCaption();
}

// -------------------------------------- v0.9.2 append
void TextEdit::fileMenuSave( void )
{
	QString s_file = doc->file();

	if ( editor->edited() )
	{
		if (( s_file.isNull() ) || ( s_file.isEmpty() ))
			fileMenuSaveAs();
		else
			save();
	}
	editor->setFocus();		// v1.0.0
}

// -------------------------------------- 2003.01.19 append
void TextEdit::fileMenuSaveAs( void )
{
//	if ( editor->edited() )
//	̵˥ɽ
	fileSave();
	bFromDocView = false;

	// Show filename in caption
	QString name = QFileInfo( doc->file() ).fileName();
	doc->setName( name );	// bug !!! v2.0.4
	updateCaption( name );
}

// -------------------------------------- v1.3.0
void TextEdit::fileMenuFiler( void )
{
	// ---------------------- get old doc
	QString old_path;
	if (( doc ) && ( ! doc->file().isEmpty() ))
		old_path = doc->file();
	else
		if ( ! last_file.isNull() )
			old_path = last_file;

	FileDialog fileDialog( this, "", true, 0, DIALOG_FILER );
	fileDialog.setUserDir( userJumpU, userJumpJ );
	fileDialog.setUserDir2( userJumpMnt, userJumpHome, userJumpText, userJumpUser );
	if ( ! old_path.isNull() )
		if ( ! fileDialog.setList( QFileInfo( old_path ).dirPath() ))
			fileDialog.cd_text();

	if ( fileDialog.exec() == QDialog::Accepted )
		editor->setFocus();
}


void TextEdit::fileSave()
{
	QString s_file = doc->file();

	// ----------------------------------- save dialog
	FileDialog fileDialog( this, "", true, 0, DIALOG_SAVE, is_small );
	fileDialog.setUserDir( userJumpU, userJumpJ );
	fileDialog.setUserDir2( userJumpMnt, userJumpHome, userJumpText, userJumpUser );
	// ----------------------------------- v0.9.2 new file
	if (( s_file.isNull() ) || ( s_file.isEmpty() ))
	{
		if ( ! last_file.isNull() )
			if ( ! fileDialog.setList( QFileInfo( last_file ).dirPath() ))
				fileDialog.cd_text();
	}
	else
	{
		if ( ! fileDialog.setList( QFileInfo( s_file ).dirPath() ))
			fileDialog.cd_text();
		fileDialog.setName( QFileInfo( s_file ).fileName() );
	}

	// ----------------------------------- get file name from dialog
	if ( fileDialog.exec() == QDialog::Accepted )
	{
		// ------------------------------- check new file name v1.29
		if ( ! new_file )
		{
			if ( *( fileDialog.getAbsSelectedFileName() ) != doc->file() )
			{
				new_file = true;
			}
		}
		doc->setFile( *( fileDialog.getAbsSelectedFileName() ) );	// bug fix!!! v1.2.9a
		save();
	}
}

void TextEdit::setDoingCodec()
{
	// ---------------------- set correct codec
	if ( codec_num > CODEC_UTF8 )
	{
		if (( codec_num == CODEC_ASC_SJIS ) || ( codec_num == CODEC_SJIS ))
			codec = QTextCodec::codecForName( "SJIS" );
		else
			if ( codec_num == CODEC_EUCJP )
				codec = QTextCodec::codecForName( "eucJP" );
			else
				if ( codec_num == CODEC_JIS )
					codec = QTextCodec::codecForName( "JIS7" );
				else
					// -------------------------------------------- v3.2.0
					if ( codec_num == CODEC_EUCKR )
						codec = QTextCodec::codecForName( "eucKR" );
					else
						codec = QTextCodec::codecForName( "GBK" );
	}
}

int  TextEdit::allRight()
{
	QString rt = editor->text();
	if ( editor->edited() )
	{
		if (( new_file ) && ( rt.length() == 0 ))
			return( false );
		codec = QTextCodec::codecForName( "eucJP" );
		// ---------------------- v1.0.0 : save file ? if edited
		int ret = QMessageBox::warning( this, codec->toUnicode("ZEditor ٹ"), codec->toUnicode( "ѹ줿ե̵ˤʤޤ" ), "OK", "Cancel", 0, 1, 1 );
		return( ret );
	}
	return( false );
}

void TextEdit::fileRevert()
{
    clear();
    fileOpen();
}

void TextEdit::setLastFile()
{
	int i, col, line, k;

	// ------------------------------ check file
	if (( ! doc ) || ( doc->file().isEmpty() ))
		return;

	// ------------------------------ search List
	for( i= 0 ; i < MAX_LIST_COUNT ; i++ )
	{
		if ( listF.col( i ) < 0 )
			continue;
		if ( listF.path( i ) == doc->file() )
		{
			// --------------------------- slide data
			for( k= i - 1 ; k >= 0 ; k-- )
			{
				listF.itemSet( k + 1, listF.path( k ), listF.col( k ), listF.line( k ), listF.color( k ) );
			}
			break;
		}
	}
	if ( i == MAX_LIST_COUNT )
	{
		// --------------------------- slide data
		for( i= 5 ; i >= 0 ; i-- )
		{
			listF.itemSet( i + 1, listF.path( i ), listF.col( i ), listF.line( i ), listF.color( i ) );
		}
	}
	editor->getCursorPosition( &line, &col );
	listF.itemSet( 0, doc->file(), col, line, backcolor );

	// -------------------------------- change menu
	for ( i= 0 ; i < MAX_LIST_COUNT ; i++ )		// v2.0.1 remove all --> insert
	{
		popFile->removeItem( i );
	}
	// ---------------------------------------- v3.2.4
	for ( i= 0, k= 0 ; i < MAX_LIST_COUNT ; i++ )
	{
		if (( listF.col( k ) >= 0 ) && ( QFileInfo( listF.path( k ) ).exists() ))
		{
			k++;
			continue;
		}
		listF.clear( k );
		listF.move_last( k );
	}

	QString	m_file;
	for ( i= 0, k= 0 ; i < MAX_LIST_COUNT ; i++ )
	{
		if ( listF.col( i ) < 0 )
			continue;

		m_file = QFileInfo( listF.path( i ) ).fileName();
		m_file.append( tr( "(&" ) );
		m_file.append( tr( menu_num[k] ) );
		m_file.append( tr( ")" ));
		popFile->insertItem( m_file, this , SLOT( openLastFile( int ) ) ,0, k++ );
	}
}

// -------------------------------------- v3.2.0
void TextEdit::fileClearHistory()
{
	// -------------------------------- change menu
	for ( int i= 0 ; i < MAX_LIST_COUNT ; i++ )	
	{
		popFile->removeItem( i );
		listF.clear( i );
	}
}


// -------------------------------------- v3.5.0
void TextEdit::fileReadOnly( bool y )
{
	read_only = y;
//	editor->setReadOnly( y );		// 2005.08.20 can't move cursor !
	editor->setReadOnlyFlg( y );	// v3.5.0 ---> keyPressEvent()
    editor->setFocus();
}

// -------------------------------------- v2.0.3
void TextEdit::timerOn( void )
{
	QString rt = editor->text();
	if ( editor->edited() )
	{
		if (( new_file ) && ( rt.length() == 0 ))
			return;

		// 	if ( doc->name().isEmpty() ) ---> save()  auto file name
		if ( save() )
		{
			// Show filename in caption
			QString name = QFileInfo( doc->file() ).fileName();
			doc->setName( name );	// bug !!! v2.0.7
			updateCaption( name );
		}
	}
}




// ********************************************************************
// 		>> Edit <<
// ********************************************************************

void TextEdit::selectWords()			// v2.0.0 Shift + Space
{
	editor->autoSelectWords();
}

void TextEdit::reSetCursorPosition()	// v1.1.9 beta for Japanese cursor position???
{
	int	yy,xx;
	editor->getCursorPosition( &yy, &xx );
	editor->setCursorPosition( yy, xx );
}

void TextEdit::editCut()
{
	if ( read_only )
		return;

	if ( default_cutcopy )
		editor->defaultLineMark();

	editor->cut();
    editor->setFocus();		// v1.0.0
    reSetCursorPosition();
}

void TextEdit::editCopy()
{
	if ( default_cutcopy )
		editor->defaultLineMark();

	editor->copy();
    editor->setFocus();		// v1.0.0
}

void TextEdit::editPaste()
{
	if ( read_only )
		return;

	// ----------------------- v3.1.0
	if ( searchComboEdit->hasFocus() )
	{
		QClipboard *cb = QApplication::clipboard();
		QString text;
		text = cb->text();
		searchComboEdit->changeItem( text, 0 );
	}
	else
	{
	    editor->paste();
	    editor->setFocus();		// v1.0.0
	    reSetCursorPosition();
	}
}

void TextEdit::editDuplicate()
{
	if ( read_only )
		return;

	editor->lineDuplicate();
	editor->update();
	editor->setEdited( true );
	editor->setFocus();
}

void TextEdit::editRemove()
{
	int line, col;

	if ( read_only )
		return;

	editor->getCursorPosition( &line, &col );
	editor->removeLine( line );
	editor->setCursorPosition( line, col );
	editor->update();
	editor->setEdited( true );
	editor->setFocus();
	reSetCursorPosition();
}

void TextEdit::editSelectAll()
{
	editor->selectAll();
	editor->setFocus();		// v1.0.0
}

// ----------------------------------- v2.0.7
void TextEdit::editSelectTop()
{
	int line, col;
	editor->getCursorPosition( &line, &col );
	editor->setSelection( 0, 0, line, col );
	editor->setFocus();
}

// ----------------------------------- v2.0.7
void TextEdit::editSelectBottom()
{
	editor->setCursorPosition( editor->numLines(), 999, true );
	editor->setFocus();
	if ( line_number == LINE_NUMBER_TITLE  )
		updateCaption();
}

// ----------------------------------- v2.0.7
void TextEdit::editSelectMark()
{
	int line, col;
	editor->getCursorPosition( &line, &col );

	if ( jump_mark->isOn() )
	{
		int		max_line;
		max_line = editor->numLines();
		if ( mk_yy > max_line )			// check max line
			mk_yy = max_line;

		if ( mk_yy > line )
			editor->setCursorPosition( mk_yy, mk_xx, true );
		else
			editor->setSelection( mk_yy, mk_xx, line, col );
		editor->setFocus();
		if ( line_number == LINE_NUMBER_TITLE  )
			updateCaption();
	}
	else
	{
		editor->setFocus();
	}
}

void TextEdit::editFind()
{
	find_backword = false;
	editFindCommon();
}

void TextEdit::editFindPrev()
{
	find_backword = true;
	editFindCommon();
}

void TextEdit::editFindCommon()
{
//	QTextCodec	*codec;
//	codec = QTextCodec::codecForName( "eucJP" );

	if ( ! searchVisible )
	{
		searchBar->show();
		searchVisible = true;
	}

	searchComboEdit->clear();
	if ( cursorword )
	{
//		searchComboEdit->setText( editor->getCursorWord( cursorword ) );
		search_words[0] = editor->getCursorWord( cursorword );
	}
	else
	{
		search_words[0].truncate( 0 );
	}
	searchComboEdit->setInsertionPolicy( QComboBox::AtBottom );
	// ---------------------------- v3.1.0 set combobox
	for( int i= 0 ; i < MAX_SEARCH_COUNT + 1 ; i++ )
		searchComboEdit->insertItem( search_words[i], i );
//		searchComboEdit->insertItem( codec->toUnicode( search_words[i] ), i );
	searchComboEdit->setInsertionPolicy( QComboBox::NoInsertion );

	searchComboEdit->lineEdit()->selectAll();			// v3.5.0
	searchComboEdit->setFocus();
}

void TextEdit::search()
{
	editor->find( searchComboEdit->currentText(), c_sensitive, find_backword );
}


void TextEdit::findNext()
{
	find_backword = false;
	editor->find( searchComboEdit->currentText(), c_sensitive, find_backword );
	editor->setFocus();		// v1.0.0
}

void TextEdit::findPrev()		// v3.0.0
{
	find_backword = true;
	editor->find( searchComboEdit->currentText(), c_sensitive, find_backword );
	editor->setFocus();
}

void TextEdit::findClose()
{
	if ( searchVisible )
	{
		searchVisible = false;
		searchBar->hide();
	}
	editor->setFocus();		// v0.9.2
}

void TextEdit::replaceProc()
{
	int   count;

	if ( read_only )
		return;

	// ----------------------------------- replace dialog
	ReplaceDialog repDialog( this, "", true, 0 );

	if ( cursorword )
	{
		repDialog.setOldStr( editor->getCursorWord( cursorword ) );
	}
	else
	{
		repDialog.setOldStr( old_str );
	}
	repDialog.setNewStr( new_str );

	// ----------------------------------- get old_str, new_str from dialog
	if ( repDialog.exec() == QDialog::Accepted )
	{
		QString	buf;
		count = editor->replace( repDialog.old_str, repDialog.new_str, c_sensitive, repDialog.which_from, repDialog.which_each );
		if ( count > 0 )
		{
			editor->update();
			editor->setEdited( true );
			editor->setUndoEnabled( false );		// v2.0.0 clear undo buffer
			editor->setUndoEnabled( true );
		}
		codec = QTextCodec::codecForName( "eucJP" );
		buf.sprintf( "ִ줿ʸ %d Ǥ", count );
		QMessageBox::information( this, codec->toUnicode("ZEditor ִ"), codec->toUnicode( buf ), QMessageBox::Ok, QMessageBox::Default );
		old_str = repDialog.old_str;
		new_str = repDialog.new_str;
		editor->update();
		editor->setFocus();
	}
}

QString TextEdit::getUserJumpU()
{
	return( userJumpU );
}

// ------------------------- abort !!!  why????   v2.0.8 confirmed
//QString TextEdit::getUserJumpJ()
//{
//	return( userJumpJ );
//}

QString TextEdit::getLine1Text()
{
	return( editor->textLine( 0 ) );
}

QString TextEdit::getDateTime()
{
	QString	buf;
	QString	buf2;
	QTime	tt;
	QDate	dd;

	codec = QTextCodec::codecForName( "eucJP" );
	tt = QTime::currentTime();
	dd = QDate::currentDate();

	switch( windateform )
	{
		case 0 :
		default:
			buf.sprintf( "%04d/%02d/%02d(", dd.year(), dd.month(), dd.day() );
			buf.append( codec->toUnicode( name_week[dd.dayOfWeek()] ));
			buf2.sprintf( ") %02d:%02d:%02d", tt.hour(), tt.minute(), tt.second() );
			buf.append( buf2 );
			break;
		case 1 :
			buf.sprintf( "%04d/%02d/%02d(", dd.year(), dd.month(), dd.day() );
			buf.append( codec->toUnicode( name_week[dd.dayOfWeek()] ));
			buf2.sprintf( ") %02d:%02d", tt.hour(), tt.minute() );
			buf.append( buf2 );
			break;
		case 2 :
			buf.sprintf( "%04d/%02d/%02d(", dd.year(), dd.month(), dd.day() );
			buf.append( codec->toUnicode( name_week[dd.dayOfWeek()] ));
			buf.append( ")" );
			break;
		case 3 :
			buf.sprintf( "%04d/%02d/%02d %02d:%02d:%02d", dd.year(), dd.month(), dd.day(), tt.hour(), tt.minute(), tt.second() );
			break;
		case 4 :
			buf.sprintf( "%04d/%02d/%02d %02d:%02d", dd.year(), dd.month(), dd.day(), tt.hour(), tt.minute() );
			break;
		case 5 :
			buf.sprintf( "%04d/%02d/%02d", dd.year(), dd.month(), dd.day() );
			break;
		case 6 :
			buf.sprintf( "%04d.%02d.%02d %02d:%02d:%02d", dd.year(), dd.month(), dd.day(), tt.hour(), tt.minute(), tt.second() );
			break;
		case 7 :
			buf.sprintf( "%04d.%02d.%02d %02d:%02d", dd.year(), dd.month(), dd.day(), tt.hour(), tt.minute() );
			break;
		case 8 :
			buf.sprintf( "%04d.%02d.%02d", dd.year(), dd.month(), dd.day() );
			break;
		case 9 :
			buf.sprintf( "%02d:%02d:%02d %04d/%02d/%02d",  tt.hour(), tt.minute(), tt.second(), dd.year(), dd.month(), dd.day() );
			break;
		case 10:
			buf.sprintf( "%02d:%02d %04d/%02d/%02d",  tt.hour(), tt.minute(), dd.year(), dd.month(), dd.day() );
			break;
		case 19:
			buf = dd.toString();
			break;
	}
	return( buf );
}

void TextEdit::insertDateTime()
{
	if ( read_only )
		return;

	QString	buf = getDateTime();
	editor->insert( buf );
	editor->setFocus();
}

// ----------------------------------- v2.2.2
void TextEdit::insertFullPath()
{
	QFileInfo finfo( doc->file() );
	editor->insert( finfo.absFilePath() );
	editor->setFocus();
}


void TextEdit::otherProcNum( int other_num )
{
	switch( other_num )
	{
		case 0 :
			undoProc();
			break;
		case 1 :
			redoProc();
			break;
		case 2 :
			idiomListBox();
			break;
	}
}

void TextEdit::undoProc()
{
	editor->undo();
    editor->setFocus();
}

void TextEdit::redoProc()
{
	editor->redo();
    editor->setFocus();
}


void TextEdit::idiomListBox()
{
	IdiomSelectDialog	iselectDialog( this, "", true, 0 );

	int		i;
	for( i= 0 ; i < 9 ; i++ )
	{
		iselectDialog.setThisIdiom( i, idiom[i] );
	}
	iselectDialog.ListBox->setCurrentItem( 0 );

	// ----------------------------------- get option data
	if ( iselectDialog.exec() == QDialog::Accepted )
	{
		int index = iselectDialog.getSelectIdiomNum();		// return selected index
		idiomNumber( index );
	}
}

void TextEdit::idiomNumber1()
{
	idiomNumber( 0 );
}
void TextEdit::idiomNumber2()
{
	idiomNumber( 1 );
}
void TextEdit::idiomNumber3()
{
	idiomNumber( 2 );
}
void TextEdit::idiomNumber4()
{
	idiomNumber( 3 );
}
void TextEdit::idiomNumber5()
{
	idiomNumber( 4 );
}
void TextEdit::idiomNumber6()
{
	idiomNumber( 5 );
}
void TextEdit::idiomNumber7()
{
	idiomNumber( 6 );
}
void TextEdit::idiomNumber8()
{
	idiomNumber( 7 );
}
void TextEdit::idiomNumber9()
{
	idiomNumber( 8 );
}
void TextEdit::idiomNumber( int index )
{
	if ( read_only )
		return;

	QKeyEvent	ke_b( QEvent::KeyPress, Qt::Key_BackSpace, 0, 0 );
	QKeyEvent	ke_e( QEvent::KeyPress, Qt::Key_Enter, 0, 0 );

	bool	esc_flg = false;
	QString str;
	QString c;
	for( int i= 0 ; i < (int)idiom[index].length() ; i++ )
    {
    	// ---------------------------------- \\, \n, \t, \b, \d
    	c = idiom[index].mid( i, 1 );
    	if (( c == "\\" ) && ( ! esc_flg ))
    	{
    		esc_flg = true;
		}
		else
		{
    		if ( esc_flg )
    		{
				if (( c == "b" ) || ( c == "d" ) || ( c == "n" ) || ( c == "t" ))
				{
					if ( str.length() > 0 )
					{
						editor->insert( str );	
						str.truncate( 0 );
					}
					// ----------------------- BackSpace
					if ( c == "b" )
						QApplication::sendEvent( editor, &ke_b );
					// ----------------------- Date & Time
					if ( c == "d" )
						editor->insert( getDateTime() );
					// ----------------------- Enter
					if ( c == "n" )
						QApplication::sendEvent( editor, &ke_e );
					// ----------------------- Tab
					if ( c == "t" )
						editor->insert( "\t" );	
				}
				else	// "\\"
				{
    				str.append( c );
   				}
   				esc_flg = false;
   				continue;
			}
    		str.append( c );
		}
    }
	if ( str.length() > 0 )
		editor->insert( str );	

	editor->setFocus();
}

// ----------------------------------- v3.0.0 Tab indent
void TextEdit::tabIndent()
{
	if ( read_only )
		return;
	if ( ! editor->insertTabIndent() )
		editor->insert( "\t" );			// input Tab key
}

void TextEdit::shiftTabIndent()
{
	if ( read_only )
		return;
	editor->removeTabIndent();
}




// ********************************************************************
void TextEdit::newFile( const DocLnk &f )
{
    DocLnk nf = f;
    nf.setType( "text/plain" );
    nf.setFile( "" );
    clear();
    editorStack->raiseWidget( editor );
    setWState( WState_Reserved1 );
    editor->setFocus();
    doc = new DocLnk( nf );
    new_file = true;
	FileType = FILE_TEXT;
    jump_mark->setOn( false );	// mark jump
	editor->setJumpMark( -1, -1 );
    updateCaption();

	setUpdateCellWidth();
}


// ********************************************************************
void TextEdit::openFile( const QString &f )
{
    bFromDocView = true;
    DocLnk nf;

    nf.setType( "text/plain" );
    nf.setFile( f );
    openFile( nf );
    showEditTools();
    // Show filename in caption
    QString name = f;
    int sep = name.findRev( '/' );
    if ( sep > 0 )
		name = name.mid( sep+1 );
	new_file = false;
	doc->setName( name );
    updateCaption( name );
}

void TextEdit::setFileType( QString ext )
{
	FileType = FILE_ETC;
	if ( ext.upper() == "TXT" )
	{
		FileType = FILE_TEXT;
		editor->setUserFileInfo( FILE_TEXT, user[FileType] );
	}
	else
	{
		for( int i= 1 ; i < FILE_ETC ; i++ )
        {
			for ( QStringList::Iterator it = extUserlist[i].begin(); it != extUserlist[i].end(); ++it )
			{
				if ( ext == *it )
				{
					FileType = i;
					break;
				}
			}
			if ( FileType != FILE_ETC )
				break;
        }
		editor->setUserFileInfo( FileType, user[FileType] );
	}
}

void TextEdit::openFile( const DocLnk &f )
{
	// --------------------------------------- set last file v1.0.0
	setLastFile();

	clear();
	FileManager	fm;
	QString		txt;

	// --------------------------------------- get file size
	QFileInfo finfo( f.file() );
	fsize = finfo.size();			// v0.9.2 bug fix
	QByteArray buf = QByteArray( fsize );	// 2003.01.18 for codec

	if ( ! fm.loadFile( f, buf ) )
	{
		QMessageBox::information( this, "Open error", "fm.loadFile : This file dose not exist?", QMessageBox::Ok, QMessageBox::Default );
		new_file = true;
	}

	fileNew();
	if ( doc )
		delete doc;
	doc = new DocLnk(f);

	// ------------------------------------------- v1.2.5 check extension
	file_ext = finfo.extension( false );
	setFileType( file_ext );

	// ------------------------------------------- 2003.07.13 check input codec
	if ( input_codec == CODEC_AUTO )
	{
		if (( finfo.extension( false ) == "conf" )		// v1.3.0
		 || ( finfo.extension( false ) == "desktop" )	// v1.1.1
		 || ( finfo.extension( false ) == "control" )	// v1.1.1
		 || ( finfo.fileName().left(2) == "rc" ))
		{
			codec_num = CODEC_UTF8;
		}
		else
		{
			if ( fsize > 2 )
			{
				codec_num = checkCodec( buf );		// check codec

				if ( finfo.fileName().left(1) == "."  )		// v1.3.0
				{
					if ( codec_num == CODEC_ASC_SJIS )			// ascii code v1.3.0
						codec_num = CODEC_UTF8;
				}
			}
			else	// fsize <= 2
			{
				codec_num = CODEC_SJIS;
//				codec_num = CODEC_UTF8;		modified v0.9.2
			}
		}
	}
	else
	{
		codec_num = input_codec;
	}



	//-------------------------------------------- 2003.01.18 codec from "SJIS", "eucJP"
	if ( codec_num > CODEC_UTF8 )
	{
		// ---------------------- set correct codec
		setDoingCodec();
//		txt = codec->toUnicode( buf, fsize );     // read twice for stream codec

		QFile		inputfile( f.file() );
		if( inputfile.open( IO_ReadOnly ))
		{
			QTextStream stream( &inputfile );
			inputfile.flush();
			stream.setCodec( codec );
			txt = stream.read();
			inputfile.close();
		}
		// ----------------------- v2.2.2 convert CR --> LF : Macintosh
		if ( mac_flg )
		{
			for( int i= 0 ; i < (int)txt.length() ; i++ )
			{
				if ( txt[i] == 0x0d )
					txt[i] = 0x0a;
			}
		}
	}
	else
	{
		fm.loadFile( f, txt );
	}

    editor->setText( txt );
    editor->setEdited( false );
    jump_mark->setOn( false );	// mark jump
	editor->setJumpMark( -1, -1 );
	setUpdateCellWidth();
}

void TextEdit::showEditTools()
{
    if ( !doc )
		close();
    menu->show();
    editBar->show();
    if ( searchVisible )
		searchBar->show();
    updateCaption();
}



// **************************************************************************************
// qcop message
// **************************************************************************************

void TextEdit::qcop_receive( const QCString& msg, const QByteArray& data )
{
	QDataStream stream( data, IO_ReadOnly );
	if ( msg == "JumpTo(int)" )
	{
		int		line;
		stream >> line;

		jump_to( line );
/*---
		if ( line < 0 )
			line = editor->numLines();
		if ( word_wrap )
		{
			line = editor->Line2WrapLineNumber( line );
			if ( line < 0 )
				line = editor->numLines();
		}
		editor->setCursorPosition( line, 0, false );
---*/
	}
}

void TextEdit::setDocument(const QString& fileref)
{
	// ------------------------------- v2.1.2 bug fix
	if ( allRight() )
		return;

	bFromDocView = true;
	QFileInfo	f_info( fileref );
	openThisFile( f_info.absFilePath() );

//    openThisFile( fileref );		// v2.0.9a bug fix
	showEditTools();
}


// **************************************************************************************
bool TextEdit::save()
{
    // case of nothing to save...
	if ( ! doc )
		return true;

	QString rt;
	rt = editor->text();

	if ( doc->name().isEmpty() )
	{
		QString pt = rt.simplifyWhiteSpace();
		int i = pt.find( ' ' );
		QString docname = pt;
		if ( i > 0 )
			docname = pt.left( i );
		// remove "." at the beginning
		while( docname.startsWith( "." ) )
			docname = docname.mid( 1 );
		docname.replace( QRegExp("/"), "_" );
		// cut the length. filenames longer than that don't make sense and something goes wrong when they get too long.
		if ( docname.length() > 40 )
			docname = docname.left(40);
		if ( docname.isEmpty() )
			docname = "NoTitle";
//		doc->setName( docname );	bug !!! v2.0.4
//		doc->setFile( "/home/zaurus/Documents/Text_Files/" + docname );	// bug
		if ( doc->file().isEmpty() )
			doc->setFile( autosave_dir + docname );
		else
			doc->setName( docname );	// bug !!! v2.0.4
    }

	QFile outfile( doc->file() );
	// ----------------------------------------- v1.2.7a check file exist
	if ( new_file )
	{
		if ( outfile.exists() )
		{
			codec = QTextCodec::codecForName( "eucJP" );
			// ---------------------- v1.0.0 : save file ? if edited
			int ret = QMessageBox::warning( this, codec->toUnicode("ZEditor ٹ"), codec->toUnicode( "ե¸ߤޤ\n񤭤ޤ" ), "OK", "Cancel", 0, 1, 1 );
			if ( ret )
				return true;
		}
	}


	// ------------------------------------------- check extension
	QFileInfo finfo( doc->file() );
	file_ext = finfo.extension( false );
	setFileType( file_ext );


	// ----------------------------------------- v1.2.3 check output codec
	if ( output_codec > CODEC_AUTO )
		codec_num = output_codec;


	// ----------------------------------------- from unicode to SJIS, EUC
	if ( codec_num > CODEC_UTF8 )
	{
		// ---------------------- set correct codec
		setDoingCodec();

		// --------------------------------- 2003.01.22 instead of "fm.saveFile()"
//		QFile outfile( doc->file() );
		if ( ! outfile.open( IO_WriteOnly ))
		{
			QMessageBox::critical( this, "Write Error!!!", "outfile.open( IO_WriteOnly ) : Please investigate the file...", QMessageBox::Ok, QMessageBox::Default );
			return false;
		}
		QTextStream  stream( &outfile );

		unsigned int		write_size;
		// ---------------------------------------- change CR code to LF,CR  v1.1.0
		//		v2.2.2 Macintosh : LF --> CR
		//		Macintosh & Windows : Shift-JIS
		//		cr_code : CR_WIN or CR_MAC
		if ( (( cr_code ) || ( mac_flg ))
		 &&  (( codec_num == CODEC_ASC_SJIS ) || ( codec_num == CODEC_SJIS ))  )
		{
			QCString	buf2 = QCString( rt.length() + 1 );		// bug fix +1	v2.1.2
			buf2 = codec->fromUnicode( rt );	// to ShiftJIS
			uint	len = buf2.length();

			QCString	buf = QCString( len * 2 + 1 );			// bug fix +1	v2.1.2
			// ------------------------------------------ change LF code to CR,LF  v1.1.0a
			// instead of "find & insert" ( insert is very slow )
			uint		i, k;
			for ( i= 0, k= 0 ; i < len ; i++ )
			{
				if ( buf2[i] == 0x0a )	// LF
				{
					// when Macintosh
					if (( cr_code == CR_MAC ) || ( mac_flg ))
					{
						buf[k++] = 0x0d;		// LF( 0x0a ) ---> CR( 0x0d )
					}
					else	// when Windows/DOS
					{
						buf[k++] = 0x0d;		// insert CR( 0x0d )
						buf[k++] = buf2[i];
					}
				}
				else
				{
					buf[k++] = buf2[i];
				}
			}
			buf[k++] = '\0';
			buf.resize( k );		// including the '\0'-terminator!!!
			write_size = buf.length();
			stream.writeRawBytes( buf, write_size );
		}
		else
		{
			QCString	buf = QCString( rt.length() );
			buf = codec->fromUnicode( rt );
			write_size = buf.length();
			stream.writeRawBytes( buf, write_size );
		}
//		stream.setCodec( codec );				// too slow !!!
//		stream << rt;						// too slow !!!
		outfile.close();
		// --------------------------------- v3.2.0 bug fix : check write error
		QFileInfo fi = QFileInfo( outfile );
		if ( fi.size() != write_size )
		{
			QMessageBox::critical( this, "Write Error!!!", "stream.writeRawBytes : Please investigate the file...", QMessageBox::Ok, QMessageBox::Default );
			return false;
		}

/*-----
		if ( ! fm.saveFile( *doc, buf ) )	// 2003.01.19 append last NULL???  !!! can't use !!!
			return false;
---*/
	}
	else  // ------------------------------------ unicode UTF-8
	{
		if ( save_fast )
		{
			// ------- permission changed !!! v1.3.6 ---> save fast v2.1.7
			FileManager		fm;	
			if ( ! fm.saveFile( *doc, rt ) )
			{
				QMessageBox::critical( this, "Write Error!!!", "fm.saveFile : Please investigate the file...", QMessageBox::Ok, QMessageBox::Default );
				return false;
			}
		}
		else
		{
			// ----------------------------------- save slow!!!
			if ( ! outfile.open( IO_WriteOnly ))
			{
				QMessageBox::critical( this, "Write Error!!!", "outfile.open( IO_WriteOnly ) : Please investigate the file...", QMessageBox::Ok, QMessageBox::Default );
				return false;
			}
			QTextStream  stream( &outfile );
			codec = QTextCodec::codecForName( "utf8" );
			stream.setCodec( codec );				// too slow !!! v1.3.6 
			stream << rt;							// too slow !!!
			outfile.close();
			// --------------------------------- v3.2.0 bug fix : check write error
			QFileInfo fi = QFileInfo( outfile );
			uint		i, k;
			for ( i= 0, k= 0 ; i < rt.length() ; i++ )	// v3.2.2 bug fix : UTF-8 JP-character count
			{
				if ( rt[i] > 0xff )
					k++;
			}
			if ( fi.size() < rt.length() + k*2 )
			{
				QMessageBox::critical( this, "Write Error!!!", "stream : Please investigate the file...", QMessageBox::Ok, QMessageBox::Default );
				return false;
			}
		}
	}
//	delete doc;     2003.01.22 continue!!!
//	doc = 0;
	editor->setEdited( false );
	new_file = false;
	return true;
}

void TextEdit::clear()
{
	delete doc;
	doc = 0;
	editor->clear();
}

void TextEdit::updateCaption( const QString &name )
{
//	QString  ttl = tr("ZEditor");
	QString  codec_name;

	if (( input_codec == CODEC_AUTO ) && ( output_codec == CODEC_AUTO ))
	{
		switch( codec_num )
		{
			case CODEC_UNICODE :
				codec_name = tr("(unicode file)");
				break;
			case CODEC_UTF8 :
				codec_name = tr("(UTF-8 file)");
				break;
			case CODEC_ASC_SJIS :
			case CODEC_SJIS :
				codec_name = tr("(ShiftJIS file)");
				break;
			case CODEC_EUCJP :
				codec_name = tr("(EUC-JP file)");
				break;
			case CODEC_JIS :
				codec_name = tr("(JIS file)");
				break;
			case CODEC_EUCKR :
				codec_name = tr("(EUC-KR file)");
				break;
			case CODEC_GBK :
				codec_name = tr("(GB2312-80 file)");
				break;

			default :
				codec_name = tr("(???? file)");
				break;
		}
	}
	else
	{
		switch( input_codec )
		{
			case CODEC_AUTO :
				codec_name = tr("(Auto ->");
				break;
			case CODEC_UTF8 :
				codec_name = tr("(UTF-8 ->");
				break;
			case CODEC_ASC_SJIS :
			case CODEC_SJIS :
				codec_name = tr("(ShiftJIS ->");
				break;
			case CODEC_EUCJP :
				codec_name = tr("(EUC-JP ->");
				break;
			case CODEC_JIS :
				codec_name = tr("(JIS file ->");
				break;
			case CODEC_EUCKR :
				codec_name = tr("(EUC-KR ->");
				break;
			case CODEC_GBK :
				codec_name = tr("(GB2312-80 ->");
				break;

			default :
				codec_name = tr("(???? ->");
				break;
		}
		switch( output_codec )
		{
			case CODEC_UTF8 :
				codec_name.append( tr("UTF-8)"));
				break;
			case CODEC_ASC_SJIS :
			case CODEC_SJIS :
				codec_name.append( tr("ShiftJIS)"));
				break;
			case CODEC_EUCJP :
				codec_name.append( tr("EUC-JP)"));
				break;
			case CODEC_JIS :
				codec_name.append( tr("JIS file)"));
				break;
			case CODEC_EUCKR :
				codec_name.append( tr("EUC-KR)"));
				break;
			case CODEC_GBK :
				codec_name.append( tr("GB2312-80)"));
				break;

			default :
				codec_name.append( tr("????)"));
				break;
		}
	}

	QString s = name;
	if ( ! doc )
	{
	 	s = tr( "Unnamed" );
	}
	else
	{
		if ( s.isNull() )
			s = doc->name();
		if ( s.isEmpty() )
	 		s = tr( "Unnamed" );
	}
	// ----------------------------------- v1.1.5, v1.2.1
	QString num = "";
	if ( line_number == LINE_NUMBER_TITLE  )
	{
		int	wk_line, col, show_line, last_line;
		editor->getCursorPosition( &wk_line, &col );
		// ------------------------------- v2.3.1
		if ( line_number_cr )
		{
			show_line = editor->Row2CRLineNumber( wk_line );
			last_line = editor->Row2CRLineNumber( editor->numLines() - 1 ) + 1;
		}
		else
		{
			show_line = wk_line;
			last_line = editor->numLines();
		}
		num.sprintf( "%d ( %d )", show_line + 1, last_line );
	}
	setCaption( num + s + codec_name + " - " + arg0_baseName );
}


void TextEdit::closeEvent( QCloseEvent *e )
{
	// ---------------------- v1.2.2b : [Cancel] if find-field is visible
	if ( searchVisible )
	{
		findClose();
		return;
	}
	// ---------------------- v1.0.0 : save file ? if edited
	if ( allRight() )
		return;

	// ---------------------- v2.0.6
	setLastFile();
//	writeConf();
	bFromDocView = false;
	e->accept();
}

void TextEdit::accept()
{
	// ---------------------- v1.2.2b : [OK] if find-field is visible
	if ( searchVisible )
	{
		if ( find_backword )
			findPrev();
		else
			findNext();
		// --------------------------------- v3.1.1 set search history
		if ( searchComboEdit->currentText().length() > 0 )
		{
			// ----------------------------- v3.1.0 set search history
			int		i;
			int		index = MAX_SEARCH_COUNT;
			// ----------------------------- check same words
			for( i= 1 ; i <= MAX_SEARCH_COUNT ; i++ )
			{
				if ( searchComboEdit->currentText() == search_words[i] )
					index = i;
			}
			// index == i : exist same words!
			// index == MAX_SEARCH_COUNT : replace all history
			for( i= index ; i > 1 ; i-- )
			{
				search_words[i] = search_words[i-1];
			}
			search_words[1] = searchComboEdit->currentText();
			// ------------------------------ set new words
			for( i= 1 ; i <= MAX_SEARCH_COUNT ; i++ )
				searchComboEdit->changeItem( search_words[i], i );
			searchComboEdit->setCurrentItem( 1 );
		}
		return;
	}
	// ---------------------- v2.0.4 : [OK] if viewstyle
	if ( ok_is_enter )
	{
		QKeyEvent	ke_e( QEvent::KeyPress, Qt::Key_Enter, 0, 0 );
		QApplication::sendEvent( editor, &ke_e );
		return;
	}
//    fileSave();
	fileMenuSave();   // v1.0.1 only save
//	writeConf();
	close();
}

// -------------------------------------- 2003.01.20 append
uint TextEdit::checkCodec( const char *buf )
{
	uint		i;
	uint		c_count;
	uint		asc_count;		// v0.9.2
	uint		jis_flg;
	uint		cr_count = 0;		// 0x0d		v2.2.2
	uint		lf_count = 0;		// 0x0a		v2.2.2

	if (( buf[0] == 0xff ) && ( buf[1] == 0xfe ))
		return( CODEC_UNICODE );

	// ---------------------------------- check UTF-8
	for( i= 0, c_count= 0, asc_count= 0, jis_flg= 0 ; i < fsize ; i++ )
	{
		// ---------------------- CR,LF count v2.2.2	for ascii Shift-JIS
		if ( buf[i] == 0x0a )
			lf_count++;
		if ( buf[i] == 0x0d )
			cr_count++;

		if ( c_count > 0 )
		{
			if (( buf[i] < 0x80 ) || ( buf[i] > 0xbf ))
				break;
			c_count--;
		}
		else	// c_count == 0
		{
			if (( buf[i] > 0x1b ) && ( buf[i] <= 0x7f ))
				asc_count++;

			if ( buf[i] == 0x1b )
				jis_flg++;

//			if (( buf[i] >= 0x00 ) && ( buf[i] <= 0x7f ))	// warning!
			if ( buf[i] <= 0x7f )
			{
				c_count = 0;
			}
			else
			{
				if (( buf[i] >= 0xc0 ) && ( buf[i] <= 0xdf ))
					c_count = 1;
				else
					if (( buf[i] >= 0xe0 ) && ( buf[i] <= 0xef ))
						c_count = 2;
					else
						break;
			}
		}
	}

	if (( i >= fsize ) && ( ! jis_flg ))
	{
		// ------------------------------ v2.2.2 check Macintosh CR code
		if (( cr_count > 0 ) && ( lf_count == 0 ))
			mac_flg = true;
		else
			mac_flg = false;

		if ( asc_count == fsize )
			return( CODEC_ASC_SJIS );		// default codec v0.9.2
		else
			return( CODEC_UTF8 );
	}

	lf_count = cr_count = 0;
	// ---------------------------------- check JIS( iso-2022-jp )
	for( i= 0, c_count= 0 ; i < fsize ; i++ )
	{
		// ---------------------- CR,LF count v2.2.2	v2.2.4 update
		if ( buf[i] == 0x0a )
			lf_count++;
		if ( buf[i] == 0x0d )
			cr_count++;

		// ------------------------------ v1.3.0b
		if ( c_count == 0 )
		{
			if ( buf[i] == 0x1b )
				c_count = 3;
		}
		else
		{
			if ( c_count == 3 )
			{
				if ( buf[i] == 0x24 )
					c_count = 2;
				else
					if ( buf[i] == 0x28 )
						c_count = 1;
					else
						c_count = 0;
			}
			else
			{
				if ( c_count == 2 )
				{
					if (( buf[i] == 0x40 ) || ( buf[i] == 0x42 ))
						return( CODEC_JIS );
				}
				else
				{
					if ( c_count == 1 )
					{
						if (( buf[i] == 0x42 ) || ( buf[i] == 0x49 ) || ( buf[i] == 0x4a ))
							return( CODEC_JIS );
					}
				}
				c_count = 0;
			}
		}
	}

	// ---------------------------------- v2.2.4 check Macintosh CR code
	if (( cr_count > 0 ) && ( lf_count == 0 ))
		mac_flg = true;
	else
		mac_flg = false;

	// ---------------------------------- check ShiftJIS
	for( i= 0, c_count= 0 ; i < fsize ; i++ )
	{
		if (( (unsigned char)buf[i] >= 0x81 ) && ( (unsigned char)buf[i] <= 0x9f )
		 && ( buf[i] != 0x8e ) && ( buf[i] != 0x9f ))
			return( CODEC_SJIS );
	}
	return( CODEC_EUCJP );
}
